function [final_degree,final_c,final_S,final_D,final_C]=BCT_MIBCA(matrix,ctx_labels,sel_label,type,thres)
%Developed by A. Santos Ribeiro
%%%%

index_matrix=any(matrix);
matrix2=matrix(index_matrix,index_matrix);
final_c=zeros(size(matrix,1),1);
final_degree=zeros(size(matrix,1),1);

if type==0
    M_bin_u=matrix2>thres;
    deg_M_bin_u=degrees_und(M_bin_u);
    c_bin_u = clustering_coef_bu(M_bin_u);
    d_bin_u = distance_bin(M_bin_u);
    
    stop_cond=any(isinf(c_bin_u(:))) || any(isinf(d_bin_u(:)));
    C_bin_u = sum(sum(c_bin_u(c_bin_u(:)~=Inf)))/length(nonzeros(c_bin_u(:)~=Inf));
    D_bin_u = sum(sum(d_bin_u(d_bin_u(:)~=Inf)))/length(nonzeros(d_bin_u(:)~=Inf));
    
    %%random matrix
    for i=1:10
        while true
            temp_m=triu(ones(size(matrix2))).*(~eye(size(matrix2)));
            i_m=find(temp_m(:)>0);
            p = randperm(length(i_m));
            rand_i_m=i_m(p);
            rand_m=zeros(size(matrix2));
            rand_m(i_m)=matrix2(rand_i_m);
            rand_m=rand_m+rand_m';
            
            rand_matrix(:,:,i)=rand_m;
            M_bin_u_rand(:,:,i)=rand_matrix(:,:,i)>thres;
            deg_M_bin_u_rand(:,:,i)=degrees_und(M_bin_u_rand(:,:,i));
            c_bin_u_rand(:,:,i) = clustering_coef_bu(M_bin_u_rand(:,:,i));
            d_bin_u_rand(:,:,i) = distance_bin(M_bin_u_rand(:,:,i));
            
            temp_c_bin_u_rand=c_bin_u_rand(:,:,i);
            temp_d_bin_u_rand=d_bin_u_rand(:,:,i);
            C_bin_u_rand(i)=mean(temp_c_bin_u_rand(:));
            D_bin_u_rand(i)=mean(temp_d_bin_u_rand(:));
            
            if (all(~isinf(C_bin_u_rand(:))) && all(~isnan(C_bin_u_rand(:))) && all(~isinf(D_bin_u_rand(:))) && all(~isnan(D_bin_u_rand(:)))) || stop_cond
                C_bin_u_rand(i) = sum(sum(temp_c_bin_u_rand(temp_c_bin_u_rand(:)~=Inf)))/length(nonzeros(temp_c_bin_u_rand(:)~=Inf));
                D_bin_u_rand(i) = sum(sum(temp_d_bin_u_rand(temp_d_bin_u_rand(:)~=Inf)))/length(nonzeros(temp_d_bin_u_rand(:)~=Inf));
                break
            end
        end
    end
    C_bin_u_rand_mean=mean(C_bin_u_rand);
    D_bin_u_rand_mean=mean(D_bin_u_rand);
    
    S_bin_u=(C_bin_u/C_bin_u_rand_mean)/(D_bin_u/D_bin_u_rand_mean);
    C_bin_u=C_bin_u/C_bin_u_rand_mean;
    D_bin_u=D_bin_u/D_bin_u_rand_mean;
   
final_C=C_bin_u;
final_D=D_bin_u;
final_S=S_bin_u;
final_c(index_matrix)=c_bin_u;
final_degree(index_matrix)=deg_M_bin_u;
else
    %%%%%%%%
    M_wei_u=matrix2;
    deg_M_wei_u=degrees_und(M_wei_u);
    Deg_M_wei_u=mean(deg_M_wei_u);
    c_wei_u = clustering_coef_wu(M_wei_u);
    d_wei_u = distance_wei(M_wei_u);
    
    stop_cond=any(isinf(c_wei_u(:))) || any(isinf(d_wei_u(:)));
    C_wei_u = sum(sum(c_wei_u(c_wei_u(:)~=Inf)))/length(nonzeros(c_wei_u(:)~=Inf));
    D_wei_u = sum(sum(d_wei_u(d_wei_u(:)~=Inf)))/length(nonzeros(d_wei_u(:)~=Inf));
    
    %%random matrix
    for i=1:10
        while true
            temp_m=triu(ones(size(matrix2))).*(~eye(size(matrix2)));
            i_m=find(temp_m(:)>0);
            p = randperm(length(i_m));
            rand_i_m=i_m(p);
            rand_m=zeros(size(matrix2));
            rand_m(i_m)=matrix2(rand_i_m);
            rand_m=rand_m+rand_m';
            rand_matrix(:,:,i)=rand_m;
            M_wei_u_rand(:,:,i)=rand_matrix(:,:,i);
            deg_M_wei_u_rand(:,:,i)=degrees_und(M_wei_u_rand(:,:,i));
            c_wei_u_rand(:,:,i) = clustering_coef_wu(M_wei_u_rand(:,:,i));
            d_wei_u_rand(:,:,i) = distance_wei(M_wei_u_rand(:,:,i));
            
            temp_c_wei_u_rand=c_wei_u_rand(:,:,i);
            temp_d_wei_u_rand=d_wei_u_rand(:,:,i);
            C_wei_u_rand(i)=mean(temp_c_wei_u_rand(:));
            D_wei_u_rand(i)=mean(temp_d_wei_u_rand(:));
            if (all(~isinf(C_wei_u_rand(:))) && all(~isnan(C_wei_u_rand(:))) && all(~isinf(D_wei_u_rand(:))) && all(~isnan(D_wei_u_rand(:))))  || stop_cond
                C_wei_u_rand(i) = sum(sum(temp_c_wei_u_rand(temp_c_wei_u_rand(:)~=Inf)))/length(nonzeros(temp_c_wei_u_rand(:)~=Inf));
                D_wei_u_rand(i) = sum(sum(temp_d_wei_u_rand(temp_d_wei_u_rand(:)~=Inf)))/length(nonzeros(temp_d_wei_u_rand(:)~=Inf));
                break
            end
        end
    end
    C_wei_u_rand_mean=mean(C_wei_u_rand);
    D_wei_u_rand_mean=mean(D_wei_u_rand);
    
    S_wei_u=(C_wei_u/C_wei_u_rand_mean)/(D_wei_u/D_wei_u_rand_mean);
    C_wei_u=C_wei_u/C_wei_u_rand_mean;
    D_wei_u=D_wei_u/D_wei_u_rand_mean;
    
final_C=C_wei_u;
final_D=D_wei_u;
final_S=S_wei_u;
final_c(index_matrix)=c_wei_u;
final_degree(index_matrix)=deg_M_wei_u;

end



end
