function [] = GUI_MIBCA_3(varargin)
size_yyy=600;
S.fh = figure('units','pixels',...
    'position',[100 100 1200 size_yyy],...
    'menubar','none',...
    'name','GUI_MIBCA',...
    'numbertitle','off',...
    'resize','off');
S.tx(2) = uicontrol('style','tex',...
    'unit','pix',...
    'position',[10 30 100 20],...
    'backg',get(S.fh,'color'),...
    'fontsize',14,'fontweight','bold' );


m_file = uimenu(S.fh,'Label','File');
m_view = uimenu(S.fh,'Label','View');
m_op = uimenu(S.fh,'Label','Operations');
m_file_open = uimenu(m_file,'Label','Open Image');
m_file_close = uimenu(m_file,'Label','Close Image');
m_file_closeall = uimenu(m_file,'Label','Close all Images');
m_view_trans = uimenu(m_op,'Label','Transformations');
m_view_trans = uimenu(m_op,'Label','Registration');

i_size=nargin;
global Ptransform
Ptransform=[];
global P
global P_fix
global pix_dim
global s_vol
global c_check
global disp_images;
global srow;
global transforms;
% global scale
scale=0.7;
view_volumes=2;

fig_pos1{1}=[10,size_yyy];
fig_pos2{1}=[10,size_yyy];
fig_pos3{1}=[10,size_yyy];

if (i_size==0)
    error('Please give as input at least 1 3d images')
end
for i=1:i_size
    struct_volume=varargin{i};
    %     label_name=strsplit(struct_volume.fileprefix,'/');
    %     S2.(['list',num2str(i)]) = uimenu(m_view,'Label',label_name{end},'Checked','off');
    S2.(['list',num2str(i)]) = uimenu(m_view,'Label',['Item ', num2str(i)],'Checked','off');
    
    if ~isfield(struct_volume,'mat')
        srow{i}(1,:)=struct_volume.hdr.hist.srow_x;
        srow{i}(2,:)=struct_volume.hdr.hist.srow_y;
        srow{i}(3,:)=struct_volume.hdr.hist.srow_z;
    else
        srow{i}(1,:)=struct_volume.mat(1,:);
        srow{i}(2,:)=struct_volume.mat(2,:);
        srow{i}(3,:)=struct_volume.mat(3,:);
    end
    pix_dim{i}=struct_volume.hdr.dime.pixdim;
    volume{i}=struct_volume.img;
    
    s_vol{i}=size(volume{i});
    if length(s_vol{i})==4
        c_volume{i}=volume{i}(:,:,:,round(s_vol{i}(4)/2));
    else
        c_volume{i}=volume{i};
    end
    P_fix{i}=[round(s_vol{i}(1)/2),round(s_vol{i}(2)/2),round(s_vol{i}(3)/2)];
    P{i}=P_fix{i};
end
for i=1:(min(i_size,view_volumes))
    set(S2.(['list',num2str(i)]),'Checked','on');
    c_check=i;
    disp_images(i)=i;
    
    fig_pos1{i+1}=[fig_pos1{i}(1),fig_pos1{i}(2)-(pix_dim{i}(4)*s_vol{i}(3)+10)*scale];
    axes('unit','pix','position',[fig_pos1{i+1}(1) fig_pos1{i+1}(2) pix_dim{i}(3)*s_vol{i}(2)*scale pix_dim{i}(4)*s_vol{i}(3)*scale])
    S.(['a',num2str(i),'x1']) = gca;
    S.(['h',num2str(i),'h1'])=imagesc(squeeze(c_volume{i}(round(s_vol{i}(1)/2),:,:))');axis off,
    
    
    fig_pos2{i+1}=[fig_pos1{i+1}(1)+(pix_dim{i}(3)*s_vol{i}(2)+10)*scale,fig_pos2{i}(2)-(pix_dim{i}(4)*s_vol{i}(3)+10)*scale];
    axes('unit','pix','position',[fig_pos2{i+1}(1) fig_pos2{i+1}(2)...
        pix_dim{i}(2)*s_vol{i}(1)*scale pix_dim{i}(4)*s_vol{i}(3)*scale])
    S.(['a',num2str(i),'x2']) = gca;
    S.(['h',num2str(i),'h2'])=imagesc(squeeze(c_volume{i}(:,round(s_vol{i}(2)/2),:))');axis off,
    
    
    fig_pos3{i+1}=[fig_pos2{i+1}(1)+(pix_dim{i}(2)*s_vol{i}(1)+10)*scale,fig_pos3{i}(2)-(pix_dim{i}(3)*s_vol{i}(2)+10)*scale];
    axes('unit','pix','position',[fig_pos3{i+1}(1) fig_pos3{i+1}(2)...
        pix_dim{i}(2)*s_vol{i}(1)*scale pix_dim{i}(3)*s_vol{i}(2)*scale])
    S.(['a',num2str(i),'x3']) = gca;
    S.(['h',num2str(i),'h3'])=imagesc(squeeze(c_volume{i}(:,:,round(s_vol{i}(3)/2)))');axis off
end
for i=1:(min(i_size,view_volumes))
    set(S.(['h',num2str(i),'h1']),'buttondownfcn',{@fh_bdfcn,S,c_volume})
    set(S.(['h',num2str(i),'h2']),'buttondownfcn',{@fh_bdfcn,S,c_volume})
    set(S.(['h',num2str(i),'h3']),'buttondownfcn',{@fh_bdfcn,S,c_volume})
end

set(S.fh,'windowbuttonmotionfcn',{@fh_wbmfcn,S,scale}) % Set the motion detector.
for i=1:i_size
    set(S2.(['list',num2str(i)]),'Callback',{@fh_select,S,S2,c_volume}) % Set the motion detector.
end


S.pb(2) = uicontrol('style','push',...
    'unit','pix',...
    'position',[10 10 200 20],...
    'backg',get(S.fh,'color'),...
    'fontsize',14,'fontweight','bold', 'String','Registration',...
    'callback',{@pb_call,S,S2});



function [] = fh_wbmfcn(varargin)
S = varargin{3};
scale=varargin{4};
global P
global P_fix
global pix_dim
global s_vol
names = fieldnames(S);
n_vol=(length(names)-2)/6;

for i=1:n_vol
    F1 = get(S.(['a',num2str(i),'x1']),'currentpoint');
    F2 = get(S.(['a',num2str(i),'x2']),'currentpoint');
    F3 = get(S.(['a',num2str(i),'x3']),'currentpoint');
    
    if ((F1(1,1)>0) && (F1(1,1)<s_vol{i}(2)) && (F1(1,2)>0) && (F1(1,2)<s_vol{i}(3)))
        %     if ((F1(1,1)>0) && (F1(1,1)<(pix_dim{i}(3)*s_vol{i}(2)*scale))) && ((F1(1,2)>0) && (F1(1,2)<(pix_dim{i}(4)*s_vol{i}(3)*scale)))
        P{i}(1)=P_fix{i}(1);
        P{i}(2)=round(F1(1,1));
        P{i}(3)=round(F1(1,2));
        set(S.tx(2),'str',['C.P.L:',num2str(P{i})])
        
    elseif ((F2(1,1)>0) && (F2(1,1)<s_vol{i}(1)) && (F2(1,2)>0) && (F2(1,2)<s_vol{i}(3)))
        %     elseif ((F2(1,1)>0) && (F2(1,1)<(pix_dim{i}(2)*s_vol{i}(1)*scale))) && ((F2(1,2)>0) && (F2(1,2)<(pix_dim{i}(4)*s_vol{i}(3)*scale)))
        P{i}(1)=round(F2(1,1));
        P{i}(2)=P_fix{i}(2);
        P{i}(3)=round(F2(1,2));
        set(S.tx(2),'str',['C.P.L:',num2str(P{i})])
        
    elseif ((F3(1,1)>0) && (F3(1,1)<s_vol{i}(1)) && (F3(1,2)>0) && (F3(1,2)<s_vol{i}(2)))
        %     elseif ((F3(1,1)>0) && (F3(1,1)<(pix_dim{i}(2)*s_vol{i}(1)*scale))) && ((F3(1,2)>0) && (F3(1,2)<(pix_dim{i}(3)*s_vol{i}(2)*scale)))
        P{i}(1)=round(F3(1,1));
        P{i}(2)=round(F3(1,2));
        P{i}(3)=P_fix{i}(3);
        set(S.tx(2),'str',['C.P.L:',num2str(P{i})])
    end
end

function [] = fh_bdfcn(varargin)
S = varargin{3};
seltype = get(S.fh,'selectiontype'); % Right-or-left click?
volume=varargin{4};
axes_on=varargin{1};
names = fieldnames(S);
n_vol=(length(names)-2)/6;
global P_fix
global disp_images

if strcmp(seltype,'normal')
    for i=1:n_vol
        switch axes_on
            case S.(['h',num2str(i),'h1'])
                F1 = get(S.(['a',num2str(i),'x1']),'currentpoint');
                
                P_fix{disp_images(i)}(2)=round(F1(1,1));
                set(S.(['h',num2str(i),'h2']),'CData',squeeze(volume{disp_images(i)}(:,P_fix{disp_images(i)}(2),:))')
                P_fix{disp_images(i)}(3)=round(F1(1,2));
                set(S.(['h',num2str(i),'h3']),'CData',squeeze(squeeze(volume{disp_images(i)}(:,:,P_fix{disp_images(i)}(3)))'))
                
                set(S.(['h',num2str(i),'h1']),'ButtonDownFcn',{@fh_bdfcn,S,volume})
                
            case S.(['h',num2str(i),'h2'])
                F1 = get(S.(['a',num2str(i),'x2']),'currentpoint');
                
                P_fix{disp_images(i)}(1)=round(F1(1,1));
                set(S.(['h',num2str(i),'h1']),'CData',squeeze(volume{disp_images(i)}(P_fix{disp_images(i)}(1),:,:))')
                P_fix{disp_images(i)}(3)=round(F1(1,2));
                set(S.(['h',num2str(i),'h3']),'CData',squeeze(volume{disp_images(i)}(:,:,P_fix{disp_images(i)}(3)))')
                
                set(S.(['h',num2str(i),'h2']),'ButtonDownFcn',{@fh_bdfcn,S,volume})
                
            case S.(['h',num2str(i),'h3'])
                F1 = get(S.(['a',num2str(i),'x3']),'currentpoint');
                
                P_fix{disp_images(i)}(1)=round(F1(1,1));
                set(S.(['h',num2str(i),'h1']),'CData',squeeze(volume{disp_images(i)}(P_fix{disp_images(i)}(1),:,:))')
                P_fix{disp_images(i)}(2)=round(F1(1,2));
                set(S.(['h',num2str(i),'h2']),'CData',squeeze(volume{disp_images(i)}(:,P_fix{disp_images(i)}(2),:))')
                
                set(S.(['h',num2str(i),'h3']),'ButtonDownFcn',{@fh_bdfcn,S,volume})
            otherwise
        end
    end
end

function [] = fh_select(varargin)
global c_check
global disp_images
global P_fix

m_click = varargin{1};
S = varargin{3};
S2 = varargin{4};
volume = varargin{5};
S2_names = fieldnames(S2);
S_names = fieldnames(S);
n_vol=(length(S_names)-2)/6;

m_click_check=get(m_click,'Checked');

for i=1:length(S2_names)
    if S2.(S2_names{i})==m_click
        m_click_name=str2num(S2_names{i}(5:end));
    end
end

if strcmp(m_click_check,'on')
    set(m_click,'Checked','off')
    c_check=c_check-1;
    disp_images(disp_images==m_click_name)=0;
else
    if c_check<n_vol
        set(m_click,'Checked','on')
        c_check=c_check+1;
        disp_images(find(disp_images==0,1,'first'))=m_click_name;
    else
        'Please uncheck an image first'
    end
end

for i=1:length(disp_images)
    
    if disp_images(i)==0
        set(S.(['h',num2str(i),'h1']),'Visible','off')
        set(S.(['h',num2str(i),'h2']),'Visible','off')
        set(S.(['h',num2str(i),'h3']),'Visible','off')
    else
        
        set(S.(['h',num2str(i),'h1']),'CData',squeeze(volume{disp_images(i)}(P_fix{disp_images(i)}(1),:,:))')
        set(S.(['h',num2str(i),'h2']),'CData',squeeze(volume{disp_images(i)}(:,P_fix{disp_images(i)}(2),:))')
        set(S.(['h',num2str(i),'h3']),'CData',squeeze(volume{disp_images(i)}(:,:,P_fix{disp_images(i)}(3)))')
        
        set(S.(['h',num2str(i),'h1']),'Visible','on')
        set(S.(['h',num2str(i),'h2']),'Visible','on')
        set(S.(['h',num2str(i),'h3']),'Visible','on')
    end
end

function [] = pb_call(varargin)
m_click = varargin{3};
S = varargin{3};
S_names=fieldnames(S);
S2 = varargin{4};
S2_names=fieldnames(S2);
global P_fix;
global srow;
global pix_dim
global s_vol
global transforms;
global Ptransform;

'Please select 4 points on the first and then second images'
[ax_handle,reg_x,reg_y]=ginput_mod(8);
for i=1:length(ax_handle)
    for j=1:length(S_names)
        if S.(S_names{j})==ax_handle(i)
            switch str2num(S_names{j}(4))
                case 1
                    A(i,:)=[(P_fix{str2num(S_names{j}(2))}(1)), reg_x(i), reg_y(i)];
                case 2
                    A(i,:)=[reg_x(i),P_fix{str2num(S_names{j}(2))}(2),reg_y(i)];
                case 3
                    A(i,:)=[reg_x(i),reg_y(i),P_fix{str2num(S_names{j}(2))}(3)];
                otherwise
            end
        end
    end
end

A1=A(1:length(ax_handle)/2,:);
A1=[A1,ones(length(A1),1)]';
A2=A(length(ax_handle)/2+1:length(ax_handle),:);
A2=[A2,ones(length(A1),1)]';

%%% spm registration
A1_mm=srow{1}(1:3,:)*A1;
A2_mm=srow{2}(1:3,:)*A2;
[R,t] = rigid_transform_3D_MIBCA(A1_mm',A2_mm');
transforms=[R,t];

% %%% freesurfer registration
% n_srow{1}=[srow{1}(1:3,1:3),-srow{1}(1:3,1:3)*(s_vol{1}(1:3)/2)'];
% n_srow{2}=[srow{2}(1:3,1:3)*(srow{1}(1:3,1:3)/(srow{2}(1:3,1:3)./repmat(pix_dim{2}(2:4)',1,3))),...
%     -srow{2}(1:3,1:3)*(srow{1}(1:3,1:3)/(srow{2}(1:3,1:3)./repmat(pix_dim{2}(2:4)',1,3)))*(s_vol{2}(1:3)/2)'];
% A1_mm=n_srow{1}(1:3,:)*A1;
% A2_mm=n_srow{2}(1:3,:)*A2;
% [R,t] = rigid_transform_3D_MIBCA(A1_mm',A2_mm');
% transforms=[R,t]


Ptransform(1)=transforms(1,4);
Ptransform(2)=transforms(2,4);
Ptransform(3)=transforms(3,4);
Ptransform(4)=atan2(transforms(3,2),transforms(3,3));
Ptransform(5)=atan2(-transforms(3,1),sqrt(transforms(3,2)^2+transforms(3,3)^2));
Ptransform(6)=atan2(transforms(2,1),transforms(1,1));
Ptransform
'ok'
