function [] = GUI_MIBCA_conetogram(varargin)
%Developed by A. Santos Ribeiro
%%%%

close all
S.fh = figure('units','normalized',...
    'outerposition',[0 0 1 1],...
    'menubar','none',...
    'name','GUI_MIBCA',...
    'numbertitle','off',...
    'resize','off');

axes('unit','pix','position',[300 100 600 600])
% axes('unit','normalized','position',[0.25 0.15 0.5 0.7])
S.('a_conetogram') = gca;

steps=300;
t=-pi+1/steps*pi:1/steps*pi:pi;

r{1}=1;
region_circle_x{1}=r{1}*cos(t);
region_circle_y{1}=r{1}*sin(t);
S.h_region_circle{1}=plot(region_circle_x{1},region_circle_y{1});axis tight, axis off,
hold on,

r{2}=0.8;
region_circle_x{2}=r{2}*cos(t);
region_circle_y{2}=r{2}*sin(t);
S.h_region_circle{2}=plot(region_circle_x{2},region_circle_y{2});

r{3}=0.7;
region_circle_x{3}=r{3}*cos(t);
region_circle_y{3}=r{3}*sin(t);
S.h_region_circle{3}=plot(region_circle_x{3},region_circle_y{3});

steps=72/2;
t=-pi+1/steps*pi:1/steps*pi:pi;
for i=1:72
S.h_lines{i}=line([r{2}*cos(t(i)),r{1}*cos(t(i))],[r{2}*sin(t(i)),r{1}*sin(t(i))]);
label_n=1.07;
if t(i)<-pi/2
    label_rot=t(i)+pi;
elseif t(i)>pi/2
    label_rot=t(i)-pi;
else
    label_rot=t(i);    
end    
S.a_text{i} = text(label_n*r{1}*cos(t(i)),label_n*r{1}*sin(t(i)),['reg',num2str(i)],'FontSize',1,'FontWeight','bold');
set(S.a_text{i},'horiz', 'center', 'vert', 'middle','Rotation',label_rot*180/pi);

if i~=72
S.a_text_polyg{i} =patch([r{2}*cos(t(i));r{1}*cos(t(i));r{1}*cos(t(i+1));r{2}*cos(t(i+1))],...
    [r{2}*sin(t(i));r{1}*sin(t(i));r{1}*sin(t(i+1));r{2}*sin(t(i+1))],[i/72 0 0]);
else
  S.a_text_polyg{i} =patch([r{2}*cos(t(i));r{1}*cos(t(i));r{1}*cos(t(1));r{2}*cos(t(1))],...
    [r{2}*sin(t(i));r{1}*sin(t(i));r{1}*sin(t(1));r{2}*sin(t(1))],[i/72 0 0]);
end

end


steps=72/2;
t=-pi+1/steps*pi:1/steps*pi:pi;
for i=1:steps*2
S.h_lines{i}=line([r{3}*cos(t(i)),r{2}*cos(t(i))],[r{3}*sin(t(i)),r{2}*sin(t(i))]);
if i~=steps*2
S.a_text_polyg{i} =patch([r{3}*cos(t(i));r{2}*cos(t(i));r{2}*cos(t(i+1));r{3}*cos(t(i+1))],...
    [r{3}*sin(t(i));r{2}*sin(t(i));r{2}*sin(t(i+1));r{3}*sin(t(i+1))],[rand(1) rand(1) rand(1)]);
else
  S.a_text_polyg{i} =patch([r{3}*cos(t(i));r{2}*cos(t(i));r{2}*cos(t(1));r{3}*cos(t(1))],...
    [r{3}*sin(t(i));r{2}*sin(t(i));r{2}*sin(t(1));r{3}*sin(t(1))],[rand(1) rand(1) rand(1)]);
end

end

steps=72/2;
t=-pi+1/steps*pi:1/steps*pi:pi;
for i=1:300
r1=round(rand(1)*70+1);
r2=round(rand(1)*70+1);
x=[(r{3}*cos(t(r1))+r{3}*cos(t(r1+1)))/2,0,(r{3}*cos(t(r2))+r{3}*cos(t(r2+1)))/2];
y=[(r{3}*sin(t(r1))+r{3}*sin(t(r1+1)))/2,0,(r{3}*sin(t(r2))+r{3}*sin(t(r2+1)))/2];
nn2=100;
xx=[x(1):(x(2)-x(1))/nn2:x(2),x(2)+(x(3)-x(2))/nn2:(x(3)-x(2))/nn2:x(3)];
yy=[y(1):(y(2)-y(1))/nn2:y(2),y(2)+(y(3)-y(2))/nn2:(y(3)-y(2))/nn2:y(3)];

temp_x=logspace(0,2,100)/100;

xx1=x(1)+temp_x*(x(2)-x(1));
yy1=interp1(x(1:2),y(1:2),xx1);

xx2=x(3)+temp_x*(x(2)-x(3));
yy2=interp1(x(2:3),y(2:3),xx2);

xx=[xx1,xx2(end:-1:1)];
yy=[yy1,yy2(end:-1:1)];

% yy = spline(x,y,xx);
nn=20;
% xx=[ones(1,nn)*xx(1),xx,ones(1,nn)*xx(end)];
% yy = interp1(x,y,xx);
% S.h_conections{i}=plot(xx,yy,'.-');


% smoothAmt=3;
% xInterp = xx(1):(xx(2)-xx(1))/smoothAmt:x(end); % Set up the mesh.
% yy = interp1(xx,yy,xInterp,'cubic');

xxx=conv(xx,ones(1,nn)/nn,'same');
yyy=conv(yy,ones(1,nn)/nn,'same');

xx=[x(1),xx,x(end)];
yy=[y(1),yy,y(end)];

weights=randn(1)*2+1;
weights(weights<=0)=1;
weights(weights>=4)=4;
S.h_conections{i}=plot(xxx,yyy,'-black','LineWidth',1,'LineSmoothing','on');
end

% x=[1,1.5,2];
% y=[1,1.5,1];
% xx=[1:0.01:2];
% yy = spline(x,y,xx);
% figure,plot(x',y'),hold on, plot(xx',yy','r')%,plot(xx,yy2,'g')
end
