function [] = GUI_MIBCA_visuallization_tool(varargin)
%Developed by A. Santos Ribeiro
%%%%

close all
data_1d_names={};%cell(1);
temp_label=[];
dti_fiber=[];

i_size=nargin;
i_size_1d=0;

i_fig_pos=[10 10 1200 700];
S.fh = figure('units','normalized',...
    'outerposition',[0.125 0.6 0.5 0.6],...
    'menubar','none',...
    'name','GUI_MIBCA',...
    'numbertitle','off',...
    'resize','on',...
    'color',[0.7,0.7,0.7],...
    'ResizeFcn',@fh_resize);

S.tx(2) = uicontrol('style','tex',...
    'unit','normalized',...
    'position',[0.7 0 0.3 1],...
    'backg',[0.8,0.8,0.8],...%get(S.fh,'color'),...
    'fontsize',14,'fontweight','bold' );

m_file = uimenu(S.fh,'Label','File');
S2.m_view_labels = uimenu(m_file,'Label','Load Labels','Callback',{@fh_load_labels});

S2.m_view = uimenu(S.fh,'Label','View');
S2.m_view_1d = uimenu(S2.m_view,'Label','1d Data');
S2.m_view_2d = uimenu(S2.m_view,'Label','2d Data');
S2.m_colormap_2d = uimenu(S2.m_view,'Label','Colormap');
S2.m_jet = uimenu(S2.m_colormap_2d,'Label','Jet','Callback',{@fh_colormap,1});
S2.m_hsv = uimenu(S2.m_colormap_2d,'Label','Hsv','Callback',{@fh_colormap,2});
S2.m_hot = uimenu(S2.m_colormap_2d,'Label','Hot','Callback',{@fh_colormap,3});
S2.m_cool = uimenu(S2.m_colormap_2d,'Label','Cool','Callback',{@fh_colormap,4});
S2.m_spring = uimenu(S2.m_colormap_2d,'Label','Spring','Callback',{@fh_colormap,5});
S2.m_summer = uimenu(S2.m_colormap_2d,'Label','Summer','Callback',{@fh_colormap,6});
S2.m_automn = uimenu(S2.m_colormap_2d,'Label','Autumn','Callback',{@fh_colormap,7});
S2.m_winter = uimenu(S2.m_colormap_2d,'Label','Winter','Callback',{@fh_colormap,8});
S2.m_gray = uimenu(S2.m_colormap_2d,'Label','Gray','Callback',{@fh_colormap,9});
S2.m_bone = uimenu(S2.m_colormap_2d,'Label','Bone','Callback',{@fh_colormap,10});
S2.m_copper = uimenu(S2.m_colormap_2d,'Label','Copper','Callback',{@fh_colormap,11});
S2.m_pink = uimenu(S2.m_colormap_2d,'Label','Pink','Callback',{@fh_colormap,12});
S2.m_lines = uimenu(S2.m_colormap_2d,'Label','Lines','Callback',{@fh_colormap,13});


S2.m_view_conetogram = uimenu(S2.m_view,'Label','Conectogram','Callback',{@fh_conetogram});
S2.m_view_3dgraph = uimenu(S2.m_view,'Label','3dgraph','Callback',{@fh_3dgraph});


m_op = uimenu(S.fh,'Label','Operations');
S2.m_view_trans = uimenu(m_op,'Label','Operations','Callback',{@fh_operation});
S2.m_view_regions = uimenu(m_op,'Label','Regions','Callback',{@fh_regions});

m_file_open = uimenu(m_file,'Label','Open Image','Callback',{@fh_openimage});
% m_file_close = uimenu(m_file,'Label','Close Image');
% S.m_file_close_data1d = uimenu(m_file_close,'Label','1d Data');
% S.m_file_close_data2d = uimenu(m_file_close,'Label','2d Data');
% m_file_closeall = uimenu(m_file,'Label','Close all Images','Callback',{@fh_closeallimage});
% m_file_save = uimenu(m_file,'Label','Save Matrix');
% S2.m_file_save1d = uimenu(m_file_save,'Label','1d Data');
% S2.m_file_save2d = uimenu(m_file_save,'Label','2d Data');

ctx_names_x=[];
ctx_names_y=[];
regions_show=[];

scale=1;
view_volumes=9;

set(gcf,'units','pixels'),
i_fig_pos=get(gcf,'Position');
set(gcf,'units','normalized');
fig_pos1=[i_fig_pos(1)+10,i_fig_pos(4)];

%%% IF there is some input assume that all are matrices
% matrices_img=cell(1);
data_1d=[];
matrices_img=[];
matrices_name=[];
data_1d_names=[];
type_visualization=[];

for qqq=1:i_size
    matrices_img{qqq}=varargin{qqq};
    S2.(['list',num2str(qqq)]) = uimenu(S2.m_view_2d,'Label',['Item ', num2str(qqq)],'Checked','off');
    s_vol{qqq}=size(matrices_img{qqq});
    
    if qqq>1
        if any(s_vol{qqq}-s_vol{qqq-1})
            error('All 2d matrix must be the same size')
        end
    end
end


for qqq=1:(min(i_size,view_volumes))
    set(S2.(['list',num2str(qqq)]),'Checked','on');
    c_check=qqq;
    disp_images(qqq)=qqq;
    
    fig_x_off= mod(qqq-1,3);
    fig_y_off= ceil(qqq/3);
    fig_space=50;
    
    fig_pos2=[0.01+fig_x_off*(0.25/(i_fig_pos(3)/i_fig_pos(4))*scale+0.05),1-fig_y_off*(0.25*scale+0.05)];
    axes('unit','normalized','position',[fig_pos2(1) fig_pos2(2) 0.25/(i_fig_pos(3)/i_fig_pos(4))*scale 0.25*scale])
    S.(['a',num2str(qqq),'x1']) = gca;
    S.(['h',num2str(qqq),'h1'])=imagesc(matrices_img{qqq});axis tight, axis off
    
    S.(['h',num2str(qqq),'t1']) = uicontrol('style','edit',...
        'unit','normalized',...
        'position',[fig_pos2(1)+(0.25/(i_fig_pos(3)/i_fig_pos(4))*scale)/2-0.2/(i_fig_pos(3)/i_fig_pos(4))*scale/2 ...
        fig_pos2(2)+0.25*scale+0.005 0.2/(i_fig_pos(3)/i_fig_pos(4))*scale 0.03*scale],...
        'backg',[0.8,0.8,0.8],...%get(S.fh,'color'),...
        'fontsize',14,'fontweight','bold',...
        'String','',...
        'callback',{@fh_title_call,qqq});
    
    matrices_name{qqq}=['list',num2str(qqq)];
    set(S.(['h',num2str(qqq),'t1']),'String',matrices_name{qqq})
    
    
end
for qqq=1:(min(i_size,view_volumes))
    set(S.(['h',num2str(qqq),'h1']),'buttondownfcn',{@fh_bdfcn})
end

set(S.fh,'windowbuttonmotionfcn',{@fh_wbmfcn}) % Set the motion detector.
for qqq=1:i_size
    set(S2.(['list',num2str(qqq)]),'Callback',{@fh_select})
end

for qqq=1:i_size
    uimenu(S2.m_file_save2d,'Label',['list',num2str(qqq)],'Callback',{@fh_save,qqq});
end

%%%%%%%%%%%%%%%%
    function [] = fh_title_call(varargin)
        matrices_name{disp_images(varargin{3})}=get(S.(['h',num2str(varargin{3}),'t1']),'String');
        set(S2.(['list',num2str(disp_images(varargin{3}))]),'Label',get(S.(['h',num2str(varargin{3}),'t1']),'String'));
        
    end

    function [] = fh_resize(varargin)
        set(gcf,'units','pixels'),
        i_fig_pos=get(gcf,'Position');
        set(gcf,'units','normalized');
        
        for qqq=1:(min(i_size,view_volumes))
            figure(S.fh)
            set(S.fh,'CurrentAxes',S.(['a',num2str(qqq),'x1']))
            fig_x_off= mod(qqq-1,3);
            fig_y_off= ceil(qqq/3);
            fig_pos2=[0.01+fig_x_off*(0.25/(i_fig_pos(3)/i_fig_pos(4))*scale+0.05),1-fig_y_off*(0.25*scale+0.05)];
            set(gca,'position',[fig_pos2(1) fig_pos2(2) 0.25/(i_fig_pos(3)/i_fig_pos(4))*scale 0.25*scale])
            
            if disp_images(qqq)~=0
                set(S.(['h',num2str(qqq),'h1']),'CData',matrices_img{disp_images(qqq)}(regions_show,regions_show)),axis tight,
                
                set(S.(['h',num2str(qqq),'t1']), 'position',[fig_pos2(1)+(0.25/(i_fig_pos(3)/i_fig_pos(4))*scale)/2-0.2/(i_fig_pos(3)/i_fig_pos(4))*scale/2 ...
                    fig_pos2(2)+0.25*scale+0.005 0.2/(i_fig_pos(3)/i_fig_pos(4))*scale 0.03*scale])
            end
        end
    end

    function fh_load_labels(varargin)
        [FileName,PathName] = uigetfile('*.mat','Select the MATLAB label file');
        temp_label=load([PathName,FileName]);
        temp_field_label=fieldnames(temp_label);
        ctx_names_x=temp_label.(temp_field_label{:});
        ctx_names_x=ctx_names_x(:,2);
        ctx_names_y=ctx_names_x;
        %         set(S2.m_view_labels,'Visible','off');
        %         set(S2.m_view_labels,'Label','Labels');
        %         for i=1:length(ctx_names_x)
        %         uimenu(S2.m_view_labels,'Label',ctx_names_x{i});
        %         end
        regions_show=1:length(ctx_names_x);
        reorder_region=[find((regions_show>=21) & (regions_show<=42)),...
            find((regions_show>=1) & (regions_show<=20)),...
            find((regions_show>=43) & (regions_show<=length(ctx_names_x)))];
        regions_show=regions_show(reorder_region);
    end

    function [] = fh_wbmfcn(varargin)
        P(1)=0;
        P(2)=0;
        matrices_names={'NaN';'NaN'};
        
        for i=1:(min(i_size,view_volumes))
            F1 = get(S.(['a',num2str(i),'x1']),'currentpoint');
            
            if ((F1(1,1)>1) && (F1(1,1)<(min(s_vol{i}(1),length(regions_show))+1)) && (F1(1,2)>1) && (F1(1,2)<(min(s_vol{i}(2),length(regions_show))+1)))
                %             if ((F1(1,1)>1) && (F1(1,1)<(min(s_vol{i}(1)+1))) && (F1(1,2)>1) && (F1(1,2)<(s_vol{i}(2)+1)))
                %     if ((F1(1,1)>0) && (F1(1,1)<(pix_dim{i}(3)*s_vol{i}(2)*scale))) && ((F1(1,2)>0) && (F1(1,2)<(pix_dim{i}(4)*s_vol{i}(3)*scale)))
                P(1)=fix(F1(1,1));
                P(2)=fix(F1(1,2));
                
                matrices_names{1}=ctx_names_x{regions_show(P(2))};
                matrices_names{2}=ctx_names_y{regions_show(P(1))};
                
            end
        end
        
        val_matrices{1}=['C.P.L:',num2str(P)];
        val_matrices{2}=[' Region1: ',matrices_names{1}];
        val_matrices{3}=[' Region2: ',matrices_names{2}];
        for i=1:(i_size)
            if (P(1)==0) || (P(2)==0)
                val_matrices{i+3}=[matrices_name{i},': ','NaN'];%'List',num2str(i),': ','NaN'];
            else
                val_matrices{i+3}=[matrices_name{i},': ',num2str(matrices_img{i}(regions_show(P(2)),regions_show(P(1))))];%'List',num2str(i),': ',num2str(matrices_img{i}(P(2),P(1)))];
                %                 val_matrices{i+3}=[matrices_name{i},': ',num2str(matrices_img{i}(P(2),P(1)))];%'List',num2str(i),': ',num2str(matrices_img{i}(P(2),P(1)))];
            end
        end
        for i=1:(i_size_1d)
            if (P(1)==0) || (P(2)==0)
                val_matrices{i+3+i_size}=[data_1d_names{i},': ','R1-','NaN',' R2-','NaN'];%'List',num2str(i),': ','NaN'];
                %                 val_matrices{i+3+i_size}=['1d_',num2str(i),': ','R1-','NaN',' R2-','NaN'];%'List',num2str(i),': ','NaN'];
            else
                value_order1=floor(log(abs(data_1d{i}(regions_show(P(1)))))./log(10));
                show_data1=data_1d{i}(regions_show(P(1)))/(10^value_order1);
                
                value_order2=floor(log(abs(data_1d{i}(regions_show(P(2)))))./log(10));
                show_data2=data_1d{i}(regions_show(P(2)))/(10^value_order2);
                
                val_matrices{i+3+i_size}=[data_1d_names{i}(3:end-5),': ','R1-',  num2str(round(show_data1*100)/100),'e',num2str(value_order1),' R2-', num2str(round(show_data2*100)/100),'e',num2str(value_order2)];%'List',num2str(i),': ',num2str(matrices_img{i}(P(2),P(1)))];
                %                 val_matrices{i+3+i_size}=['1d_',num2str(i),': ','R1-', num2str(data_1d{i}(P(1))),' R2-',num2str(data_1d{i}(P(2)))];%'List',num2str(i),': ',num2str(matrices_img{i}(P(2),P(1)))];
            end
        end
        
        set(S.tx(2),'str',['.','.','.','.',val_matrices]);
        
        
    end



    function [] = fh_bdfcn(varargin)
        axes_on=varargin{1};
        S_names = fieldnames(S);
        seltype = get(S.fh,'selectiontype'); % Right-or-left click?
        
        if (strcmp(seltype,'normal') || strcmp(seltype,'alt'))
            P1(1)=NaN;
            P1(2)=NaN;
            P2(1)=NaN;
            P2(2)=NaN;
            for i=1:(min(i_size,view_volumes))
                if axes_on==S.(['h',num2str(i),'h1'])
                    F1 = get(S.(['a',num2str(i),'x1']),'currentpoint');
                    P1(1)=fix(F1(1,1));
                    P1(2)=fix(F1(1,2));
                    
                    [lll,P2(1),P2(2)]=ginput_mod(1);
                    P2(1)=fix(P2(1));
                    P2(2)=fix(P2(2));
                    
                end
            end
            
            
            if any(~isnan([P1,P2]))
                t_matrices_img=matrices_img;
                t_ctx_names_x=ctx_names_x;
                t_ctx_names_y=ctx_names_y;
                
                for i=1:(min(i_size,view_volumes))
                    if strcmp(seltype,'normal')
                        matrices_img{i}(:,P1(1))=t_matrices_img{i}(:,P2(1));
                        matrices_img{i}(:,P2(1))=t_matrices_img{i}(:,P1(1));
                        ctx_names_y{P1(1)}=t_ctx_names_y{P2(1)};
                        ctx_names_y{P2(1)}=t_ctx_names_y{P1(1)};
                    else
                        matrices_img{i}(P1(2),:)=t_matrices_img{i}(P2(2),:);
                        matrices_img{i}(P2(2),:)=t_matrices_img{i}(P1(2),:);
                        ctx_names_x{P1(2)}=t_ctx_names_x{P2(2)};
                        ctx_names_x{P2(2)}=t_ctx_names_x{P1(2)};
                    end
                    set(S.(['h',num2str(i),'h1']),'CData',matrices_img{i});
                end
            end
        end
        
    end

    function [] = fh_select(varargin)
        
        m_click = varargin{1};
        S2_names = fieldnames(S2);
        
        
        m_click_check=get(m_click,'Checked');
        
        for i=1:length(S2_names)
            if S2.(S2_names{i})==m_click
                m_click_name=str2num(S2_names{i}(5:end));
            end
        end
        
        if strcmp(m_click_check,'on')
            set(m_click,'Checked','off')
            c_check=c_check-1;
            disp_images(disp_images==m_click_name)=0;
        else
            if c_check<=(min(i_size,view_volumes))
                set(m_click,'Checked','on')
                c_check=c_check+1;
                disp_images(find(disp_images==0,1,'first'))=m_click_name;
            else
                'Please uncheck an image first'
            end
        end
        
        for i=1:length(disp_images)
            
            if disp_images(i)==0
                set(S.(['h',num2str(i),'h1']),'Visible','off')
                
                set(S.(['h',num2str(i),'t1']),'Visible','off')
                
            else
                set(S.(['h',num2str(i),'h1']),'CData',matrices_img{disp_images(i)})
                set(S.(['h',num2str(i),'h1']),'Visible','on')
                
                set(S.(['h',num2str(i),'t1']),'Visible','on')
                
                set(S.(['h',num2str(i),'t1']),'String',matrices_name{disp_images(i)})
                
            end
        end
        
    end


    function [] = fh_operation(varargin)
        % global S2;
        
        if nargin==1
            i_fig_pos=varargin{1};
        else
            i_fig_pos=[10 10 600 700];
        end
        S2_names = fieldnames(S2);
        
        %         aaa=1;
        %         for i=1:length(S2_names)
        %             if strcmp(S2_names{i}(1:4),'list')
        %                 list_names{aaa}=S2_names{i};
        %                 aaa=aaa+1;
        %             end
        %         end
        
        for i=1:length(matrices_img)
            list_names{i}=matrices_name{i};
        end
        
        
        S.fh_operation = figure('units','normalized',...
            'position',[0    1    0.3    0.4],...
            'menubar','none',...
            'name','GUI_MIBCA_operations',...
            'numbertitle','off',...
            'resize','off');
        
        S.fh_oper_list = uicontrol('style','listbox',...
            'unit','normalized',...
            'position',[ 0.05    0.25    0.9    0.7],...
            'backg','white',...
            'Max',2,...
            'fontsize',14,'fontweight','bold',...
            'String',list_names);%,...
        %'callback',{@list_call,S,S2});
        
        S.fh_oper_command = uicontrol('style','edit',...
            'unit','normalized',...
            'position',[0.05    0.10    0.9    0.1],...
            'backg','white',...
            'fontsize',14,'fontweight','bold', 'String','',...
            'keypressfcn',{@button_call,S,S2});
        
        set(S.fh_oper_list,'callback',{@list_call,S,S2});
        % hListBox = uicontrol('Style','listbox','String',{'item 1' 'item 2'},'Position',[20 20 100 200]);
    end

    function [] = list_call(varargin)
        m_click = varargin{1};
        values = get(m_click,'Value');
        list_names= get(m_click,'String');
        paste_command=[];
        for i=1:length(values)
            paste_command=[paste_command,list_names{values(i)}];
        end
        old_command=get (S.fh_oper_command, 'String');
        new_command=[old_command,paste_command];
        set (S.fh_oper_command, 'String', new_command)
    end

    function [] = button_call(varargin)
        m_click = varargin{1};
        key_click = varargin{2};
        key_edit=int16(key_click.Character);
        
        pause(0.01)
        command_text= get(m_click,'String');
        command_text_old=command_text;
        
        %         expression_match = 'list(\w+)';
        %         replace_match='matrices_img{$1}';
        %         command_text = regexprep(command_text,expression_match,replace_match);
        
        [~,temp_indx]=sort(cell2mat(cellfun(@(C)length(C),matrices_name,'UniformOutput',false)));
        t_matrices_name=matrices_name(temp_indx(end:-1:1));
        for i=1:length(matrices_img)
            command_text = strrep(command_text, t_matrices_name{i}, ['matrices_img{',num2str(temp_indx(length(temp_indx)-i+1)),'}']);
        end
        
        % aaa=1;
        % for i=1:length(S2_names)
        %     if strcmp(S2_names{i}(1:4),'list')
        %     command_text = strrep(command_text, S2_names{i}, ['matrices_img{',num2str(aaa),'}']);
        %     aaa=aaa+1;
        %     end
        % end
        
        if key_edit==13
            %           eval(command_text);
            matrices_img{end+1}=eval(command_text);
            matrices_name{end+1}=command_text_old;
            
            
            %             if (min(i_size,view_volumes))==(length(matrices_img)-1)
            s_vol{length(matrices_img)}=size(matrices_img{length(matrices_img)});
            S2.(['list',num2str(length(matrices_img))]) = uimenu(S2.m_view_2d,'Label',['Item ', num2str(length(matrices_img))],'Checked','off');
            set(S2.(['list',num2str(length(matrices_img))]),'Label',command_text_old);
            
            i_fig_pos=get(S.fh_operation,'Position');
            close(S.fh_operation);
            fh_operation(i_fig_pos);
            
            i_size=length(matrices_img);
            set(S2.(['list',num2str(i_size)]),'Callback',{@fh_select,S,S2,matrices_img})
            
            if i_size<=view_volumes
                %                     indx=n_vol+1;
                set(S2.(['list',num2str(i_size)]),'Checked','on');
                c_check=i_size;
                disp_images(i_size)=i_size;
                
                %                     i_size=i_size+1;
                fig_x_off= mod(i_size-1,3);
                fig_y_off= ceil(i_size/3);
                fig_space=50;
                
                figure(S.fh)
                
                set(gcf,'units','pixels'),
                i_fig_pos=get(gcf,'Position');
                set(gcf,'units','normalized');
                
                fig_pos2=[0.01+fig_x_off*(0.25/(i_fig_pos(3)/i_fig_pos(4))*scale+0.05),1-fig_y_off*(0.25*scale+0.05)];
                axes('unit','normalized','position',[fig_pos2(1) fig_pos2(2) 0.25/(i_fig_pos(3)/i_fig_pos(4))*scale 0.25*scale])
                S.(['a',num2str(i_size),'x1']) = gca;
                S.(['h',num2str(i_size),'h1'])=imagesc(matrices_img{i_size});axis image; axis off%,colorbar
                
                %                     %%%%NEW
                %                     set(S.(['h',num2str(i_size),'h1']),'CData',matrices_img{i_size}(regions_show,regions_show)),
                %                     %%%%
                
                set(S.(['h',num2str(i_size),'h1']),'buttondownfcn',{@fh_bdfcn,S,matrices_img})
                % % %                     set(S2.(['list',num2str(i_size)]),'Callback',{@fh_select,S,S2,matrices_img})
                
                
                S.(['h',num2str(i_size),'t1']) = uicontrol('style','edit',...
                    'unit','normalized',...
                    'position',[fig_pos2(1)+(0.25/(i_fig_pos(3)/i_fig_pos(4))*scale)/2-0.2/(i_fig_pos(3)/i_fig_pos(4))*scale/2 ...
                    fig_pos2(2)+0.25*scale+0.005 0.2/(i_fig_pos(3)/i_fig_pos(4))*scale 0.03*scale],...
                    'backg',[0.8,0.8,0.8],...%get(S.fh,'color'),...
                    'fontsize',14,'fontweight','bold',...
                    'String','',...
                    'callback',{@fh_title_call,i_size});
                
                
                set(S.(['h',num2str(i_size),'t1']),'String',matrices_name{i_size})
                
                
            end
            %             end
        end
        
    end




    function [] = fh_regions(varargin)
        if nargin==1
            i_fig_pos=varargin{1};
        else
            i_fig_pos=[10 10 610 700];
        end
        
        S.fh_regions = figure('units','normalized',...
            'position',[0    1    0.32 0.6],...
            'menubar','none',...
            'name','GUI_MIBCA_regions',...
            'numbertitle','off',...
            'resize','off');
        
        S.fh_regions_text1 = uicontrol('style','tex',...
            'unit','normalized',...
            'position',[0.0803    0.9129    0.3279    0.0714],...
            'backg',get(S.fh,'color'),...
            'fontsize',14,'fontweight','bold','String', 'All regions available' );
        
        
        S.fh_region_list1 = uicontrol('style','listbox',...
            'unit','normalized',...
            'position',[-0.0016    0.0700    0.4918    0.8571],...
            'backg','white',...
            'Max',2,...
            'fontsize',14,'fontweight','bold',...
            'String',ctx_names_x);%,...
        
        S.fh_regions_text2 = uicontrol('style','tex',...
            'unit','normalized',...
            'position',[0.5885    0.9129    0.3279    0.0714],...
            'backg',get(S.fh,'color'),...
            'fontsize',14,'fontweight','bold','String', 'Regions to analyse' );
        
        S.fh_region_list2= uicontrol('style','listbox',...
            'unit','normalized',...
            'position',[0.5066    0.0700    0.4918    0.8571],...
            'backg','white',...
            'Max',2,...
            'fontsize',14,'fontweight','bold',...
            'String',ctx_names_x(regions_show));%cellfun(@(C) C(regions_show,:),ctx_names_x ,'UniformOutput', false));%,...
        
        set(S.fh_region_list1,'keypressfcn',{@region_list1_call,S,S2});
        %         set(S.fh_region_list1,'callback',{@region_list1_call,S,S2});
        set(S.fh_region_list2,'keypressfcn',{@region_list2_call,S,S2});
        %         set(S.fh_region_list2,'callback',{@region_list2_call,S,S2});
        
    end

    function [] = region_list1_call(varargin)
        key_click = varargin{2};
        key_edit=int16(key_click.Character);
        
        if key_edit==13
            m_click = varargin{1};
            values = get(m_click,'Value');
            list_names= get(m_click,'String');
            
            regions_show=union(regions_show,values);
            reorder_region=[find((regions_show>=21) & (regions_show<=42)),...
                find((regions_show>=1) & (regions_show<=20)),...
                find((regions_show>=43) & (regions_show<=length(ctx_names_x)))];
            regions_show=regions_show(reorder_region);
            
            i_fig_pos=get(S.fh_regions,'Position');
            close(S.fh_regions)
            fh_regions(i_fig_pos)
            
            
            for i=1:(min(i_size,view_volumes))
                set(S.(['h',num2str(i),'h1']),'CData',matrices_img{disp_images(i)}(regions_show,regions_show)),
                figure(S.fh)
                set(S.fh,'CurrentAxes',S.(['a',num2str(i),'x1']))
                axis tight
            end
            
        end
    end
    function [] = region_list2_call(varargin)
        key_click = varargin{2};
        key_edit=int16(key_click.Character);
        
        if key_edit==13
            m_click = varargin{1};
            values = get(m_click,'Value');
            list_names= get(m_click,'String');
            
            before_delete=length(regions_show);
            regions_show = setdiff(regions_show,regions_show(values));
            reorder_region=[find((regions_show>=21) & (regions_show<=42)),...
                find((regions_show>=1) & (regions_show<=20)),...
                find((regions_show>=43) & (regions_show<=length(ctx_names_x)))];
            regions_show=regions_show(reorder_region);
            
            after_delete=length(regions_show);
            
            %             regions_show=regions_show([9:16,1:8,17:end]);
            i_fig_pos=get(S.fh_regions,'Position');
            close(S.fh_regions)
            fh_regions(i_fig_pos)
            
            
            for i=1:(min(i_size,view_volumes))
                set(S.(['h',num2str(i),'h1']),'CData',matrices_img{disp_images(i)}(regions_show,regions_show)),
                figure(S.fh)
                set(S.fh,'CurrentAxes',S.(['a',num2str(i),'x1']))
                axis tight
            end
        end
        
    end



    function [] = fh_save1d(varargin)
        m_click=varargin{3};
        temp_data_1d=data_1d{m_click};
        uisave('temp_data_1d',['list',num2str(m_click),'.mat'])
    end
    function [] = fh_save2d(varargin)
        m_click=varargin{3};
        temp_matrix=matrices_img{m_click};
        uisave('temp_matrix',['list',num2str(m_click),'.mat'])
    end

    function [] = fh_closeallimage(varargin)
        children_2d=get(S2.m_view_2d,'Children');
        for i=1:length(children_2d)
            set(children_2d(i),'Visible','off')
        end
        children_1d=get(S2.m_view_1d,'Children');
        for i=1:length(children_1d)
            set(children_1d(i),'Visible','off')
        end
        
        children_2d=get(S2.m_file_save2d,'Children');
        for i=1:length(children_2d)
            set(children_2d(i),'Visible','off')
        end
        children_1d=get(S2.m_file_save1d,'Children');
        for i=1:length(children_1d)
            set(children_1d(i),'Visible','off')
        end
        
        
        for i=1:min(i_size,view_volumes)
            set(S.(['h',num2str(i),'h1']),'Visible','off')
            set(S.(['h',num2str(i),'t1']),'Visible','off')
        end
        matrices_img=[];
        data_1d=[];
    end


    function [] = fh_openimage(varargin)
        [FileName,PathName] = uigetfile('*.mat','Select the MATLAB code file');
        type_visualization=strcmp(FileName(1:5),'mean_');
        
        temp_data=load([PathName,FileName]);
        temp_data2{1}=temp_data;
        temp_fields=fieldnames(temp_data);
        temp_matrices=[];
        temp_1d=[];
        temp_names_1d=[];
        temp_matrices_name=[];
        
        aaa1=1;
        aaa2=1;
        aaa3=1;
        s_fieldnames=cell(1);
        ns_fieldnames2d=cell(1);
        ns_fieldnames1d=cell(1);
        for i=1:length(temp_fields)
            if isstruct(temp_data2{1}.(temp_fields{i}))
                s_fieldnames{aaa1}=temp_fields{i};
                aaa1=aaa1+1;
            else
                siz_temp=size(temp_data2{end}.(temp_fields{i}));
                if (length(siz_temp)==2) && (siz_temp(1)>1) && (siz_temp(1)==siz_temp(2))
                    ns_fieldnames2d{aaa2}=temp_fields{i};
                    aaa2=aaa2+1;
                elseif (length(siz_temp)==2) && ((siz_temp(1)>1)||(siz_temp(2)>1)) && (siz_temp(1)~=siz_temp(2))
                    ns_fieldnames1d{aaa3}=temp_fields{i};
                    aaa3=aaa3+1;
                    
                end
            end
        end
        
        i_fig_pos=[10 10 610 700];
        
        S.fh_regions = figure('units','normalized',...
            'position',[0   1    0.32    0.6],...
            'menubar','none',...
            'name','GUI_MIBCA_opendata',...
            'numbertitle','on',...
            'resize','off');
        
        S.fh_regions_text1 = uicontrol('style','tex',...
            'unit','normalized',...
            'position',[-0.0016    0.9629    0.4918    0.0286],...
            'backg',get(S.fh_regions,'color'),...
            'fontsize',14,'fontweight','bold','String', 'Structured data' );
        
        
        S.fh_openimage_list1 = uicontrol('style','listbox',...
            'unit','normalized',...
            'position',[-0.0016    0.3914    0.4918    0.5714],...
            'backg','white',...
            'Max',1,...
            'fontsize',14,'fontweight','bold',...
            'String',s_fieldnames,...
            'callback',{@region_list1_call});%,...
        
        S.fh_regions_text2 = uicontrol('style','tex',...
            'unit','normalized',...
            'position',[0.5066    0.9629    0.4918    0.0286],...
            'backg',get(S.fh_regions,'color'),...
            'fontsize',14,'fontweight','bold','String', 'Available variables 2d' );
        
        S.fh_openimage_list2= uicontrol('style','listbox',...
            'unit','normalized',...
            'position',[0.5066    0.7129    0.4918    0.2500],...
            'backg','white',...
            'Max',2,...
            'fontsize',14,'fontweight','bold',...
            'String',ns_fieldnames2d,...
            'callback',{@region_list2_call});%cellfun(@(C) C(regions_show,:),ctx_names_x ,'UniformOutput', false));%,...
        
        S.fh_regions_text2b = uicontrol('style','tex',...
            'unit','normalized',...
            'position',[0.5066    0.6414    0.4918    0.0286],...
            'backg',get(S.fh_regions,'color'),...
            'fontsize',14,'fontweight','bold','String', 'Available variables 1d' );
        
        S.fh_openimage_list2b= uicontrol('style','listbox',...
            'unit','normalized',...
            'position',[0.5066    0.3914    0.4918    0.2500],...
            'backg','white',...
            'Max',2,...
            'fontsize',14,'fontweight','bold',...
            'String',ns_fieldnames1d,...
            'callback',{@region_list2b_call});%cellfun(@(C) C(regions_show,:),ctx_names_x ,'UniformOutput', false));%,...
        
        S.fh_regions_text3 = uicontrol('style','tex',...
            'unit','normalized',...
            'position',[-0.0016    0.3200    1.0000    0.0286],...
            'backg',get(S.fh_regions,'color'),...
            'fontsize',14,'fontweight','bold','String', 'Variables to be analysed' );
        
        S.fh_openimage_list3= uicontrol('style','listbox',...
            'unit','normalized',...
            'position',[-0.0016    0.2129    1.0000    0.1071],...
            'backg','white',...
            'Max',2,...
            'fontsize',14,'fontweight','bold',...
            'String',{},...
            'callback',{@region_list3_call});%cellfun(@(C) C(regions_show,:),ctx_names_x ,'UniformOutput', false));%,...
        
        
        S.fh_openimage_list3b= uicontrol('style','listbox',...
            'unit','normalized',...
            'position',[-0.0016    0.1057    1.0000    0.1071],...
            'backg','white',...
            'Max',2,...
            'fontsize',14,'fontweight','bold',...
            'String',{},...
            'callback',{@region_list3b_call});%cellfun(@(C) C(regions_show,:),ctx_names_x ,'UniformOutput', false));%,...
        
        S.fh_openimage_done = uicontrol('style','push',...
            'unit','normalized',...
            'position',[-0.0016    0.0343    1.0000    0.0429],...
            'fontsize',14,'fontweight','bold', 'String','Done',...
            'callback',{@fh_openimage_done});
        
        function fh_openimage_done(varargin)
            matrices_img=[matrices_img,temp_matrices];
            data_1d=[data_1d,temp_1d];
            
            matrices_name=[matrices_name,temp_matrices_name];
            data_1d_names=[data_1d_names,temp_names_1d];
            
            for i=i_size_1d:length(data_1d)-1
                i_size_1d=i_size_1d+1;
                S2.(['list_1d',num2str(i_size_1d)]) = uimenu(S2.m_view_1d,'Label',['Item ', num2str(i_size_1d)],'Checked','off');
                
% % % % %                 uimenu(S2.m_file_save1d,'Label',['list',num2str(i_size_1d)],'Callback',{@fh_save1d,i_size_1d});
                
                %                 data_1d_names{i_size_1d}=['list',num2str(i_size_1d)];
            end
            
            
            %             if (min(i_size,view_volumes))==(length(matrices_img)-1)
            
            
            % % %             %%%done
            % % %             s_vol{length(matrices_img)}=size(matrices_img{length(matrices_img)});
            % % %             S2.(['list',num2str(length(matrices_img))]) = uimenu(S2.m_view_2d,'Label',['Item ', num2str(length(matrices_img))],'Checked','off');
            % % %             set(S2.(['list',num2str(length(matrices_img))]),'Label',command_text_old);
            % % %             i_size=length(matrices_img);
            % % %             set(S2.(['list',num2str(i_size)]),'Callback',{@fh_select,S,S2,matrices_img})
            % % %             %%%
            % % %
            % % %
            % % %             i_fig_pos=get(S.fh_operation,'Position');
            % % %             close(S.fh_operation);
            % % %             fh_operation(i_fig_pos);
            
            
            
            
            
            for i=i_size:length(matrices_img)-1
                i_size=i_size+1;
                s_vol{i_size}=size(matrices_img{i_size});
                
                %                 matrices_name{i_size}=['list',num2str(i_size)];
                
                S2.(['list',num2str(i_size)]) = uimenu(S2.m_view_2d,'Label',['Item ', num2str(i_size)],'Checked','off');
                
% % % %                 uimenu(S2.m_file_save2d,'Label',['list',num2str(i_size)],'Callback',{@fh_save2d,i_size});
                
                set(S2.(['list',num2str(i_size)]),'Callback',{@fh_select})
                
                if i_size<=view_volumes
                    set(S2.(['list',num2str(i_size)]),'Checked','on');
                    c_check=i_size;
                    
                    disp_images(i_size)=i_size;
                    fig_x_off= mod(i_size-1,3);
                    fig_y_off= ceil(i_size/3);
                    
                    figure(S.fh)
                    
                    set(gcf,'units','pixels'),
                    i_fig_pos=get(gcf,'Position');
                    set(gcf,'units','normalized');
                    
                    fig_pos2=[0.01+fig_x_off*(0.25/(i_fig_pos(3)/i_fig_pos(4))*scale+0.05),1-fig_y_off*(0.25*scale+0.05)];
                    axes('unit','normalized','position',[fig_pos2(1) fig_pos2(2) 0.25/(i_fig_pos(3)/i_fig_pos(4))*scale 0.25*scale])
                    S.(['a',num2str(i_size),'x1']) = gca;
                    S.(['h',num2str(i_size),'h1'])=imagesc(matrices_img{i_size}.*(1-eye(size(matrices_img{i_size}))));axis image; axis off%,colorbar
                    
                    set(S.(['h',num2str(i_size),'h1']),'buttondownfcn',{@fh_bdfcn,})
                    set(S2.(['list',num2str(i_size)]),'Callback',{@fh_select})
                    
                    S.(['h',num2str(i_size),'t1']) = uicontrol('style','edit',...
                        'unit','normalized',...
                        'position',[fig_pos2(1)+(0.25/(i_fig_pos(3)/i_fig_pos(4))*scale)/2-0.2/(i_fig_pos(3)/i_fig_pos(4))*scale/2 ...
                        fig_pos2(2)+0.25*scale+0.005 0.2/(i_fig_pos(3)/i_fig_pos(4))*scale 0.03*scale],...
                        'backg',[0.8,0.8,0.8],...%get(S.fh,'color'),...
                        'fontsize',14,'fontweight','bold',...
                        'String','',...
                        'callback',{@fh_title_call,i_size});
                    
                    set(S.(['h',num2str(i_size),'t1']),'String',matrices_name{i_size})
                    
                end
            end
            
        end
        
        function [] = region_list1_call(varargin)
            s_openimage_list1=get(S.fh_openimage_list1,'String');
            v_openimage_list1=get(S.fh_openimage_list1,'Value');
            set(S.fh_openimage_list1,'Value',1);
            selected=s_openimage_list1(v_openimage_list1);
            
            set(S.fh_openimage_list2,'Value',1);
            set(S.fh_openimage_list2b,'Value',1);
            
            
            if ~strcmp(selected{:},'..')
                temp_data2{end+1}=temp_data2{end}.(selected{:});
            else
                temp_data2(end)=[];
            end
            
            if isstruct(temp_data2{end})
                temp_fields=fieldnames(temp_data2{end});
                aaa1=1;
                aaa2=1;
                aaa3=1;
                s_fieldnames=cell(1);
                ns_fieldnames1d=cell(1);
                ns_fieldnames2d=cell(1);
                
                for i=1:length(temp_fields)
                    if ~strcmp(temp_fields{i}(1:2),'h_'),
                        if strcmp(temp_fields{i}(1:2),'m_')
                            t_temp_fields=fieldnames(temp_data2{end}.(temp_fields{i}));
                            for j=1:length(t_temp_fields)
                                siz_temp=size(temp_data2{end}.(temp_fields{i}).(t_temp_fields{j}));
                                ns_fieldnames2d{aaa2}=[temp_fields{i},'.',t_temp_fields{j}];
                                aaa2=aaa2+1;
                            end
                        elseif  strcmp(temp_fields{i}(1:2),'v_')
                            t_temp_fields=fieldnames(temp_data2{end}.(temp_fields{i}));
                            for j=1:length(t_temp_fields)
                                siz_temp=size(temp_data2{end}.(temp_fields{i}).(t_temp_fields{j}));
                                ns_fieldnames1d{aaa3}=[temp_fields{i},'.',t_temp_fields{j}];
                                aaa3=aaa3+1;
                            end
                        else
                            s_fieldnames{aaa1}=temp_fields{i};
                            aaa1=aaa1+1;
                        end
                        
                    end
                end
                % % %                 for i=1:length(temp_fields)
                % % %                     if ~strcmp(temp_fields{i}(1:2),'h_'),
                % % %                         if isstruct(temp_data2{end}.(temp_fields{i}))
                % % %                             s_fieldnames{aaa1}=temp_fields{i};
                % % %                             aaa1=aaa1+1;
                % % %                         else
                % % %                             siz_temp=size(temp_data2{end}.(temp_fields{i}));
                % % %                             %                         if strcmp(temp_fields{i}(1:2),'m_')
                % % %                             if (length(siz_temp)==2) && (siz_temp(1)>1) && (siz_temp(1)==siz_temp(2))
                % % %                                 ns_fieldnames2d{aaa2}=temp_fields{i};
                % % %                                 aaa2=aaa2+1;
                % % %                                 %                         elseif strcmp(temp_fields{i}(1:2),'v_')
                % % %                             elseif (length(siz_temp)==2) && ((siz_temp(1)>1)||(siz_temp(2)>1)) && (siz_temp(1)~=siz_temp(2))
                % % %                                 ns_fieldnames1d{aaa3}=temp_fields{i};
                % % %                                 aaa3=aaa3+1;
                % % %                             end
                % % %                         end
                % % %                     end
                % % %                 end
                set(S.fh_openimage_list1,'String',[{'..'}, s_fieldnames])
                set(S.fh_openimage_list2,'String',ns_fieldnames2d)
                set(S.fh_openimage_list2b,'String',ns_fieldnames1d)
                
                
            end
        end
        
        function [] = region_list2_call(varargin)
            s_openimage_list2=get(S.fh_openimage_list2,'String');
            v_openimage_list2=get(S.fh_openimage_list2,'Value');
            selected=s_openimage_list2(v_openimage_list2);
            
            s_openimage_list3=get(S.fh_openimage_list3,'String');
            C = union(s_openimage_list3,selected);
            set(S.fh_openimage_list3,'String',C)
            
            if isempty(temp_matrices)
                %                 temp_matrices={temp_data2{end}.(selected{:})};
                temp_matrices=eval(['{temp_data2{end}.',selected{:},'}']);
                temp_matrices_name=selected(:);
            else
                %                 temp_matrices{end+1}=temp_data2{end}.(selected{:});
                temp_matrices{end+1}=eval(['temp_data2{end}.',selected{:}]);
                temp_matrices_name{end+1}=selected{:};
            end
            
        end
        function [] = region_list2b_call(varargin)
            s_openimage_list2=get(S.fh_openimage_list2b,'String');
            v_openimage_list2=get(S.fh_openimage_list2b,'Value');
            selected=s_openimage_list2(v_openimage_list2);
            
            s_openimage_list3=get(S.fh_openimage_list3b,'String');
            C = union(s_openimage_list3,selected);
            set(S.fh_openimage_list3b,'String',C)
            
            if isempty(temp_1d)
                temp_1d=eval(['{temp_data2{end}.',selected{:},'}']);
                %                 temp_1d={temp_data2{end}.(selected{:})};
                temp_names_1d=selected(:);
            else
                temp_1d{end+1}=eval(['temp_data2{end}.',selected{:}]);
                %                 temp_1d{end+1}=temp_data2{end}.(selected{:});
                temp_names_1d{end+1}=selected{:};
            end
            
        end
        function [] = region_list3_call(varargin)
            s_openimage_list3=get(S.fh_openimage_list3,'String');
            v_openimage_list3=get(S.fh_openimage_list3,'Value');
            set(S.fh_openimage_list3,'Value',1);
            selected=s_openimage_list3(v_openimage_list3);
            
            C = setdiff(s_openimage_list3,selected);
            set(S.fh_openimage_list3,'String',C)
            
            if ~isempty(temp_matrices)
                temp_matrices(v_openimage_list3)=[];
            end
        end
        function [] = region_list3b_call(varargin)
            s_openimage_list3=get(S.fh_openimage_list3b,'String');
            v_openimage_list3=get(S.fh_openimage_list3b,'Value');
            set(S.fh_openimage_list3b,'Value',1);
            selected=s_openimage_list3(v_openimage_list3);
            
            C = setdiff(s_openimage_list3,selected);
            set(S.fh_openimage_list3b,'String',C)
            
            if ~isempty(temp_1d)
                temp_1d(v_openimage_list3)=[];
            end
        end
        
    end
    function [] = fh_colormap(varargin)
        option=varargin{3};
        
        switch option
            case 1
                cmap='Jet';
            case 2
                cmap='Hsv';
            case 3
                cmap='Hot';
            case 4
                cmap='Cool';
            case 5
                cmap='Spring';
            case 6
                cmap='Summer';
            case 7
                cmap='Autumn';
            case 8
                cmap='Winter';
            case 9
                cmap='Gray';
            case 10
                cmap='Bone';
            case 11
                cmap='Copper';
            case 12
                cmap='Pink';
            case 13
                cmap='Lines';
            otherwise
                cmap='Jet';
        end
        figure(S.fh)
        colormap(cmap)
        figure(S.fh)
        
    end


    function [] = fh_conetogram(varargin)
        S.fh_fh_conetogram = figure('units','normalized',...
            'outerposition',[0.05 0.05 0.6 0.6],...
            'menubar','none',...
            'ToolBar','figure',...
            'name','Conectogram_MIBCA',...
            'numbertitle','off',...
            'resize','on',...
            'color',[0,0,0]);
        
        axes_circle=[];
        
        S.fh_fh_hcmenu = uicontextmenu;
        S.fh_fh_hcmenu_add_ring = uimenu(S.fh_fh_hcmenu, 'Label', 'Add circle');
        for i=1:length(data_1d)
            uimenu(S.fh_fh_hcmenu_add_ring, 'Label', data_1d_names{i}, 'Callback', {@fh_fh_hcmenu_add_ring,i});
        end
        
%         S.fh_fh_hcmenu_remove_ring = uimenu(S.fh_fh_hcmenu, 'Label', 'Remove circle', 'Callback', {@fh_fh_hcmenu_remove_ring});
        
% % %         S.fh_fh_hcmenu_add_con = uimenu(S.fh_fh_hcmenu, 'Label', 'Add connexions');
% % %         for i=1:length(matrices_img)
% % %             uimenu(S.fh_fh_hcmenu_add_con, 'Label', matrices_name{i}, 'Callback', {@fh_fh_hcmenu_add_con,i});
% % %         end
        
%         type_visualization=1;
        S.fh_fh_hcmenu_add_concon = uimenu(S.fh_fh_hcmenu, 'Label', 'Add Connection');
        for i=1:length(matrices_img)
            uimenu(S.fh_fh_hcmenu_add_concon, 'Label', matrices_name{i}, 'Callback', {@fh_fh_hcmenu_add_concon,i});
        end
        
        if type_visualization==1
        S.fh_fh_hcmenu_add_fun = uimenu(S.fh_fh_hcmenu, 'Label', 'Add functionality');
        for i=1:length(matrices_img)
            uimenu(S.fh_fh_hcmenu_add_fun, 'Label', matrices_name{i}, 'Callback', {@fh_fh_hcmenu_add_fun,i});
        end
        
        S.fh_fh_hcmenu_add_dir = uimenu(S.fh_fh_hcmenu, 'Label', 'Add directionality');
        for i=1:length(matrices_img)
            uimenu(S.fh_fh_hcmenu_add_dir, 'Label', matrices_name{i}, 'Callback', {@fh_fh_hcmenu_add_dir,i});
        end
        
        S.fh_fh_hcmenu_add_modularity = uimenu(S.fh_fh_hcmenu, 'Label', 'Add Modularity');
        for i=1:length(matrices_img)
            uimenu(S.fh_fh_hcmenu_add_modularity, 'Label', matrices_name{i}, 'Callback', {@fh_fh_hcmenu_add_modularity,i});
        end
        end
        
%         S.fh_fh_hcmenu_remove2 = uimenu(S.fh_fh_hcmenu, 'Label', 'Remove connexions');
        
        
        
        
        set(S.fh_fh_conetogram,'uicontextmenu',S.fh_fh_hcmenu)
        
        set(S.fh_fh_conetogram, 'units','pix');
        screen_coor=get(S.fh_fh_conetogram, 'Position');
        
        axes('unit','normalized','position',[0.35-0.9*screen_coor(4)/screen_coor(3)/2 0.03 0.95*screen_coor(4)/screen_coor(3) 0.95])
        S.('a_conetogram') = gca;
        
        type_dti_direction=0;
        col_mod=[];
        
        steps=300;
        t=-pi+1/steps*pi:1/steps*pi:pi;
        
        r{1}=1;
        region_circle_x{1}=r{1}*cos(t);
        region_circle_y{1}=r{1}*sin(t);
        S.h_region_circle{1}=plot(0,0,'r');axis image, axis off, set(S.h_region_circle{1},'Visible','off')
        hold on,
        
        r{2}=0.65;
        region_circle_x{2}=r{2}*cos(t);
        region_circle_y{2}=r{2}*sin(t);
        %         S.h_region_circle{2}=plot(region_circle_x{2},region_circle_y{2},'r');
        
        %%% HUGOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO ADNIIIIIII ORDEMMMMMMM
        %         regions_show=regions_show([9:16,1:8,17:end]);
        
        use_ctx_names_x=ctx_names_x(regions_show);
        steps=length(use_ctx_names_x)/2;
        t=-pi:1/steps*pi:pi;
        col_breaks=[find(regions_show>43,1,'first'),find(regions_show>78,1,'first')];
        for i=1:steps*2
            
            %             S.h_lines{i}=line([r{2}*cos(t(i)),r{1}*cos(t(i))],[r{2}*sin(t(i)),r{1}*sin(t(i))]);
            
            label_n=1.02;
            
            if t(i)<-pi/2
                label_rot=t(i)+pi;
            elseif t(i)>pi/2
                label_rot=t(i)-pi;
            else
                label_rot=t(i);
            end
            
            sum_col_break=sum(i==(col_breaks));
            
            S.a_text_polyg{1,i} =patch([r{2}*cos(t(i));r{1}*cos(t(i));r{1}*cos(t(i+1));r{2}*cos(t(i+1))],...
                [r{2}*sin(t(i));r{1}*sin(t(i));r{1}*sin(t(i+1));r{2}*sin(t(i+1))],...
                [0.05+sum(i>=col_breaks)*0.25,...
                0.05+sum(i>=col_breaks)*0.25, ...
                0.05+sum(i>=col_breaks)*0.25]);
            
            if strcmp(use_ctx_names_x{i}(1:4),'ctx-')
                use_name=use_ctx_names_x{i}(5:end);
            elseif strcmp(use_ctx_names_x{i}(1:5),'Left-')
                use_name=['L-',use_ctx_names_x{i}(6:end)];
            elseif strcmp(use_ctx_names_x{i}(1:6),'Right-')
                use_name=['R-',use_ctx_names_x{i}(7:end)];
            else
                use_name=use_ctx_names_x{i};
            end
            if t(i)<-pi/2
                label_pos=[(r{2}*cos(t(i))+r{2}*cos(t(i+1)))/2,(r{2}*sin(t(i))+r{2}*sin(t(i+1)))/2];
                S.a_text{i} = text(label_n*label_pos(1),label_n*label_pos(2),use_name,'FontSize',8,'FontWeight','normal');
                set(S.a_text{i},'horiz', 'right', 'vert', 'middle','Rotation',label_rot*180/pi,'color',[1,1,1]);
            elseif t(i)>pi/2
                label_pos=[(r{2}*cos(t(i))+r{2}*cos(t(i+1)))/2,(r{2}*sin(t(i))+r{2}*sin(t(i+1)))/2];
                S.a_text{i} = text(label_n*label_pos(1),label_n*label_pos(2),use_name,'FontSize',8,'FontWeight','normal');
                set(S.a_text{i},'horiz', 'right', 'vert', 'middle','Rotation',label_rot*180/pi,'color',[1,1,1]);
            else
                label_pos=[(r{2}*cos(t(i))+r{2}*cos(t(i+1)))/2,(r{2}*sin(t(i))+r{2}*sin(t(i+1)))/2];
                S.a_text{i} = text(label_n*label_pos(1),label_n*label_pos(2),use_name,'FontSize',8,'FontWeight','normal');
                set(S.a_text{i},'horiz', 'left', 'vert', 'middle','Rotation',label_rot*180/pi,'color',[1,1,1]);
            end
            
            %             set(S.a_text{i},'horiz', 'center', 'vert', 'middle','Rotation',label_rot*180/pi,'color',[1,1,1]);
            
        end
        
        S.h_conections=cell(steps*2);
        
        xxx=[];
        yyy=[];
        dti_direction=ones(size(matrices_img{1}))*5;
        dti_effective=ones(size(matrices_img{1}))*5;
        dti_mod=ones(size(matrices_img{1}))*5;
        
        old_ttt=NaN;
        set(S.fh_fh_conetogram,'windowbuttonmotionfcn',{@fh_fh_wbmfcn}) % Set the motion detector.
        
        ppp1=[];
        ppp2=[];
        for hhh=1:steps*2
            set(S.a_text_polyg{1,hhh},'buttondownfcn',{@fh_fh_bdfcn})
        end
        
        function fh_fh_bdfcn(varargin)
            %             axes_on=varargin{1};
            %             S_names = fieldnames(S);
            % %             expression_match = 'a_text_polyg{1,[0123456789]+}';
            % %             startIndex = regexp(S_names,expression_match);
            % %             n_vol=sum(cell2mat(startIndex)==1);
            %             seltype = get(S.fh_fh_conetogram,'selectiontype'); % Right-or-left click?
            %
            %             if isempty(ppp1)
            %                 ppp1=cell2mat(cellfun(@(C) C==axes_on, S.a_text_polyg(1,:),'uniformoutput',false));
            %                 ppp1=find(ppp1);
            %             else
            %                 ppp2=cell2mat(cellfun(@(C) C==axes_on, S.a_text_polyg(1,:),'uniformoutput',false));
            %                 ppp2=find(ppp2);
            %             end
            %
            %             if (strcmp(seltype,'normal')) && (~isempty(ppp1)) && (~isempty(ppp2))
            % %                         set(S.a_text_polyg{1,ppp},'FaceColor',[1,1,1]);
            %                         global indx_min
            %                         lol=indx_min{ppp1,ppp2};
            %
            %                         for ggg=1:steps*2
            %                         for ggg2=ggg:steps*2
            %                             zzz=[ppp2,lol];
            %                             zzz2=[lol,ppp1];
            %                             a=zzz;
            %                             zzz=[zzz,zzz2];
            %                             zzz2=[zzz2,a];
            %                             if any((ggg==zzz) & (ggg2==zzz2))
            %                                 set(S.h_conections{ggg,ggg2},'Visible','on')
            %                                 set(S.h_conections{ggg2,ggg},'Visible','on')
            %                             else
            %                                 set(S.h_conections{ggg,ggg2},'Visible','off')
            %                                 set(S.h_conections{ggg2,ggg},'Visible','off')
            %                             end
            %                         end
            %                         end
            %
            %                         ppp1=[];
            %                         ppp2=[];
            %
            %
            %             end
            %
        end
        
        function fh_fh_wbmfcn(varargin)
            
            F1 = get(S.('a_conetogram'),'currentpoint');
            F1_angle=atan2(F1(1,2),F1(1,1));
            F1_r=sqrt(F1(1,1)^2+F1(1,2)^2);
            use_ctx_names_x=ctx_names_x(regions_show);
            steps=length(use_ctx_names_x)/2;
            
            col_breaks=[find(regions_show>43,1,'first'),find(regions_show>78,1,'first')];
            
            t=-pi:1/steps*pi:pi;
            for ttt=1:steps*2
                
                if (~isnan(old_ttt)) && (old_ttt~=ttt) && ((F1_angle<t(old_ttt)) || (F1_angle>t(old_ttt+1)) || (F1_r<r{2}) || (F1_r>r{1}))
                    n_xxx=xxx(old_ttt,:);
                    n_yyy=yyy(old_ttt,:);
                    xxx_empty=~cell2mat(cellfun(@isempty,n_xxx,'UniformOutput',false));
                    xxx_empty=find(xxx_empty);
                    for ttt2=1:length(xxx_empty)
                        %                         set(S.h_conections{old_ttt,xxx_empty(ttt2)},'xdata',n_xxx{xxx_empty(ttt2)},'ydata',n_yyy{xxx_empty(ttt2)},...
                        %                             'LineWidth',weights{old_ttt,xxx_empty(ttt2)},'color',[0,0,1]);
                        %                         S.h_conections{xxx_empty(ttt2),old_ttt}=S.h_conections{old_ttt,xxx_empty(ttt2)};
                        
                        %                         set(S.a_text_polyg{1,xxx_empty(ttt2)},'FaceColor',[xxx_empty(ttt2)/(steps*2),0,0]);
                        set(S.a_text_polyg{1,xxx_empty(ttt2)},'FaceColor',[xxx_empty(ttt2)/(steps*8)+0.2+round((xxx_empty(ttt2)-1)/(steps*2))*0.2 xxx_empty(ttt2)/(steps*8)+0.2+round((xxx_empty(ttt2)-1)/(steps*2))*0.2 xxx_empty(ttt2)/(steps*8)+0.2+round((xxx_empty(ttt2)-1)/(steps*2))*0.2]);
                        set(S.a_text_polyg{1,old_ttt},'FaceColor',[old_ttt/(steps*8)+0.2+round((old_ttt-1)/(steps*2))*0.2 old_ttt/(steps*8)+0.2+round((old_ttt-1)/(steps*2))*0.2 old_ttt/(steps*8)+0.2+round((old_ttt-1)/(steps*2))*0.2]);
                        %                         set(S.a_text_polyg{1,old_ttt},'FaceColor',[old_ttt/(steps*2) 0 0]);
                        
                        set(S.a_text_polyg{1,xxx_empty(ttt2)},'FaceColor',[0.05+sum(xxx_empty(ttt2)>=col_breaks)*0.25, 0.05+sum(xxx_empty(ttt2)>=col_breaks)*0.25, 0.05+sum(xxx_empty(ttt2)>=col_breaks)*0.25]);
                        set(S.a_text_polyg{1,old_ttt},'FaceColor',[0.05+sum(old_ttt>=col_breaks)*0.25, 0.05+sum(old_ttt>=col_breaks)*0.25, 0.05+sum(old_ttt>=col_breaks)*0.25]);
                        
                    end
                end
                
                if (~isnan(old_ttt)) && ( (F1_r<r{2}) || (F1_r>r{1})) && (old_ttt~=ttt)
                    for ggg=1:steps*2
                        for ggg2=ggg:steps*2
                            %                         set(S.hh{ggg,ggg2},'Visible','on')
                            
                            set(S.h_conections{ggg,ggg2},'Visible','on')
                            
                            %                                                            set(S.h_conections{ggg,ggg2},'xdata',xxx{ggg,ggg2},'ydata',yyy{ggg,ggg2},...
                            %                                                     'LineWidth',weights{ggg,ggg2},'color',[0,0,1]);
                            %                                                 S.h_conections{ggg2,ggg}=S.h_conections{ggg,ggg2};
                            
                        end
                    end
                    old_ttt=NaN;
                    
                end
                
                if        (F1_angle>t(ttt)) && (F1_angle<t(ttt+1)) && (F1_r>r{2}) && (F1_r<r{1}) && (old_ttt~=ttt)
                    n_xxx=xxx(ttt,:);
                    n_yyy=yyy(ttt,:);
                    xxx_empty=~cell2mat(cellfun(@isempty,n_xxx,'UniformOutput',false));
                    xxx_empty=find(xxx_empty);
                    for ttt2=1:length(xxx_empty)
                        %                                                 set(S.h_conections{ttt,xxx_empty(ttt2)},'xdata',n_xxx{xxx_empty(ttt2)},'ydata',n_yyy{xxx_empty(ttt2)},...
                        %                                                     'LineWidth',weights{ttt,xxx_empty(ttt2)},'color',[1,0,0]);
                        %                                                 S.h_conections{xxx_empty(ttt2),ttt}=S.h_conections{ttt,xxx_empty(ttt2)};
                        %
                        set(S.a_text_polyg{1,xxx_empty(ttt2)},'FaceColor',[0,0.5,0]);
                        
                        set(S.a_text_polyg{1,ttt},'FaceColor',[0,0,1]);
                    end
                    
                    for ggg=1:steps*2
                        for ggg2=ggg:steps*2
                            if (ggg~=ttt) && (ggg2~=ttt)
                                %                             set(S.hh{ggg,ggg2},'Visible','off')
                                
                                set(S.h_conections{ggg,ggg2},'Visible','off')
                                set(S.h_conections{ggg2,ggg},'Visible','off')
                                
                                %                                                             set(S.h_conections{ggg,ggg2},'xdata',xxx{ggg,ggg2},'ydata',yyy{ggg,ggg2},...
                                %                                                     'LineWidth',weights{ggg,ggg2},'color',[0,0,1]);
                                %                                                 S.h_conections{ggg2,ggg}=S.h_conections{ggg,ggg2};
                                
                                %                                 if (ggg<=size(h,1)) && (ggg2<=size(h,2))
                                %                                     set(h{ggg,ggg2},'Visible','off');
                                %                                     %                                 set(h{ggg2,ggg},'Visible','off');
                                %                                 end
                                
                            else
                                %                             set(S.hh{ggg,ggg2},'Visible','on')
                                
                                set(S.h_conections{ggg,ggg2},'Visible','on')
                                set(S.h_conections{ggg2,ggg},'Visible','on')
                                
                                %                                                                        set(S.h_conections{ggg,ggg2},'xdata',xxx{ggg,ggg2},'ydata',yyy{ggg,ggg2},...
                                %                                                     'LineWidth',weights{ggg,ggg2},'color',[1,0,0]);
                                %                                                 S.h_conections{ggg2,ggg}=S.h_conections{ggg,ggg2};
                                
                                %                                 if (ggg<=size(h,1)) && (ggg2<=size(h,2))
                                %                                     set(h{ggg,ggg2},'Visible','on');
                                %                                     %                                 set(h{ggg2,ggg},'Visible','on');
                                %                                 end
                                
                            end
                        end
                    end
                    old_ttt=ttt;
                    
                end
                
            end
            
        end
        
        
        function fh_fh_hcmenu_add_ring(varargin)
            
            temp_ring=data_1d{varargin{3}};
            temp_ring=temp_ring(regions_show);
            temp_ring(temp_ring==0)=NaN;
            ttemp=sort(temp_ring);
            ttemp(isnan(ttemp))=[];
            
% % % %             type_visualization=1; % 1: different colors; 3: red and blue (for %%)
            if type_visualization==1
                
                min_ttemp=ttemp(round(length(ttemp)*0.05));
                max_ttemp=ttemp(round(length(ttemp)*0.95));
                temp_ring(temp_ring<min_ttemp)=min_ttemp;
                temp_ring(temp_ring>max_ttemp)=max_ttemp;
                
                min_circles=min([length(axes_circle)+1,3]);
                y_axes_offset=mod(length(axes_circle),3)/2;
                x_axes_offset=floor(length(axes_circle)/3);
                range_circles=0.65;
                
                uicontrol('style','tex',...
                    'unit','normalized',...
                    'position',[0.68+x_axes_offset*0.16 1-(1-range_circles)/2-y_axes_offset*range_circles+0.13 0.12 0.02],...
                    'backg',get(S.fh_fh_conetogram,'color'),...
                    'fontsize',12,'fontweight','bold','String',data_1d_names{(varargin{3})}(3:end-5),'ForegroundColor','white'  );
                
                steps=32;
                t=-pi:1/steps*pi:pi;
                label_n=1.08;
                
                axes_circle{end+1}=axes('unit','normalized',...
                    'position',[0.68+x_axes_offset*0.16 1-(1-range_circles)/2-y_axes_offset*range_circles-0.06 0.12 0.12]);
                plot(0,0,'r'),axis image, axis off,
                hold on,
                
                color_ring=dec2bin(length(axes_circle),3);
                for i=1:steps*2
                    label_pos=[(1*cos(t(i))+1*cos(t(i+1)))/2,(1*sin(t(i))+1*sin(t(i+1)))/2];
                    norm_temp_data=i/(steps*2)*(max_ttemp-min_ttemp)+min_ttemp;
                    value_order=floor(log(abs(norm_temp_data))./log(10));
                    value_order(isinf(value_order))=0;
                    show_data=norm_temp_data/(10^value_order);
                    
                    if t(i)<-pi/2
                        label_rot=t(i)+pi;
                        if ~mod(i,7)
                            S.aa_text= text(label_n*label_pos(1),label_n*label_pos(2),[num2str(round(show_data*100)/100),'e',num2str(value_order)],'FontSize',13,'FontWeight','normal');
                            set(S.aa_text,'horiz','right', 'vert', 'middle','Rotation',label_rot*180/pi,'color',[1,1,1]);
                        end
                    elseif t(i)>pi/2
                        label_rot=t(i)-pi;
                        if ~mod(i,7)
                            S.aa_text= text(label_n*label_pos(1),label_n*label_pos(2),[num2str(round(show_data*100)/100),'e',num2str(value_order)],'FontSize',13,'FontWeight','normal');
                            set(S.aa_text,'horiz','right', 'vert', 'middle','Rotation',label_rot*180/pi,'color',[1,1,1]);
                        end
                    else
                        label_rot=t(i);
                        if ~mod(i,7)
                            S.aa_text= text(label_n*label_pos(1),label_n*label_pos(2),[num2str(round(show_data*100)/100),'e',num2str(value_order)],'FontSize',13,'FontWeight','normal');
                            set(S.aa_text,'horiz','left', 'vert', 'middle','Rotation',label_rot*180/pi,'color',[1,1,1]);
                        end
                    end
                    
                    S.aa_text_polyg=patch([1*cos(t(i));0;0;1*cos(t(i+1))],...
                        [1*sin(t(i));0;0;1*sin(t(i+1))],...
                        [str2num(color_ring(1))*(i/(steps*2*11/10)+1/11), ...
                        str2num(color_ring(2))*(i/(steps*2*11/10)+1/11), ...
                        str2num(color_ring(3))*(i/(steps*2*11/10)+1/11)],'EdgeColor','none');
                end
                
                axes(S.a_conetogram);
                steps=length(use_ctx_names_x)/2;
                t=-pi:1/steps*pi:pi;
                r{end+1}=r{end}-0.05;
                for i=1:steps*2
                    
                    new_col1=str2num(color_ring(1))*((temp_ring(i)-min_ttemp)/(max_ttemp-min_ttemp)*99/100+1/100);
                    new_col2=str2num(color_ring(2))*((temp_ring(i)-min_ttemp)/(max_ttemp-min_ttemp)*99/100+1/100);
                    new_col3=str2num(color_ring(3))*((temp_ring(i)-min_ttemp)/(max_ttemp-min_ttemp)*99/100+1/100);
                    new_col1(isnan(temp_ring(i)) | isinf(temp_ring(i)) | temp_ring(i)==0)=1;
                    new_col2(isnan(temp_ring(i)) | isinf(temp_ring(i))| temp_ring(i)==0)=1;
                    new_col3(isnan(temp_ring(i)) | isinf(temp_ring(i))| temp_ring(i)==0)=1;
                    
                    S.a_text_polyg{size(S.a_text_polyg,1)+1,i} =patch([r{end}*cos(t(i));r{end-1}*cos(t(i));r{end-1}*cos(t(i+1));r{end}*cos(t(i+1))],...
                        [r{end}*sin(t(i));r{end-1}*sin(t(i));r{end-1}*sin(t(i+1));r{end}*sin(t(i+1))],...
                        [new_col1, new_col2, new_col3]);
                end
                
            elseif type_visualization==2
                
                axes(S.a_conetogram);
                steps=length(use_ctx_names_x)/2;
                t=-pi:1/steps*pi:pi;
                r{end+1}=r{end}-0.05;
                
                temp_ring(isinf(temp_ring))=NaN;
                norm_val1=max(abs(temp_ring));
                %norm_val1=0.05;
                new_temp_ring=(temp_ring)/(norm_val1);
                
                for i=1:steps*2
                    if new_temp_ring(i)<0
                        col1=max(min(abs(new_temp_ring(i)),1),0);
                        col2=max(min(abs(new_temp_ring(i)),1),0);
                        col3=1;
                    elseif new_temp_ring(i)>0
                        col1=1;
                        col2=max(min(abs(new_temp_ring(i)),1),0);
                        col3=max(min(abs(new_temp_ring(i)),1),0);
                    else
                        col1=1;
                        col2=1;
                        col3=1;
                    end
                    col1(isnan(new_temp_ring(i)) | isinf(new_temp_ring(i)) | new_temp_ring(i)==0)=1;
                    col2(isnan(new_temp_ring(i)) | isinf(new_temp_ring(i))| new_temp_ring(i)==0)=1;
                    col3(isnan(new_temp_ring(i)) | isinf(new_temp_ring(i))| new_temp_ring(i)==0)=1;
                    
                    S.a_text_polyg{size(S.a_text_polyg,1)+1,i} =patch([r{end}*cos(t(i));r{end-1}*cos(t(i));r{end-1}*cos(t(i+1));r{end}*cos(t(i+1))],...
                        [r{end}*sin(t(i));r{end-1}*sin(t(i));r{end-1}*sin(t(i+1));r{end}*sin(t(i+1))],...
                        [col1, col2, col3]);
                end
                
            
            else
%             ttemp=sort(ttemp);
%             ttemp(ttemp==0)=NaN;
%             ttemp(isnan(ttemp))=[];
            
                min_ttemp=ttemp(ceil(length(ttemp)*0.05));
                max_ttemp=ttemp(ceil(length(ttemp)*0.95));
                temp_ring(temp_ring<min_ttemp)=min_ttemp;
                temp_ring(temp_ring>max_ttemp)=max_ttemp;
                
                min_circles=min([length(axes_circle)+1,3]);
                y_axes_offset=mod(length(axes_circle),3)/2;
                x_axes_offset=floor(length(axes_circle)/3);
                range_circles=0.65;
                
                uicontrol('style','tex',...
                    'unit','normalized',...
                    'position',[0.68+x_axes_offset*0.16 1-(1-range_circles)/2-y_axes_offset*range_circles+0.13 0.12 0.02],...
                    'backg',get(S.fh_fh_conetogram,'color'),...
                    'fontsize',14,'fontweight','bold','String',data_1d_names{(varargin{3})}(3:end-5),'ForegroundColor','white'  );
                
                steps=32;
                t=-pi:1/steps*pi:pi;
                label_n=1.08;
                
                axes_circle{end+1}=axes('unit','normalized',...
                    'position',[0.68+x_axes_offset*0.16 1-(1-range_circles)/2-y_axes_offset*range_circles-0.06 0.12 0.12]);
                plot(0,0,'r'),axis image, axis off,
                hold on,
                
                color_ring=dec2bin(length(axes_circle),3);
                for i=1:steps*2
                    label_pos=[(1*cos(t(i))+1*cos(t(i+1)))/2,(1*sin(t(i))+1*sin(t(i+1)))/2];
                    norm_temp_data=i/(steps*2)*(max_ttemp-min_ttemp)+min_ttemp;
                    value_order=floor(log(abs(norm_temp_data))./log(10));
                    value_order(isinf(value_order))=0;
                    show_data=norm_temp_data/(10^value_order);
                    
                    if t(i)<-pi/2
                        label_rot=t(i)+pi;
                        if ~mod(i,7)
                            S.aa_text= text(label_n*label_pos(1),label_n*label_pos(2),[num2str(round(show_data*100)/100),'e',num2str(value_order)],'FontSize',15,'FontWeight','normal');
                            set(S.aa_text,'horiz','right', 'vert', 'middle','Rotation',label_rot*180/pi,'color',[1,1,1]);
                        end
                    elseif t(i)>pi/2
                        label_rot=t(i)-pi;
                        if ~mod(i,7)
                            S.aa_text= text(label_n*label_pos(1),label_n*label_pos(2),[num2str(round(show_data*100)/100),'e',num2str(value_order)],'FontSize',15,'FontWeight','normal');
                            set(S.aa_text,'horiz','right', 'vert', 'middle','Rotation',label_rot*180/pi,'color',[1,1,1]);
                        end
                    else
                        label_rot=t(i);
                        if ~mod(i,7)
                            S.aa_text= text(label_n*label_pos(1),label_n*label_pos(2),[num2str(round(show_data*100)/100),'e',num2str(value_order)],'FontSize',15,'FontWeight','normal');
                            set(S.aa_text,'horiz','left', 'vert', 'middle','Rotation',label_rot*180/pi,'color',[1,1,1]);
                        end
                    end
                    
                    if show_data<0
                    S.aa_text_polyg=patch([1*cos(t(i));0;0;1*cos(t(i+1))],...
                        [1*sin(t(i));0;0;1*sin(t(i+1))],...
                        [1*(i/(steps*2*11/10)+1/11), ...
                        1*(i/(steps*2*11/10)+1/11), ...
                        1],'EdgeColor','none');
                    else
                    S.aa_text_polyg=patch([1*cos(t(i));0;0;1*cos(t(i+1))],...
                        [1*sin(t(i));0;0;1*sin(t(i+1))],...
                        [1, ...
                        1-1*(i/(steps*2*11/10)+1/11), ...
                        1-1*(i/(steps*2*11/10)+1/11)],'EdgeColor','none');
                        
                    end
                end
                
                                axes(S.a_conetogram);
                steps=length(use_ctx_names_x)/2;
                t=-pi:1/steps*pi:pi;
                r{end+1}=r{end}-0.05;
                
                temp_ring(isinf(temp_ring))=NaN;
                norm_val1=max(abs(temp_ring));
                %norm_val1=0.05;
                new_temp_ring=(temp_ring)/(norm_val1);
                %new_temp_ring=(temp_ring)./(max_ttemp-min_ttemp);
                new_temp_ring(temp_ring==0)=0;
                for i=1:steps*2
                    if new_temp_ring(i)<0
                        col1=1-max(min(abs(new_temp_ring(i)),1),0);
                        col2=1-max(min(abs(new_temp_ring(i)),1),0);
                        col3=1;
                    elseif new_temp_ring(i)>0
                        col1=1;
                        col2=1-max(min(abs(new_temp_ring(i)),1),0);
                        col3=1-max(min(abs(new_temp_ring(i)),1),0);
                    elseif new_temp_ring(i)==0
                        col1=1;
                        col2=1;
                        col3=1;
                    else
                        col1=1;
                        col2=1;
                        col3=1;  
                    end
                    col1(isnan(new_temp_ring(i)) | isinf(new_temp_ring(i)))=1;
                    col2(isnan(new_temp_ring(i)) | isinf(new_temp_ring(i)))=1;
                    col3(isnan(new_temp_ring(i)) | isinf(new_temp_ring(i)))=1;
                    
                    S.a_text_polyg{size(S.a_text_polyg,1)+1,i} =patch([r{end}*cos(t(i));r{end-1}*cos(t(i));r{end-1}*cos(t(i+1));r{end}*cos(t(i+1))],...
                        [r{end}*sin(t(i));r{end-1}*sin(t(i));r{end-1}*sin(t(i+1));r{end}*sin(t(i+1))],...
                        [col1, col2, col3],'EdgeColor',[0,0,0]);
                end

            end
            
           fh_fh_hcmenu_add_con() 
           
               
        end
        
%         function fh_fh_hcmenu_remove_ring(varargin)
%             S.a_text_polyg{size(S.a_text_polyg,1)+1,i}
%             
%         end
        
        
        function fh_fh_hcmenu_add_con(varargin)
            if nargin~=0
                dti_fiber=matrices_img{varargin{3}};
                dti_fiber=dti_fiber(regions_show,regions_show);
                dti_fiber(isnan(dti_fiber)|isinf(dti_fiber))=0;
            end
            
            
            %             dti_fiber=(dti_fiber+dti_fiber')/2;
            
            max_dti_fiber=max(abs(dti_fiber(dti_fiber~=0)));
            min_dti_fiber=min(abs(dti_fiber(dti_fiber~=0)));
            %             dti_fiber(abs(dti_fiber)<abs(min_dti_fiber)+abs(max_dti_fiber-min_dti_fiber)*0.6)=0;
            % % % % % %             dti_fiber(abs(dti_fiber)>0.01)=0;
            
            % % %             dti_fiber(abs(dti_fiber)>0.05)=0;
            
            %                         dti_direction=matrices_img{4}(regions_show,regions_show);
            
            %             S.h_conections=cell(steps*2);
            for i=1:steps*2
                for j=i+1:steps*2
                    
                    if abs(dti_fiber(i,j))
                        r1=i;
                        r2=j;
                        
                        aaax=((r{end}*cos(t(r1))+r{end}*cos(t(r1+1)))/2+(r{end}*cos(t(r2))+r{end}*cos(t(r2+1)))/2)/2;
                        aaay=((r{end}*sin(t(r1))+r{end}*sin(t(r1+1)))/2+(r{end}*sin(t(r2))+r{end}*sin(t(r2+1)))/2)/2;
                        x=[(r{end}*cos(t(r1))+r{end}*cos(t(r1+1)))/2,aaax*0.5,(r{end}*cos(t(r2))+r{end}*cos(t(r2+1)))/2];
                        y=[(r{end}*sin(t(r1))+r{end}*sin(t(r1+1)))/2,aaay*0.5,(r{end}*sin(t(r2))+r{end}*sin(t(r2+1)))/2];
                        
                        temp_x=logspace(0,2,100)/100;
                        temp_x=[0,temp_x];
                        
                        xx1=x(1)+temp_x*(x(2)-x(1));
                        yy1=interp1(x(1:2),y(1:2),xx1);
                        xx1(end)=[];
                        yy1(end)=[];
                        
                        xx2=x(3)+temp_x*(x(2)-x(3));
                        yy2=interp1(x(2:3),y(2:3),xx2);
                        xx2(end)=[];
                        yy2(end)=[];
                        
                        xx=[xx1,xx2(end-1:-1:1)];
                        yy=[yy1,yy2(end-1:-1:1)];
                        qqq(i,j)=length(xx);
                        
                        nn=20;
                        xx=conv(xx,ones(1,nn)/nn,'same');
                        yy=conv(yy,ones(1,nn)/nn,'same');
                        
                        xxx{i,j}=[x(1),xx(ceil(nn/2):end-ceil(nn/2)),x(end)];
                        yyy{i,j}=[y(1),yy(ceil(nn/2):end-ceil(nn/2)),y(end)];
                        
                        xxx{j,i}=[x(1),xx(ceil(nn/2):end-ceil(nn/2)),x(end)];
                        yyy{j,i}=[y(1),yy(ceil(nn/2):end-ceil(nn/2)),y(end)];
                        %
                        % % %                         weights{i,j}=abs(dti_fiber(i,j))/max_dti_fiber*2;
                        % % %                         weights{j,i}=abs(dti_fiber(i,j))/max_dti_fiber*2;
                        
                        weights{i,j}=(abs(dti_fiber(i,j))-min_dti_fiber)./(max_dti_fiber-min_dti_fiber);
                        weights{j,i}=(abs(dti_fiber(i,j))-min_dti_fiber)./(max_dti_fiber-min_dti_fiber);
                        
                        if isnan(weights{i,j})
                            weights{i,j}=1;
                            weights{j,i}=1;
                        end
                        if isempty(S.h_conections{i,j})
                            S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[1,1,1],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
%                             S.h_conections{j,i}=plot(xxx{i,j},yyy{i,j},'Color',[0,1,0],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
                        else
                            set(S.h_conections{i,j},'XData',xxx{i,j},'YData',yyy{i,j})
%                             set(S.h_conections{j,i},'XData',xxx{i,j},'YData',yyy{i,j})
                        end
                        
                        % % %                         if isempty(S.h_conections{i,j})
                        % % %                         zzz = zeros(length(xxx{i,j}),1)';
                        % % %                         S.h_conections{i,j}=surface([xxx{i,j};xxx{i,j}],[yyy{i,j};yyy{i,j}],[zzz;zzz],...
                        % % %                             'facecol','none',...
                        % % %                                 'linew',weights{i,j},...
                        % % %                                 'edgealpha',0.5,...
                        % % %                                 'edgecolor',[0,1,0],...
                        % % %                                 'LineSmoothing','on');
                        % % %
                        % % %                         S.h_conections{j,i}=S.h_conections{i,j};
                        % % %                         else
                        % % %                             set(S.h_conections{i,j},'XData',xxx{i,j},'YData',yyy{i,j})
                        % % %                             set(S.h_conections{j,i},'XData',xxx{i,j},'YData',yyy{i,j})
                        % % %                         end
                        
                        if type_visualization==1
                            
                        if type_dti_direction==0
                            delete(S.h_conections{i,j})
                                S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[0,0,1],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
                                set(S.h_conections{i,j},'Color',[1,1,1]);
                        elseif type_dti_direction==1
                                if dti_direction(i,j)<0
                                    delete(S.h_conections{i,j})
                                    S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[0,0,1],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
                                    set(S.h_conections{i,j},'Color',[0,0,1]);
                                elseif dti_direction(i,j)>0
                                    delete(S.h_conections{i,j})
                                    S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[1,0,0],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
                                    set(S.h_conections{i,j},'Color',[1,0,0]);
                                else
                                    delete(S.h_conections{i,j})
                                    S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[1,1,1],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
                                end
                        elseif type_dti_direction==2
                            if dti_effective(i,j)<0
                                zzz = zeros(length(xxx{i,j}),1)';
                                delete(S.h_conections{i,j})
                                S.h_conections{i,j}=surface([xxx{i,j};xxx{i,j}],[yyy{i,j};yyy{i,j}],[zzz;zzz],[1/length(xxx{i,j}):1/length(xxx{i,j}):1;1/length(xxx{i,j}):1/length(xxx{i,j}):1]*255,...
                                    'facecol','no',...
                                    'linew',weights{i,j}*1+1,...
                                    'edgealpha',1,...
                                    'edgecolor','interp',...
                                    'LineSmoothing','on');
                                map= colormap;
                                map(:,2)=0;
                                colormap(map);
                            elseif dti_effective(i,j)>0
                                zzz = zeros(length(xxx{i,j}),1)';
                                delete(S.h_conections{i,j})
                                S.h_conections{i,j}=surface([xxx{i,j};xxx{i,j}],[yyy{i,j};yyy{i,j}],[zzz;zzz],[1-1/length(xxx{i,j}):-1/length(xxx{i,j}):0;1-1/length(xxx{i,j}):-1/length(xxx{i,j}):0]*255,...
                                    'facecol','no',...
                                    'linew',weights{i,j}*1+1,...
                                    'edgealpha',1,...
                                    'edgecolor','interp',...
                                    'LineSmoothing','on');
                                map= colormap;
                                map(:,2)=0;
                                colormap(map);
                            else
                                delete(S.h_conections{i,j})
                                S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[1,1,1],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
                            end
                        elseif type_dti_direction==3
                            if dti_mod(i,j)~=0
                                col_code=[str2num(col_mod(i,1))/3+str2num(col_mod(i,4))/3*2,...
                                    str2num(col_mod(i,2))/3+str2num(col_mod(i,5))/3*2,...
                                    str2num(col_mod(i,4))/3+str2num(col_mod(i,6))/3*2];
                                delete(S.h_conections{i,j})
                                S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',col_code,'LineWidth',weights{i,j}+1,'LineSmoothing','on');
                            else
                                delete(S.h_conections{i,j})
                                S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[1,1,1],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
                            end
                        end
                        
                        elseif (type_visualization==0) || (type_visualization==2)
                            if dti_fiber(i,j)<0
                                delete(S.h_conections{i,j})
                                S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[0,0,1],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
                                set(S.h_conections{i,j},'Color',[0,0,1]);
                            elseif dti_fiber(i,j)>0
                                delete(S.h_conections{i,j})
                                S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[1,0,0],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
                                set(S.h_conections{i,j},'Color',[1,0,0]);
                            else
                                delete(S.h_conections{i,j})
                                S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[1,1,1],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
                            end
                        end
                        
                        
                        
% % % % %                         if dti_direction(i,j)<0
% % % % %                             if type_dti_direction==1
% % % % %                                 delete(S.h_conections{i,j})
% % % % %                                 S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[0,0,1],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
% % % % %                                 set(S.h_conections{i,j},'Color',[0,0,1]);
% % % % % %                                 set(S.h_conections{j,i},'Color',[0,0,1]);
% % % % %                             elseif type_dti_direction==2
% % % % %                                 zzz = zeros(length(xxx{i,j}),1)';
% % % % %                                 delete(S.h_conections{i,j})
% % % % %                                 S.h_conections{i,j}=surface([xxx{i,j};xxx{i,j}],[yyy{i,j};yyy{i,j}],[zzz;zzz],[1/length(xxx{i,j}):1/length(xxx{i,j}):1;1/length(xxx{i,j}):1/length(xxx{i,j}):1]*255,...
% % % % %                                     'facecol','no',...
% % % % %                                     'linew',weights{i,j}*1+1,...
% % % % %                                     'edgealpha',1,...
% % % % %                                     'edgecolor','interp',...
% % % % %                                     'LineSmoothing','on');
% % % % %                                 map= colormap;
% % % % %                                 map(:,2)=0;
% % % % %                                 colormap(map);
% % % % %                                 
% % % % %                             elseif type_dti_direction==3
% % % % %                                 delete(S.h_conections{i,j})
% % % % %                                 S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[0,0,1],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
% % % % %                                 set(S.h_conections{i,j},'Color',[0,0,1]);
% % % % %                                 
% % % % %                             end
% % % % %                             
% % % % %                         elseif dti_direction(i,j)>0
% % % % %                             if type_dti_direction==1
% % % % %                                 delete(S.h_conections{i,j})
% % % % %                                 S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[1,0,0],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
% % % % %                                 set(S.h_conections{i,j},'Color',[1,0,0]);
% % % % % %                                 set(S.h_conections{j,i},'Color',[1,0,0]);
% % % % %                             else
% % % % %                                 zzz = zeros(length(xxx{i,j}),1)';
% % % % %                                 delete(S.h_conections{i,j})
% % % % %                                 S.h_conections{i,j}=surface([xxx{i,j};xxx{i,j}],[yyy{i,j};yyy{i,j}],[zzz;zzz],[1-1/length(xxx{i,j}):-1/length(xxx{i,j}):0;1-1/length(xxx{i,j}):-1/length(xxx{i,j}):0]*255,...
% % % % %                                     'facecol','no',...
% % % % %                                     'linew',weights{i,j}*1+1,...
% % % % %                                     'edgealpha',1,...
% % % % %                                     'edgecolor','interp',...
% % % % %                                     'LineSmoothing','on');
% % % % %                                 map= colormap;
% % % % %                                 map(:,2)=0;
% % % % %                                 colormap(map);
% % % % %                             end
% % % % %                             
% % % % %                         elseif dti_direction(i,j)==0
% % % % %                             delete(S.h_conections{i,j})
% % % % %                             S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[1,1,1],'LineWidth',weights{i,j}+1,'LineSmoothing','on');
% % % % %                                 
% % % % % %                             set(S.h_conections{i,j},'Color',[1,1,1]);
% % % % % %                             set(S.h_conections{j,i},'Color',[1,1,1]);
% % % % %                         end
                        
                        
                    else
                        %             S.hh{i,j}=plot(0,0,'.black');
                        delete(S.h_conections{i,j})
                        delete(S.h_conections{j,i})
                        xxx{i,j}=[];
                        yyy{i,j}=[];
                        xxx{j,i}=[];
                        yyy{j,i}=[];
                        S.h_conections{i,j}=[];
                        S.h_conections{j,i}=[];
                        
                        %                         xxx{i,j}=[];
                        %                         yyy{i,j}=[];
                        %                         weights{i,j}=0;
                        %                         weights{j,i}=0;
                        %                         if isempty(S.h_conections{i,j})
                        %                             S.h_conections{i,j}=plot(xxx{i,j},yyy{i,j},'Color',[0,0,1],'LineWidth',weights{i,j},'LineSmoothing','on');
                        %                             S.h_conections{j,i}=S.h_conections{i,j};
                        %                         else
                        %                             set(S.h_conections{i,j},'XDataSource','xxx{i,j}')
                        %                             set(S.h_conections{i,j},'YDataSource','yyy{i,j}')
                        %                             set(S.h_conections{j,i},'XDataSource','xxx{i,j}')
                        %                             set(S.h_conections{j,i},'YDataSource','yyy{i,j}')
                        %                         end
                        
                        
                    end
                    
                end
            end
        end
        
        function fh_fh_hcmenu_add_concon(varargin)
            type_dti_direction=0;
            fh_fh_hcmenu_add_con([],[],varargin{3})
        end
        
        function fh_fh_hcmenu_add_fun(varargin)
            dti_direction=matrices_img{varargin{3}};
            dti_direction=dti_direction(regions_show,regions_show);
            type_dti_direction=1;
            
            %             dti_direction=(dti_direction-dti_direction');
            %             dti_direction(abs(dti_direction)<0.1)=0;
            %             dti_direction=sign(dti_direction);
            
            fh_fh_hcmenu_add_con([],[],varargin{3})
        end
        
        function fh_fh_hcmenu_add_dir(varargin)
            dti_effective=matrices_img{varargin{3}};
            dti_effective=dti_effective(regions_show,regions_show);
            type_dti_direction=2;
            
            dti_effective=(dti_effective-dti_effective');
            %                         dti_direction(abs(dti_direction)<0.1)=0;
            dti_effective=sign(dti_effective);
            
            fh_fh_hcmenu_add_con([],[],varargin{3})
        end
        
        
        function fh_fh_hcmenu_add_modularity(varargin)
            dti_mod=matrices_img{varargin{3}};
            dti_mod=dti_mod(regions_show,regions_show);
            dti_mod(isnan(dti_mod))=0;
            dti_mod=dti_mod~=0;
            
            [Ci Q]=modularity_und(dti_mod);
            col_mod=dec2bin(Ci,6);
            col_ones=find(arrayfun(@(A) strcmp(col_mod(A,:),'000111'),1:size(col_mod,1)));
            col_mod(col_ones,:)=repmat('100001',length(col_ones),1);
            
            type_dti_direction=3;
            
            fh_fh_hcmenu_add_con([],[],varargin{3})
            
        end
    end






    function  fh_3dgraph(varargin)
        
        S.fh_fh_3dgraph = figure('units','normalized',...
            'outerposition',[0 0 1 1],...
            'name','GUI_3dgraph',...
            'numbertitle','off',...
            'resize','on',...
            'color',[0,0,0],...
            'menubar','none',...
            'ToolBar','figure');
        
        S.fh_fh_dcm_obj_3dgraph = datacursormode(S.fh_fh_3dgraph);
        set(S.fh_fh_dcm_obj_3dgraph,'UpdateFcn',@myupdatefcn_3dgraph)
        target=0;
        
        
        S.fh_fh_hcmenu_3dgraph = uicontextmenu;
        %         S.fh_fh_hcmenu_add_ring = uimenu(S.fh_fh_hcmenu, 'Label', 'Add circle');
        %         for i=1:length(data_1d)
        %             uimenu(S.fh_fh_hcmenu_add_ring, 'Label', ['list',num2str(i)], 'Callback', {@fh_fh_hcmenu_add_ring,i});
        %         end
        %
        %         S.fh_fh_hcmenu_remove_ring = uimenu(S.fh_fh_hcmenu, 'Label', 'Remove circle', 'Callback', {@fh_fh_hcmenu_remove_ring});
        
        S.fh_fh_hcmenu_add_con_3dgraph = uimenu(S.fh_fh_hcmenu_3dgraph, 'Label', 'Add connexions');
        for i=1:length(matrices_img)
            uimenu(S.fh_fh_hcmenu_add_con_3dgraph, 'Label', matrices_name{i}, 'Callback', {@fh_fh_hcmenu_add_con_3dgraph,i});
        end
        dti_fiber_3dgraph=[];
        
        S.fh_fh_hcmenu_add_fun_3dgraph = uimenu(S.fh_fh_hcmenu_3dgraph, 'Label', 'Add functionality');
        for i=1:length(matrices_img)
            uimenu(S.fh_fh_hcmenu_add_fun_3dgraph, 'Label', matrices_name{i}, 'Callback', {@fh_fh_hcmenu_add_fun_3dgraph,i});
        end
        
        S.fh_fh_hcmenu_add_dir_3dgraph = uimenu(S.fh_fh_hcmenu_3dgraph, 'Label', 'Add directionality');
        for i=1:length(matrices_img)
            uimenu(S.fh_fh_hcmenu_add_dir_3dgraph, 'Label', matrices_name{i}, 'Callback', {@fh_fh_hcmenu_add_dir_3dgraph,i});
        end
        
        S.fh_fh_hcmenu_add_mod_3dgraph = uimenu(S.fh_fh_hcmenu_3dgraph, 'Label', 'Add modularity');
        for i=1:length(matrices_img)
            uimenu(S.fh_fh_hcmenu_add_mod_3dgraph, 'Label', matrices_name{i}, 'Callback', {@fh_fh_hcmenu_add_mod_3dgraph,i});
        end
        
        fun_matrix_3dgraph=[];
        
        type_dti_direction=[];
        
        source_connexion=[];
        sink_connexion=[];
        find_connexion=0;
        uimenu(S.fh_fh_hcmenu_3dgraph, 'Label', 'Find connexion','Callback', {@fh_fh_hcmenu_source_sink_3dgraph});
        
        
        set(S.fh_fh_3dgraph,'uicontextmenu', S.fh_fh_hcmenu_3dgraph)
        
        
        
        %         S.fh_fh_hcmenu_add_fun = uimenu(S.fh_fh_hcmenu, 'Label', 'Add directionality');
        %         for i=1:length(matrices_img)
        %             uimenu(S.fh_fh_hcmenu_add_fun, 'Label', matrices_name{i}, 'Callback', {@fh_fh_hcmenu_add_fun,i});
        %         end
        %
        %         S.fh_fh_hcmenu_remove2 = uimenu(S.fh_fh_hcmenu, 'Label', 'Remove connexions');
        %         set(S.fh_fh_conetogram,'uicontextmenu',S.fh_fh_hcmenu)
        
        
        
        m_file_3dgraph = uimenu(S.fh_fh_3dgraph,'Label','File');
        S2.m_load_label_volume_3dgraph = uimenu(m_file_3dgraph,'Label','Load Label Volume','Callback',{@fh_fh_load_label_volume_3dgraph});
        
        
        % hold on;
        % w=size(skel,1);
        % l=size(skel,2);
        % h=size(skel,3);
        % [x,y,z]=ind2sub([w,l,h],find(skel(:)));
        % plot3(y,x,z,'square','Markersize',4,'MarkerFaceColor','r','Color','r');
        % set(gcf,'Color','white');
        % view(140,80)
        
        centr_graph=[];
        S.fh_gh_plot3d_3dgraph=cell(length(regions_show));
        
        function fh_fh_hcmenu_source_sink_3dgraph(varargin)
            find_connexion=~find_connexion;
            source_connexion=[];
            sink_connexion=[];
            datacursormode on;
        end
        
        function fh_fh_load_label_volume_3dgraph(varargin)
            [FileName,PathName] = uigetfile('*.nii*','Select a Label Volume Image file');
            label_vol_image=load_nii([PathName,FileName]);
            label_vol_image=label_vol_image.img;
            samp_rate=2;
            label_vol_image=label_vol_image(1:samp_rate:end,1:samp_rate:end,1:samp_rate:end);
            label_vol_image_bin=label_vol_image>0;
            
            figure(S.fh_fh_3dgraph)
            % %             aaa=isosurface(label_vol_image_bin,0);
            % %             S.fh_fh_3dgraph_hiso = patch(aaa,'FaceColor','interp',...
            % %                 'FaceVertexCData',rand(size(aaa.vertices,1),1),'EdgeColor','none');
            
            col=[.7 .7 .8];
            S.fh_fh_3dgraph_hiso = patch(isosurface(label_vol_image_bin,0),'FaceColor',col,'EdgeColor','none');
            % %             hiso2 = patch(isocaps(label_vol_image_bin,0),'FaceColor',col,'EdgeColor','none');
            axis equal;axis off;
            lighting phong;
            isonormals(label_vol_image_bin,S.fh_fh_3dgraph_hiso);
            alpha(0.2);
            set(gca,'DataAspectRatio',[1 1 1])
            camlight;
            hold on;
            
            regions2analy=cell2mat(temp_label.ctx_labels(regions_show,1));
            for hh=1:length(regions2analy)
                graph_lindx=find(label_vol_image==regions2analy(hh));
                [graph_x,graph_y,graph_z] = ind2sub(size(label_vol_image),graph_lindx);
                centr_graph(hh,1)=mean(graph_x);
                centr_graph(hh,2)=mean(graph_y);
                centr_graph(hh,3)=mean(graph_z);
                
                centr_graph(hh,4)=plot3(centr_graph(hh,2),centr_graph(hh,1),centr_graph(hh,3),...
                    'o','Markersize',7,'MarkerFaceColor','black','Color','black');
            end
            
            set(S.fh_fh_3dgraph_hiso,'HitTest','off')
            
            
            % %             dist_vertex=repmat(aaa.vertices,1,1,size(centr_graph,1))-...
            % %                 permute(repmat(centr_graph(:,1:3),1,1,size(aaa.vertices,1)),[3,2,1]);
            % %             [~,indx]=min(squeeze(sum(dist_vertex.^2,2)),[],2);
            % %
            % %             lin_indx=sub2ind(size(label_vol_image),aaa.vertices(:,2),aaa.vertices(:,1),aaa.vertices(:,3));
            % %             data_3d=load_nii('/home/afs13/Documents/data/ibeb_data/dados_raw/dados_raw/results_DTI_fMRI_sMRI/MNI_0590/fMRI/s013a001/s013a001.feat/mean_func.nii');
            % %             data_3d=data_3d.img;
            % %             data_3d=data_3d(1:samp_rate:end,1:samp_rate:end,1:samp_rate:end);
            % %             plot_data=data_3d(lin_indx);
            % %             plot_data=(plot_data-min(plot_data(:)))/(max(plot_data(:))-min(plot_data(:)));
            % %             set(S.fh_fh_3dgraph_hiso,'FaceVertexCData',[plot_data,...
            % %                 zeros(size(aaa.vertices,1),1),zeros(size(aaa.vertices,1),1)])
            
            %             plot_data=(data_1d{1}(regions_show(indx))-min(data_1d{1}(:)))/(max(data_1d{1}(:))-min(data_1d{1}(:)));
            %             set(S.fh_fh_3dgraph_hiso,'FaceVertexCData',[plot_data,...
            %                 zeros(size(aaa.vertices,1),1),zeros(size(aaa.vertices,1),1)])
            
            %                 max_image=max(label_vol_image(:));
            %             aaa=1;
            %             while max_image~=0
            %                 graph_lindx=find(label_vol_image==max_image);
            %                 [graph_x,graph_y,graph_z] = ind2sub(size(label_vol_image),graph_lindx);
            %                 centr_graph(aaa,1)=mean(graph_x);
            %                 centr_graph(aaa,2)=mean(graph_y);
            %                 centr_graph(aaa,3)=mean(graph_z);
            %
            %              centr_graph(aaa,4)=plot3(centr_graph(aaa,2),centr_graph(aaa,1),centr_graph(aaa,3),...
            %                  'o','Markersize',7,'MarkerFaceColor','r','Color','r');
            %                label_vol_image(label_vol_image(:)==max_image)=0;
            %                 max_image=max(label_vol_image(:));
            %                 aaa=aaa+1;
            %             end
            
            %             plot3(centr_graph(:,2),centr_graph(:,1),centr_graph(:,3),'o','Markersize',1,'MarkerFaceColor','r','Color','r');
            set(gcf,'Color','white');
            view(140,80)
            
            
        end
        function fh_fh_hcmenu_add_fun_3dgraph(varargin)
            fun_matrix_3dgraph=-matrices_img{varargin{3}};
            fun_matrix_3dgraph=fun_matrix_3dgraph(regions_show,regions_show);
            fun_matrix_3dgraph(isnan(fun_matrix_3dgraph))=0;
            type_dti_direction=1;
            
            fh_fh_hcmenu_add_con_3dgraph([],[],varargin{3})
        end
        
        function fh_fh_hcmenu_add_mod_3dgraph(varargin)
% % %                         fun_matrix_3dgraph=(fun_matrix_3dgraph-fun_matrix_3dgraph');
% % %             %             fun_matrix_3dgraph(abs(fun_matrix_3dgraph)<0.1)=0;
% % %                         fun_matrix_3dgraph=sign(fun_matrix_3dgraph);
            fh_fh_hcmenu_add_con_3dgraph([],[],varargin{3})
        
                
            fun_matrix_3dgraph=matrices_img{varargin{3}};
            fun_matrix_3dgraph=fun_matrix_3dgraph(regions_show,regions_show);
            fun_matrix_3dgraph(isnan(fun_matrix_3dgraph))=0;
            
                        [Ci Q]=modularity_und(fun_matrix_3dgraph);
            %             [Ci Q]=modularity_dir(fun_matrix_3dgraph);
                        col_mod=dec2bin(Ci,6);
            
                        col_ones=find(arrayfun(@(A) strcmp(col_mod(A,:),'000111'),1:size(col_mod,1)));
                        col_mod(col_ones,:)=repmat('100001',length(col_ones),1);
                        for i=1:size(fun_matrix_3dgraph,1)
                            for j=i+1:size(fun_matrix_3dgraph,2)
                                col_code=[str2num(col_mod(i,1))/3+str2num(col_mod(i,4))/3*2,...
                                    str2num(col_mod(i,2))/3+str2num(col_mod(i,5))/3*2,...
                                    str2num(col_mod(i,4))/3+str2num(col_mod(i,6))/3*2];
                                    set(S.fh_gh_plot3d_3dgraph{i,j},'Color',col_code);
                            end
                        end
                        type_dti_direction=2;
        
            
        end
        
                function fh_fh_hcmenu_add_dir_3dgraph(varargin)
                   fun_matrix_3dgraph=matrices_img{varargin{3}};
            fun_matrix_3dgraph=fun_matrix_3dgraph(regions_show,regions_show);
            fun_matrix_3dgraph(isnan(fun_matrix_3dgraph))=0;

            fun_matrix_3dgraph=(fun_matrix_3dgraph-fun_matrix_3dgraph');
                    fun_matrix_3dgraph=sign(fun_matrix_3dgraph);

                    type_dti_direction=0;
                    
                        
                        fh_fh_hcmenu_add_con_3dgraph([],[],varargin{3})
                end
        
        function fh_fh_hcmenu_add_con_3dgraph(varargin)
            dti_fiber_3dgraph=matrices_img{varargin{3}};
            dti_fiber_3dgraph=dti_fiber_3dgraph(regions_show,regions_show);
            
%             dti_fiber_3dgraph=(dti_fiber_3dgraph+dti_fiber_3dgraph')/2;
            
            %%%%%%%% PARA TESTE ESTATISTICO
% % % %             dti_fiber_3dgraph=abs(dti_fiber_3dgraph)<0.05;
            %%%%%%%% PARA TESTE ESTATISTICO
            % % %             %%%%%%%% PARA MEDIAS
            % % %             dti_fiber_3dgraph(abs(dti_fiber_3dgraph)<abs(min(dti_fiber_3dgraph(:)))+abs(max(dti_fiber_3dgraph(:))-min(dti_fiber_3dgraph(:)))*0.6)=0;
            % % %             dti_fiber_3dgraph=(dti_fiber_3dgraph+dti_fiber_3dgraph')/2;
            % % %             %%%%%%%% PARA MEDIAS
            
            numb_conn=nansum(dti_fiber_3dgraph);
            
            numb_conn=(numb_conn-min(numb_conn))/(max(numb_conn)-min(numb_conn))...
                *19+1;
            
            %             S.fh_gh_plot3d_3dgraph=cell(size(dti_fiber_3dgraph));
            figure(S.fh_fh_3dgraph)
            for i=1:size(dti_fiber_3dgraph,1)
                for j=i+1:size(dti_fiber_3dgraph,2)
                    try
                        delete(S.fh_gh_plot3d_3dgraph{i,j})
                        delete(S.fh_gh_plot3d_3dgraph{j,i})
                    end
                    S.fh_gh_plot3d_3dgraph{i,j}=[];
                    S.fh_gh_plot3d_3dgraph{j,i}=[];
                    
                    if abs(dti_fiber_3dgraph(i,j))>0
                        %                         S.fh_gh_plot3d_3dgraph{i,j}=plot3([centr_graph(i,2),centr_graph(j,2)],[centr_graph(i,1),centr_graph(j,1)],[centr_graph(i,3),centr_graph(j,3)],'-','Markersize',10,'MarkerFaceColor','r','Color','r');
                        if fun_matrix_3dgraph(i,j)>0%(fun_matrix_3dgraph(i,j)==1) ||(fun_matrix_3dgraph(j,i)==1)
                            if type_dti_direction==1
                                S.fh_gh_plot3d_3dgraph{i,j}=plot3([centr_graph(i,2),centr_graph(j,2)],[centr_graph(i,1),centr_graph(j,1)],[centr_graph(i,3),centr_graph(j,3)],'-','Markersize',10,'MarkerFaceColor','r','Color','r','linew',2);
                        
                            elseif type_dti_direction==0
                                                            xxx=centr_graph(i,1):(centr_graph(j,1)-centr_graph(i,1))/10:centr_graph(j,1);
                                                        yyy=centr_graph(i,2):(centr_graph(j,2)-centr_graph(i,2))/10:centr_graph(j,2);
                                                        zzz=centr_graph(i,3):(centr_graph(j,3)-centr_graph(i,3))/10:centr_graph(j,3);
                                                        color_vec=linspace(1,0,length(xxx));
                                                        S.fh_gh_plot3d_3dgraph{i,j}=surface([yyy;yyy]',[xxx;xxx]',[zzz;zzz]',([color_vec;color_vec]')*255,...
                                                            'facecol','no',...
                                                            'linew',2,...
                                                            'edgealpha',1,...
                                                            'edgecolor','interp',...
                                                            'LineSmoothing','on');
                                                       map= colormap;
                                                       map(:,2)=0;
                                                       colormap(map);
                                                       S.fh_gh_plot3d_3dgraph{j,i}=S.fh_gh_plot3d_3dgraph{i,j};
                            
                            else
                                S.fh_gh_plot3d_3dgraph{i,j}=plot3([centr_graph(i,2),centr_graph(j,2)],[centr_graph(i,1),centr_graph(j,1)],[centr_graph(i,3),centr_graph(j,3)],'-','Markersize',10,'MarkerFaceColor','r','Color','black','linew',2);
                            end
                            
                        elseif fun_matrix_3dgraph(i,j)<0 
                            
                            if type_dti_direction==1
                            S.fh_gh_plot3d_3dgraph{i,j}=plot3([centr_graph(i,2),centr_graph(j,2)],[centr_graph(i,1),centr_graph(j,1)],[centr_graph(i,3),centr_graph(j,3)],'-','Markersize',10,'MarkerFaceColor','r','Color','b','linew',2);
                            elseif type_dti_direction==0
                                                            xxx=centr_graph(i,1):(centr_graph(j,1)-centr_graph(i,1))/10:centr_graph(j,1);
                                                        yyy=centr_graph(i,2):(centr_graph(j,2)-centr_graph(i,2))/10:centr_graph(j,2);
                                                        zzz=centr_graph(i,3):(centr_graph(j,3)-centr_graph(i,3))/10:centr_graph(j,3);
                                                        color_vec=linspace(0,1,length(xxx));
                                                        S.fh_gh_plot3d_3dgraph{i,j}=surface([yyy;yyy]',[xxx;xxx]',[zzz;zzz]',([color_vec;color_vec]')*255,...
                                                            'facecol','no',...
                                                            'linew',2,...
                                                            'edgealpha',1,...
                                                            'edgecolor','interp',...
                                                            'LineSmoothing','on');
                                                       map= colormap;
                                                       map(:,2)=0;
                                                       colormap(map);
                                                       S.fh_gh_plot3d_3dgraph{j,i}=S.fh_gh_plot3d_3dgraph{i,j};
                            else
                                S.fh_gh_plot3d_3dgraph{i,j}=plot3([centr_graph(i,2),centr_graph(j,2)],[centr_graph(i,1),centr_graph(j,1)],[centr_graph(i,3),centr_graph(j,3)],'-','Markersize',10,'MarkerFaceColor','r','Color','black','linew',2);
                                
                            end
                            
                        else
                            % % %                             S.fh_gh_plot3d_3dgraph{i,j}=plot3([centr_graph(i,2),centr_graph(j,2)],[centr_graph(i,1),centr_graph(j,1)],...
                            % % %                                 [centr_graph(i,3),centr_graph(j,3)],'-','Markersize',10,'MarkerFaceColor','r','Color','black','linew',2);
                            % % %                             S.fh_gh_plot3d_3dgraph{j,i}=S.fh_gh_plot3d_3dgraph{i,j};
                            
                            S.fh_gh_plot3d_3dgraph{i,j}=plot3([centr_graph(i,2),centr_graph(j,2)],[centr_graph(i,1),centr_graph(j,1)],[centr_graph(i,3),centr_graph(j,3)],'-','Markersize',10,'MarkerFaceColor','r','Color','black','linew',2);
                        end
                        
                        
                        set(S.fh_gh_plot3d_3dgraph{i,j},'Visible','on')
                        set(S.fh_gh_plot3d_3dgraph{j,i},'Visible','on')
                        %                          S.fh_gh_plot3d_3dgraph{j,i}=S.fh_gh_plot3d_3dgraph{i,j};
                        
                    end
                end
                
                set(centr_graph(i,4),'Markersize',numb_conn(i))
                %             plot3(centr_graph(i,2),centr_graph(i,1),centr_graph(i,3),'o','LineWidth',numb_conn(i))
            end
        end
        
        
        
        
        function txt = myupdatefcn_3dgraph(empt,event_obj)
            % change the point info to show the 1d metrics
            temp_var1=datacursormode(S.fh_fh_3dgraph);
            temp_var2=getCursorInfo(temp_var1);
            temp_target=get(event_obj,'Target');
            
            alldatacursors = findall(gcf,'type','hggroup');
            set(alldatacursors,'FontSize',18)
            
            num_datatypes=length(temp_var2);
            pos = get(event_obj,'Position');
            sel_node=find((centr_graph(:,1)==pos(2)) &...
                (centr_graph(:,2)==pos(1)) &(centr_graph(:,3)==pos(3)));
            
            info_node{1}=[ctx_names_x{regions_show(sel_node)}(5:end)];
            for i=1:length(data_1d)
                value_order=floor(log(abs(data_1d{i}(regions_show(sel_node))))./log(10));
                show_data=data_1d{i}(regions_show(sel_node))/(10^value_order);
                info_node{i+1}=[data_1d_names{i}(3:end-5),': ', ...
                    num2str(round(show_data*100)/100),'e',num2str(value_order)];
            end
            txt=info_node;
            
            if target~=temp_target
                target=temp_target;
                
                
                if (find_connexion==1)
                    if isempty(source_connexion)
                        source_connexion=pos;
                    else
                        sink_connexion=pos;
                    end
                end
                
                if isempty( sink_connexion)
                    
                    
                    
                    % % %                 for i=1:size(dti_fiber_3dgraph,1)
                    % % %                     for j=i+1:size(dti_fiber_3dgraph,2)
                    % % %                         if (i==sel_node) || (j==sel_node)
                    % % %                             if dti_fiber_3dgraph(i,j)
                    % % %                                 %                             set(S.fh_gh_plot3d_3dgraph{i,j},'LineWidth',2)
                    % % %                                 %                             set(S.fh_gh_plot3d_3dgraph{i,j},'Color',[0,0,1])
                    % % %                                 set(S.fh_gh_plot3d_3dgraph{i,j},'Visible','on')
                    % % %                                 %                           set(S.fh_gh_plot3d_3dgraph{j,i},'Visible','on')
                    % % %                             end
                    % % %
                    % % %                         else
                    % % %                             %                         set(S.fh_gh_plot3d_3dgraph{i,j},'LineWidth',1)
                    % % %                             %                         set(S.fh_gh_plot3d_3dgraph{i,j},'Color',[1,0,0])
                    % % %
                    % % %                             if num_datatypes<=1
                    % % %                                 set(S.fh_gh_plot3d_3dgraph{i,j},'Visible','off')
                    % % %                             end
                    % % %                             %set(S.fh_gh_plot3d_3dgraph{j,i},'Visible','off')
                    % % %                         end
                    % % %                     end
                    % % %                 end
                    
                    oper=0;
                    if (num_datatypes<=1)
                        for loop1=1:size(dti_fiber_3dgraph,1)
                            for loop2=loop1+1:size(dti_fiber_3dgraph,2)
                                if oper==0
                                    set(S.fh_gh_plot3d_3dgraph{loop1,loop2},'Visible','off');
                                    set(S.fh_gh_plot3d_3dgraph{loop2,loop1},'Visible','off');
                                    % fprintf('i=%d, j=%d\n',loop1,loop2)
                                else
                                    set(S.fh_gh_plot3d_3dgraph{loop1,loop2},'Visible','on');
                                    set(S.fh_gh_plot3d_3dgraph{loop2,loop1},'Visible','on');
                                end
                            end
                        end
                    end
                    
                    if num_datatypes>=1
                        [~,~,~,~,paths_source] = findpaths(dti_fiber_3dgraph,sel_node,1,1);
                        % % %                 if num_datatypes<=1
                        % % %                 if isfield(S,'fh_gh_plot3d_3dgraph_temp')
                        % % %                     for i=1:size(S.fh_gh_plot3d_3dgraph_temp,1)
                        % % %                         for j=1:size(S.fh_gh_plot3d_3dgraph_temp,2)
                        % % %                             try
                        % % %                                 delete(S.fh_gh_plot3d_3dgraph_temp{i,j});
                        % % %                             end
                        % % %                         end
                        % % %                     end
                        % % %                     S=rmfield(S,'fh_gh_plot3d_3dgraph_temp');
                        % % %                 end
                        % % %                 end
                        
                        %                 div_color=ceil(sqrt(size(paths_source,2)));
                        temp_matrix=zeros(size(dti_fiber_3dgraph,1),size(dti_fiber_3dgraph,2));
                        if ~isempty(paths_source)
                            for i=1:size(paths_source,2)
                                for j=1:size(paths_source,1)-1
                                    if (paths_source(j,i)~=0) && (paths_source(j+1,i)~=0)
                                        temp_matrix(paths_source(j,i),paths_source(j+1,i))=1;
                                        temp_matrix(paths_source(j+1,i),paths_source(j,i))=1;
                                        
                                        % % %                                     if num_datatypes>1
                                        % % %                                         vis_state=get(S.fh_gh_plot3d_3dgraph{paths_source(j,i),paths_source(j+1,i)},'Visible');
                                        % % %
                                        % % %                                         if (oper==0)
                                        % % %                                             set(S.fh_gh_plot3d_3dgraph{paths_source(j,i),paths_source(j+1,i)},'Visible','on');
                                        % % %                                         else
                                        % % %                                             set(S.fh_gh_plot3d_3dgraph{paths_source(j,i),paths_source(j+1,i)},'Visible','on');
                                        % % %                                         end
                                        % % %
                                        % % %                                         %                                 S.fh_gh_plot3d_3dgraph_temp{paths_source(j,i),paths_source(j+1,i)}=plot3([centr_graph(paths_source(j,i),2),centr_graph(paths_source(j+1,i),2)],...
                                        % % %                                             %                                     [centr_graph(paths_source(j,i),1),centr_graph(paths_source(j+1,i),1)],...
                                        % % %                                             %                                     [centr_graph(paths_source(j,i),3),centr_graph(paths_source(j+1,i),3)],...
                                        % % %                                             %                                     '-','Markersize',10,'MarkerFaceColor','r','Color',[0,0,1],'linew',2);
                                        % % %                                             %'-','Markersize',10,'MarkerFaceColor','r','Color',[mod(floor((i-1)/div_color),div_color)/div_color,0,mod(i-1,div_color)/div_color],'linew',2);
                                        % % %                                     else
                                        % % %                                         set(S.fh_gh_plot3d_3dgraph{paths_source(j,i),paths_source(j+1,i)},'Visible','on');
                                        % % %                                     end
                                    end
                                end
                            end
                        end
                        
                        for i=1:size(dti_fiber_3dgraph,1)
                            for j=i+1:size(dti_fiber_3dgraph,2)
                                vis_state=get(S.fh_gh_plot3d_3dgraph{i,j},'Visible');
                                if (oper==0) && temp_matrix(i,j)==1
                                    set(S.fh_gh_plot3d_3dgraph{i,j},'Visible','on');
                                    set(S.fh_gh_plot3d_3dgraph{j,i},'Visible','on');
                                elseif (oper==1)&& temp_matrix(i,j)==0
                                    set(S.fh_gh_plot3d_3dgraph{i,j},'Visible','off');
                                    set(S.fh_gh_plot3d_3dgraph{j,i},'Visible','off');
                                end
                                
                            end
                        end
                    end
                    
                else
                    
                    sel_source=find((centr_graph(:,1)==source_connexion(2)) &...
                        (centr_graph(:,2)==source_connexion(1)) &(centr_graph(:,3)==source_connexion(3)));
                    sel_target=find((centr_graph(:,1)==sink_connexion(2)) &...
                        (centr_graph(:,2)==sink_connexion(1)) &(centr_graph(:,3)==sink_connexion(3)));
                    
                    max_level=30;
                    level=1;
                    check_target=0;
                    while (check_target==0) && (level<=max_level)
                        [~,~,~,~,paths_source] = findpaths(dti_fiber_3dgraph,sel_source,level,1);
                        target_vec=sel_target==paths_source(level+1,:);
                        check_target=any(target_vec);
                        level=level+1;
                    end
                    
                    if check_target
                        path_source_target=paths_source(:,find(target_vec));
                    else
                        path_source_target=[];
                    end
                    for i=1:size(dti_fiber_3dgraph,1)
                        for j=i+1:size(dti_fiber_3dgraph,2)
                            set(S.fh_gh_plot3d_3dgraph{i,j},'Visible','off');
                        end
                    end
                    if ~isempty(path_source_target)
                        for i=1:size(path_source_target,2)
                            for j=1:size(path_source_target,1)-1
                                set(S.fh_gh_plot3d_3dgraph{path_source_target(j,i),path_source_target(j+1,i)},'Visible','on');
                                set(S.fh_gh_plot3d_3dgraph{path_source_target(j+1,i),path_source_target(j,i)},'Visible','on');
                            end
                        end
                    end
                    
                    find_connexion=0;
                    source_connexion=[];
                    sink_connexion=[];
                end
            end
            
            
        end
        
        
    end







end



