function [INFOOUT, TRACTSOUT,f_length,f_orient]=NBL_filterTract_full_2_MIBCA(INFO,TRACTS,ROI,type)

%Developed by A. Santos Ribeiro and L. Lacerda
%%%%

n_count    = INFO.n_count;
INFOOUT=INFO;
TRACTSOUT=cell(n_count,1);
t=1;
size_ROI=size(ROI);

[nrows, ncols] = cellfun(@size, TRACTS);

XX=cell2mat(TRACTS);
if ~isempty(XX)
    XX(find(((XX(:,1)<=0) | (XX(:,1)>INFO.dim(1)))|((XX(:,2)<=0) | (XX(:,2)>INFO.dim(2))) | ((XX(:,3)<=0) | (XX(:,3)>INFO.dim(3)))),:)=1; %VEEEERRRRRRRRRRRRRRR
    fix_XX=fix(XX);
    fix_XX(fix_XX(:)==0)=1;
    linearInd = sub2ind(size_ROI, fix_XX(:,1), fix_XX(:,2),fix_XX(:,3));
    aaa=ROI(linearInd);
    
    %either end
    if type==1
        t_nrows=cumsum(nrows);
        t_nrows=[1;t_nrows;t_nrows(1:end-1)+1];
        t_nrows=sort(t_nrows);
        aaa=double(aaa);
        aaa(t_nrows)=aaa(t_nrows)+1;
        aaa=(aaa==2);
        %middle fiber
    elseif type==2
        t_nrows=fix([1;cumsum(nrows(1:end-1))+1]+nrows/2);
        aaa=double(aaa);
        aaa(t_nrows)=aaa(t_nrows)+1;
        aaa=(aaa==2);
    end
    
    XX=mat2cell(aaa,nrows);
    [ccc] = cellfun(@any, XX);
    TRACTSOUT=TRACTS(ccc);
    
    if nargout>2
        f_length_t=cellfun(@diff,TRACTSOUT,'UniformOutput',0);
        f_length=cellfun(@times,f_length_t,f_length_t,'UniformOutput',0);
        f_length=cellfun(@transpose,f_length,'UniformOutput',0);
        f_length=cellfun(@sum,f_length,'UniformOutput',0);
        f_length=cellfun(@sqrt,f_length,'UniformOutput',0);
        f_length=cellfun(@sum,f_length,'UniformOutput',0);
        f_length=median(cell2mat(f_length));
    end
    if nargout>3
        f_orient=cellfun(@sum,f_length_t,'UniformOutput',0);
        f_orient_t=cellfun(@norm,f_orient,'UniformOutput',0);
        f_orient=cellfun(@rdivide,f_orient,f_orient_t,'UniformOutput',0);
        f_orient=cellfun(@abs,f_orient,'UniformOutput',0);
        f_orient=median(cell2mat(f_orient));
        if any(isnan(f_orient(:)))
            f_orient=[NaN,NaN,NaN];
        end
    end
    
else
    TRACTSOUT=[];
    f_length=NaN;
    f_orient=[NaN,NaN,NaN];

end

% TRACTSOUT=TRACTSOUT(1:t-1);
INFOOUT.n_count=length(TRACTSOUT);%t-1;

end

