function PET_matrix_MIBCA(out_PET,SUBJECT, jade,ctx_labels)

%Developed by A. Santos Ribeiro
%%%%

scans_PET=dir(out_PET);
aaa=1;

for i=1:length(scans_PET)
    temp_image=scans_PET(i).name;
    s_directory=[out_PET,temp_image,'/'];
    
    if ~((strcmp(temp_image,'.')) || (strcmp(temp_image,'..')) || (strcmp(temp_image,'.DS_Store')) || (~isempty(strfind(temp_image,'.mat'))))
        if strcmp(temp_image(1:4),'ZZZ_') || strcmp(temp_image(1:4),'AAA_')
            temp_image=temp_image(5:end);
        end
        %%% mean PET calculation
        
        output_merge_volume=[s_directory,'merge_rs_',temp_image,'.nii'];
        if ~exist(output_merge_volume)
            gunzip([output_merge_volume,'.gz'])
        end
        nii_PET_dinamic=load_untouch_nii(output_merge_volume);
        
        if ~exist([s_directory,'/aparc+aseg2PET.nii'])
            gunzip([s_directory,'/aparc+aseg2PET.nii','.gz'])
        end
        region_PET = load_untouch_nii([s_directory,'/aparc+aseg2PET.nii']);
        
        if ~exist([s_directory,'/sum_rs_',temp_image,'.nii'])
            gunzip([s_directory,'/sum_rs_',temp_image,'.nii','.gz'])
        end
        mean_PET = load_untouch_nii([s_directory,'/sum_rs_',temp_image,'.nii']);
        mean_PET=double(mean_PET.img);
        
% % %         toCalcSUV=[];
% % %         file_mat=dir([s_directory,'/*SUV_parameters.mat']);
% % %         if ~isempty(file_mat)
% % %             load([s_directory,'/',file_mat.name])
% % %         end
% % %         if ischar(toCalcSUV.decay_corr_fctr)
% % %             toCalcSUV.decay_corr_fctr=1;
% % %         end
% % %         mean_PET=mean_PET*(toCalcSUV.patient_weight*1000/(toCalcSUV.decay_corr_fctr.*toCalcSUV.dose_start_time));
% % %         nii_PET_dinamic.img=double(nii_PET_dinamic.img)*(toCalcSUV.patient_weight/(toCalcSUV.decay_corr_fctr.*toCalcSUV.dose_start_time))*1000;
        
%         mean_PET=mean_PET*(toCalcSUV.patient_weight/1000/49.6747);
        
        sel_label=ones(1,length(ctx_labels));
        [mean_X1_PET,ROI_zeros_PET,mean_activation,brain_X1_fdata]=measures_mean_jade_fmri_MIBCA (nii_PET_dinamic,region_PET,ctx_labels,sel_label,jade,mean_PET);
        
        SUVR_cerebellum=mean_activation(([ctx_labels{:,1}]==8) | ([ctx_labels{:,1}]==47));
        SUVR_cerebellum=mean(SUVR_cerebellum);
        mean_activation=mean_activation./SUVR_cerebellum;
        
        SUVR_cerebellum=mean_X1_PET(([ctx_labels{:,1}]==8) | ([ctx_labels{:,1}]==47),:);
        SUVR_cerebellum=mean(SUVR_cerebellum);
        mean_X1_PET=mean_X1_PET./repmat(SUVR_cerebellum,size(mean_X1_PET,1),1);
        
        h_mean_X1_PET.(['run',num2str(aaa)])=mean_X1_PET;
        
        ctx_labels(~any(mean_X1_PET==0,2),2)
        [mean_r_PET,mean_p_PET]=corrcoef(mean_X1_PET');
        m_PET_corr.(['run',num2str(aaa)])=mean_r_PET.*(mean_p_PET<0.05);
        m_PET_corr_thres.(['run',num2str(aaa)])=abs(mean_r_PET.*(mean_p_PET<0.05))>0;
        h_PET_pval.(['run',num2str(aaa)])=mean_p_PET;
        
        mean_pet_sub_data1a=mean_X1_PET(5,:);
        mean_pet_sub_data1b=mean_X1_PET(44,:);
        mean_pet_sub_data1c=mean_X1_PET(15,:);
        brain_X1=mean([mean_pet_sub_data1a',mean_pet_sub_data1b',mean_pet_sub_data1c'],2);
        %         brain_X1=brain_X1_fdata';
        %         brain_X1=mean(mean_X1_PET(~all(isnan(mean_p_PET)),:)',2);
        [mean_r_PET,mean_p_PET]=partialcorr(mean_X1_PET',brain_X1);
        m_PET_corr_regress.(['run',num2str(aaa)])=mean_r_PET.*(mean_p_PET<0.05);
        m_PET_corr_regress_thres.(['run',num2str(aaa)])=abs(mean_r_PET.*(mean_p_PET<0.05))>0;
        h_PET_pval_regress.(['run',num2str(aaa)])=mean_p_PET;
        
        %         h_PET_pval_bonf.(['run',num2str(aaa)])=mean_p_PET<(0.05/(size(mean_r_PET,1)*(size(mean_r_PET,1)-1)));
        %         m_PET_corr_bonf.(['run',num2str(aaa)])=(mean_r_PET.*h_PET_pval_bonf.(['run',num2str(aaa)]))>0;
        %%%
        
        %%% mean activation
        v_pet_SUV.(['run',num2str(aaa)])=mean_activation;
        figure,imagesc(mean_activation(mean_activation~=0))
%%%
        
        aaa=aaa+1;
        
    end
end
save([out_PET,SUBJECT,'_pet_data.mat'],...
    'm_PET_corr','m_PET_corr_thres','h_PET_pval',...
    'm_PET_corr_regress','m_PET_corr_regress_thres','h_PET_pval',...
    'h_mean_X1_PET','v_pet_SUV')

% % mean_PET_r=squeeze(sum(PET_r,3))/(aaa-1);
% % sum_PET_r_bonf=squeeze(sum(PET_r_bonf,3));
% % mean_pet_act=squeeze(sum(pet_act,2))/(aaa-1);
% % save([out_PET,SUBJECT,'_pet_data.mat'],'mean_PET_r','PET_r','PET_p','sum_PET_r_bonf','PET_r_bonf','PET_p_bonf',...
% %     'save_mean_X1_PET','mean_pet_act','pet_act')
