function [final_mean_thickness,final_mean_indx_label]=cortical_measures_analisys (sub_dir,sub_name,ctx_labels,measure_type)
%Developed by A. Santos Ribeiro
%%%%

addpath(genpath([sub_dir(1:end-9),'matlab/']));

if exist([sub_dir,sub_name,'/surf/lh.',measure_type]) && ...
        exist([sub_dir,sub_name,'/label/lh.aparc.annot']) && ...
        exist([sub_dir,sub_name,'/surf/rh.',measure_type]) && ...
        exist([sub_dir,sub_name,'/label/rh.aparc.annot'])
    
    subject_data_l.thickness=read_curv([sub_dir,sub_name,'/surf/lh.',measure_type]);
    [~, subject_data_l.label] =read_annotation([sub_dir,sub_name,'/label/lh.aparc.annot']);
    
    subject_data_r.thickness=read_curv([sub_dir,sub_name,'/surf/rh.',measure_type]);
    [~, subject_data_r.label] =read_annotation([sub_dir,sub_name,'/label/rh.aparc.annot']);
    
    temp_thickness=subject_data_l.thickness;
    temp_label=subject_data_l.label;
    mean_thickness=[];
    mean_label=[];
    mean_indx_label=[];
    while ~isempty(temp_thickness)
        check_label=temp_label(1);
        temp_mean_thickness=temp_thickness(temp_label==check_label);
        temp_mean_thickness=mean(temp_mean_thickness);
        mean_thickness=[mean_thickness,temp_mean_thickness];
        if ~isempty(find(cell2mat(ctx_labels(:,4))==check_label,1,'first'))
            mean_indx_label=[mean_indx_label,find(cell2mat(ctx_labels(:,4))==check_label,1,'first')];
        else
            mean_indx_label=[mean_indx_label,37];
        end
        temp_thickness(temp_label==check_label)=[];
        temp_label(temp_label==check_label)=[];
    end
    final_mean_thickness=mean_thickness;
    final_mean_indx_label=mean_indx_label;
    
    temp_thickness=subject_data_r.thickness;
    temp_label=subject_data_r.label;
    mean_thickness=[];
    mean_label=[];
    mean_indx_label=[];
    while ~isempty(temp_thickness)
        check_label=temp_label(1);
        temp_mean_thickness=temp_thickness(temp_label==check_label);
        temp_mean_thickness=mean(temp_mean_thickness);
        mean_thickness=[mean_thickness,temp_mean_thickness];
        if ~isempty(find(cell2mat(ctx_labels(:,4))==check_label,1,'last'))
            mean_indx_label=[mean_indx_label,find(cell2mat(ctx_labels(:,4))==check_label,1,'last')];
        else
            mean_indx_label=[mean_indx_label,1];
        end
        temp_thickness(temp_label==check_label)=[];
        temp_label(temp_label==check_label)=[];
    end
    final_mean_thickness=[final_mean_thickness,mean_thickness];
    final_mean_indx_label=[final_mean_indx_label,mean_indx_label];
end
end