function [mean_thickness]=cortical_measures_analisys (sub_dir,sub_name,ctx_labels,measure_type)
%Developed by A. Santos Ribeiro
%%%%

addpath(genpath([sub_dir(1:end-9),'matlab/']));

if exist([sub_dir,sub_name,'/surf/lh.',measure_type]) && ...
        exist([sub_dir,sub_name,'/label/lh.aparc.annot']) && ...
        exist([sub_dir,sub_name,'/surf/rh.',measure_type]) && ...
        exist([sub_dir,sub_name,'/label/rh.aparc.annot'])
    
    subject_data_l.thickness=read_curv([sub_dir,sub_name,'/surf/lh.',measure_type]);
    [~, subject_data_l.label] =read_annotation([sub_dir,sub_name,'/label/lh.aparc.annot']);
    
    subject_data_r.thickness=read_curv([sub_dir,sub_name,'/surf/rh.',measure_type]);
    [~, subject_data_r.label] =read_annotation([sub_dir,sub_name,'/label/rh.aparc.annot']);
    
    mean_thickness=zeros(length(ctx_labels),1);
    mean_thickness(mean_thickness==0)=NaN;
    
    temp_thickness=subject_data_l.thickness;
    temp_label=subject_data_l.label;
    while ~isempty(temp_thickness)
        check_label=temp_label(1);
        temp_mean_thickness=temp_thickness(temp_label==check_label);
        temp_mean_thickness=mean(temp_mean_thickness);
        if ~isempty(find(cell2mat(ctx_labels(:,4))==check_label,1,'first'))
            mean_thickness(find(cell2mat(ctx_labels(:,4))==check_label,1,'first'))=temp_mean_thickness;
        end
        temp_thickness(temp_label==check_label)=[];
        temp_label(temp_label==check_label)=[];
    end
    temp_thickness=subject_data_r.thickness;
    temp_label=subject_data_r.label;
    while ~isempty(temp_thickness)
        check_label=temp_label(1);
        temp_mean_thickness=temp_thickness(temp_label==check_label);
        temp_mean_thickness=mean(temp_mean_thickness);
        if ~isempty(find(cell2mat(ctx_labels(:,4))==check_label,1,'last'))
            mean_thickness(find(cell2mat(ctx_labels(:,4))==check_label,1,'last'))=temp_mean_thickness;
        end
        temp_thickness(temp_label==check_label)=[];
        temp_label(temp_label==check_label)=[];
    end
    
end
end