function  create_contrast_MIBCA_ICBM(all_data,output_directory,ctx_labels)

% database_txt = importdata('/disk2/afs13/ICBM_MNI/ICBM/contrast_ICBM.txt', ' ');
database_txt= table2cell(readtable('/disk2/afs13/ICBM_MNI/ICBM/contrast_ICBM.txt'));

% database_txt = importdata('/disk2/afs13/ADNI_dataset/database.txt', ' ');
for i=1:length(database_txt)
    contrast_txt{i,:}=strsplit(database_txt{i}, ' ');
end

%% if user wish to skip some subjects
% skip_subjs={'016_S_4009','127_S_4500','127_S_4940','007_S_4467','094_S_4858','126_S_4891','003_S_4354','016_S_4584','016_S_4646',...
%     '027_S_4757','027_S_4804','052_S_4626','057_S_4909','126_S_4507','126_S_4675','127_S_4210','003_S_4900','016_S_4121','016_S_4638','029_S_4279',...
%     '029_S_4290','029_S_4384','029_S_4385','029_S_4585','094_S_456','127_S_4198','127_S_4604'};
skip_subjs={};

%% Contrast loop without regression variables
subj_names=fieldnames(all_data);
aaa=1;
for i=1:length(subj_names)
    skip_subj=cellfun(@(C) ~isempty(strfind(subj_names{i},C)), skip_subjs);
    if ~any(skip_subj)
        
        pos=cellfun(@(C) ~isempty(strfind(subj_names{i},C{1})), contrast_txt, 'UniformOutput', 0);
        if any([pos{:}])
            contrast_data=contrast_txt{find([pos{:}])};
            if strcmp(contrast_data{2},'0') %MALE
                group1G.(subj_names{i})=all_data.(subj_names{i});
            elseif strcmp(contrast_data{2},'1') %FEMALE
                group2G.(subj_names{i})=all_data.(subj_names{i});
            end
            
            contrast_data=contrast_txt{find([pos{:}])};
            if strcmp(contrast_data{5},'0') %Youth
                group1A.(subj_names{i})=all_data.(subj_names{i});
            elseif strcmp(contrast_data{5},'1') %Middle Age
                group2A.(subj_names{i})=all_data.(subj_names{i});
            end
            
            aaa=aaa+1;
        end
    end
end
ttest_groups_MIBCA(group1G,group2G,output_directory,'Male-Female')
ttest_groups_MIBCA(group1A,group2A,output_directory,'Youth-MAge')
mean_groups_MIBCA(all_data,output_directory,'All')




%% contrast with regression variables

% % % subj_names=fieldnames(all_data);
% % % for i=1:length(subj_names)
% % %     pos=cellfun(@(C) ~isempty(strfind(subj_names{i},C{1})), contrast_txt, 'UniformOutput', 0);
% % %     if any([pos{:}])
% % %         contrast_indx=find([pos{:}]);
% % %         regress_vars(i,1)=1;
% % %         regress_vars(i,2)=str2num(contrast_txt{contrast_indx}{4});
% % %     else
% % %         subj_names{i}
% % %     end
% % % end
% % % 
% % % regress_all_data=regress_out_MIBCA(all_data,regress_vars);
% % % subj_names=fieldnames(regress_all_data);
% % % aaa=1;
% % % for i=1:length(subj_names)
% % %     skip_subj=cellfun(@(C) ~isempty(strfind(subj_names{i},C)), skip_subjs);
% % %     if ~any(skip_subj)
% % %         
% % %         pos=cellfun(@(C) ~isempty(strfind(subj_names{i},C{1})), contrast_txt, 'UniformOutput', 0);
% % %         if any([pos{:}])
% % %             contrast_data=contrast_txt{find([pos{:}])};
% % %             
% % %             if strcmp(contrast_data{2},'0') %MALE
% % %                 group1G_regress.(subj_names{i})=regress_all_data.(subj_names{i});
% % %             elseif strcmp(contrast_data{2},'1') %FEMALE
% % %                 group2G_regress.(subj_names{i})=regress_all_data.(subj_names{i});
% % %             end
% % %             aaa=aaa+1;
% % %         end
% % %     end
% % % end
% % % ttest_groups_MIBCA(group1G_regress,group2G_regress,output_directory,'Male-Female_regress')

end


function regress_all_data=regress_out_MIBCA(all_data,regress_vars)

subj_names1=fieldnames(all_data);
% [save_field_names]=get_data_fields(all_data.(subj_names1{1}),[],[]);
save_field_names={};
for i=1:length(subj_names1)
i_save_field_names=get_data_fields(all_data.(subj_names1{i}),[],[]);
save_field_names=[save_field_names,i_save_field_names{:}];
end
save_field_names=unique(save_field_names);


regress_all_data=[];

for k=1:length(save_field_names)
    save_all_data=[];
    fails=0;
    save_all_regress=regress_vars;
    for kk1=1:length(subj_names1)
        try
            new_all_data=eval(['all_data.(''',subj_names1{kk1},''')',save_field_names{k}]);
%             save_all_data(kk1-fails,:)=new_all_data(:);
            save_all_data(kk1,:)=new_all_data(:);
        catch
%             ['all_data.(''',subj_names1{kk1},''')',save_field_names{k}]
%             fails=fails+1;
% % %               save_all_data(kk1,:)=NaN(numel(new_all_data),1);
              save_all_regress(kk1,:)=NaN(size(save_all_regress(kk1,:)));
        end
        
        if (kk1==length(subj_names1)) && (size(save_all_data,1)~=length(subj_names1))
            save_all_data(length(subj_names1),:)=zeros(numel(new_all_data),1);
        end
        
    end
    %     save_all_regress(isnan(save_all_regress(:,1)),:)=[];
     
    warning('off','all');
    stats=[];
    for kk1=1:size(save_all_data,2)
        try
            if sum(save_all_data(:,kk1)==0)==length(save_all_data(:,kk1))
                save_all_data(:,kk1)=NaN;
            end

            temp_stats=regstats(save_all_data(:,kk1),save_all_regress,'quadratic','r');
            stats(:,kk1)=temp_stats.r;
            
%             eval(['regress_all_data.(''',subj_names1{kk1},''')',save_field_names{k},'=temp_stats.r;']);
    
        catch
            stats(:,kk1)=NaN(size(save_all_data,1),1);
        end
    end
    warning('on','all');
    
     for kk1=1:length(subj_names1)
         eval(['regress_all_data.(''',subj_names1{kk1},''')',save_field_names{k},'=reshape(stats(kk1,:),size(new_all_data));'])
     end
     
%     eval(['regress_all_data',save_field_names{k},'=stats;']);
    
            



    k
end

    function [save_field_names]=get_data_fields (temp_data,field_names,save_field_names)
        if isstruct(temp_data)
            temp_fields=fieldnames(temp_data);
            for j=1:length(temp_fields)
                if ~strcmp(temp_fields{j}(1:2),'h_')
                    field_names2=[field_names,'.(''',temp_fields{j},''')'];
                    temp_data2=temp_data.(temp_fields{j});
                    [save_field_names]=get_data_fields (temp_data2,field_names2,save_field_names);
                end
            end
        else
            if isempty(save_field_names)
                save_field_names{1}=field_names;
            else
                save_field_names{end+1}=field_names;
            end
        end
    end



end

function anova_groups_MIBCA(group1,contrast_var,output_directory,group_type)

subj_names1=fieldnames(group1);
[save_field_names]=get_data_fields(group1.(subj_names1{1}),[],[]);

groups_anova_diff_p=[];
for k=1:length(save_field_names)
    save_new_group1=[];
    fails=0;
    for kk1=1:length(subj_names1)
        try
            new_group=eval(['group1.(''',subj_names1{kk1},''')',save_field_names{k}]);
        catch
            ['group1.(''',subj_names1{kk1},''')',save_field_names{k}]
            fails=fails+1;
        end
        save_new_group1(kk1-fails,:)=new_group(:);
    end
    
    p=[];
    for aa1=1:size(save_new_group1,2)
        try
            [temp_p,table,stats]=anova1(save_new_group1(:,aa1),contrast_var','off');
            % % %             c = multcompare(stats,'display','off');
            % % %             if sign(c(1,3))~=sign(c(1,5))
            % % %                 stat(1,aa1)=(c(1,4))./(c(1,5)-c(1,3));
            % % %             end
            % % %             if sign(c(2,3))~=sign(c(2,5))
            % % %                 stat(2,aa1)=(c(2,4))./(c(2,5)-c(2,3));
            % % %             end
            % % %             if sign(c(3,3))~=sign(c(3,5))
            % % %                 stat(3,aa1)=(c(3,4))./(c(3,5)-c(3,3));
            % % %             end
            % % %             if sign(c(4,3))~=sign(c(4,5))
            % % %                 stat(4,aa1)=(c(4,4))./(c(4,5)-c(4,3));
            % % %             end
            % % %             if sign(c(5,3))~=sign(c(5,5))
            % % %                 stat(5,aa1)=(c(5,4))./(c(5,5)-c(5,3));
            % % %             end
            % % %             if sign(c(6,3))~=sign(c(6,5))
            % % %                 stat(6,aa1)=(c(6,4))./(c(6,5)-c(6,3));
            % % %             end
            p(aa1)=temp_p;
        catch
            p(aa1)=NaN;
        end
        
    end
    
    
    p=reshape(p,size(new_group));
    eval(['groups_anova_diff_p',save_field_names{k},'=p;']);
    k
end

groups_anova.diff_p=groups_anova_diff_p;
save([output_directory,'anova_groups_data2',group_type,'.mat'],'groups_anova','-v7.3');

    function [save_field_names]=get_data_fields (temp_data,field_names,save_field_names)
        if isstruct(temp_data)
            temp_fields=fieldnames(temp_data);
            for j=1:length(temp_fields)
                if ~strcmp(temp_fields{j}(1:2),'h_')
                    field_names2=[field_names,'.(''',temp_fields{j},''')'];
                    temp_data2=temp_data.(temp_fields{j});
                    [save_field_names]=get_data_fields (temp_data2,field_names2,save_field_names);
                end
            end
        else
            if isempty(save_field_names)
                save_field_names{1}=field_names;
            else
                save_field_names{end+1}=field_names;
            end
        end
    end



end

function mean_groups_MIBCA(group1,output_directory,group_type)

subj_names1=fieldnames(group1);

save_field_names={};
for i=1:length(subj_names1)
i_save_field_names=get_data_fields(group1.(subj_names1{i}),[],[]);
save_field_names=[save_field_names,i_save_field_names{:}];
end
save_field_names=unique(save_field_names);

groups_mean=[];
groups_std=[];

for k=1:length(save_field_names)
    save_new_group1=[];
    fails=0;
    for kk1=1:length(subj_names1)
        try
            new_group=eval(['group1.(''',subj_names1{kk1},''')',save_field_names{k}]);
            save_new_group1(kk1-fails,:)=new_group(:);
        catch
            ['group1.(''',subj_names1{kk1},''')',save_field_names{k}]
            fails=fails+1;
        end
        
    end
    
    try
    
    eval(['groups_mean',save_field_names{k},'=reshape(mean(save_new_group1),size(new_group));']);
    eval(['groups_std',save_field_names{k},'=reshape(std(save_new_group1),size(new_group));']);
    
    catch
        
    end
    
    k
end
group_mean.mean=groups_mean;
group_mean.std=groups_std;
save([output_directory,'mean_groups_data2',group_type,'.mat'],'group_mean','-v7.3');


    function [save_field_names]=get_data_fields (temp_data,field_names,save_field_names)
        if isstruct(temp_data)
            temp_fields=fieldnames(temp_data);
            for j=1:length(temp_fields)
                if ~strcmp(temp_fields{j}(1:2),'h_')
                    field_names2=[field_names,'.(''',temp_fields{j},''')'];
                    temp_data2=temp_data.(temp_fields{j});
                    [save_field_names]=get_data_fields (temp_data2,field_names2,save_field_names);
                end
            end
        else
            if isempty(save_field_names)
                save_field_names{1}=field_names;
            else
                save_field_names{end+1}=field_names;
            end
        end
    end



end

function ttest_groups_MIBCA(group1,group2,output_directory,group_type)
% output_directory='/home/afs13/Documents/data/ibeb_data/ADNI/';
% group1=load([output_directory,'results_23N_ISMRM2014/all_group_data.mat']);
% group2=load([output_directory,'results_15AD_ISMRM2014/all_group_data.mat']);

subj_names1=fieldnames(group1);
subj_names2=fieldnames(group2);

save_field_names={};
for i=1:length(subj_names1)
i_save_field_names=get_data_fields(group1.(subj_names1{i}),[],[]);
save_field_names=[save_field_names,i_save_field_names{:}];
end
for i=1:length(subj_names2)
i_save_field_names=get_data_fields(group2.(subj_names2{i}),[],[]);
save_field_names=[save_field_names,i_save_field_names{:}];
end
save_field_names=unique(save_field_names);

groups_mean1=[];
groups_mean2=[];
groups_std1=[];
groups_std2=[];
groups_ttest=[];
groups_ttest_r_p=[];
groups_ttest_l_p=[];
groups_ttest_diff_p=[];
groups_ttest_diff_p_c=[];
groups_ttest_r_h=[];
groups_ttest_l_h=[];
groups_ttest_diff_h=[];
groups_ttest_r_stat=[];
groups_ttest_l_stat=[];
groups_ttest_diff_stat=[];
groups_ttest_r_stat_c=[];
groups_ttest_l_stat_c=[];
groups_ttest_diff_stat_c=[];

for k=1:length(save_field_names)
    save_new_group1=[];
    save_new_group2=[];
    fails=0;
    for kk1=1:length(subj_names1)
        try
            new_group=eval(['group1.(''',subj_names1{kk1},''')',save_field_names{k}]);
            save_new_group1(kk1-fails,:)=new_group(:);
        catch
            ['group1.(''',subj_names1{kk1},''')',save_field_names{k}]
            fails=fails+1;
        end
        
    end
    fails=0;
    for kk1=1:length(subj_names2)
        try
            new_group=eval(['group2.(''',subj_names2{kk1},''')',save_field_names{k}]);
            save_new_group2(kk1-fails,:)=new_group(:);
        catch
            ['group2.(''',subj_names2{kk1},''')',save_field_names{k}]
            fails=fails+1;
        end
        
    end
    
    %         raw_test=zeros(1,size(save_new_group1,2));
    %         for i=1:size(save_new_group1,2)
    %             if ~(any(isnan(save_new_group1(:,i))) || any(isnan(save_new_group2(:,i))))
    %                 [~,raw_test(i)] = ranksum(save_new_group1(:,i),save_new_group2(:,i),'Tail','right');
    %             end
    %         end
    try
    
    eval(['groups_mean1',save_field_names{k},'=mean(save_new_group1);']);
    eval(['groups_mean2',save_field_names{k},'=mean(save_new_group2);']);
    eval(['groups_std1',save_field_names{k},'=std(save_new_group1);']);
    eval(['groups_std2',save_field_names{k},'=std(save_new_group2);']);
      
    [h,p,~,stat]=ttest2(save_new_group1,save_new_group2,'Tail','right','Alpha',0.01);
    stat=stat.tstat;
    stat_c=stat;
    stat_c(p>0.01)=NaN;
    %     if sqrt(size(save_new_group2,2))==114
    %         stat_c(p>(0.1/114))=NaN;
    %     end
    %     stat_c(h==0)=NaN;
    %     stat_c(isnan(h))=NaN;
    h=reshape(h,size(new_group));
    p=reshape(p,size(new_group));
    stat=reshape(stat,size(new_group));
    stat_c=reshape(stat_c,size(new_group));
    eval(['groups_ttest_r_h',save_field_names{k},'=h;']);
    eval(['groups_ttest_r_p',save_field_names{k},'=p;']);
    eval(['groups_ttest_r_stat',save_field_names{k},'=stat;']);
    eval(['groups_ttest_r_stat_c',save_field_names{k},'=stat_c;']);
    
    [h,p,~,stat]=ttest2(save_new_group1,save_new_group2,'Tail','left','Alpha',0.01);
    stat=stat.tstat;
    stat_c=stat;
    stat_c(p>0.01)=NaN;
    %     if sqrt(size(save_new_group2,2))==114
    %         stat_c(p>(0.1/114))=NaN;
    %     end
    %     stat_c(h==0)=NaN;
    %     stat_c(isnan(h))=NaN;
    h=reshape(h,size(new_group));
    p=reshape(p,size(new_group));
    stat=reshape(stat,size(new_group));
    stat_c=reshape(stat_c,size(new_group));
    eval(['groups_ttest_l_h',save_field_names{k},'=h;']);
    eval(['groups_ttest_l_p',save_field_names{k},'=p;']);
    eval(['groups_ttest_l_stat',save_field_names{k},'=stat;']);
    eval(['groups_ttest_l_stat_c',save_field_names{k},'=stat_c;']);
    
    [h,p,~,stat]=ttest2(save_new_group1,save_new_group2,'Alpha',0.10,'Vartype','unequal');
    stat=stat.tstat;
    
    %             stat=[];
    %             p=[];
    %             h=[];
    %             for aa1=1:size(save_new_group2,2)
    %                 try
    %                     [p(aa1),h(aa1),temp_stat] = ranksum(save_new_group1(:,aa1),save_new_group2(:,aa1),'Alpha',0.1,'method','approximate');
    %                     stat(aa1).ranksum=temp_stat.ranksum;
    %                     stat(aa1).zval=temp_stat.zval;
    %                 catch
    %                     p(aa1)=NaN;
    %                     h(aa1)=NaN;
    %                     stat(aa1).ranksum=NaN;
    %                     stat(aa1).zval=NaN;
    %                 end
    %             end
    %             stat=[stat.zval];
    
    stat_c=stat;
    stat_c(p>0.10)=NaN;
    
    p_c=p;
    p_c(p>0.10)=NaN;
    p_c=p_c.*sign(stat_c);
    
    h=sign(stat_c);
    
    p=p.*sign(stat);
    
    h=reshape(h,size(new_group));
    p=reshape(p,size(new_group));
    p_c=reshape(p_c,size(new_group));
    stat=reshape(stat,size(new_group));
    stat_c=reshape(stat_c,size(new_group));
    eval(['groups_ttest_diff_h',save_field_names{k},'=h;']);
    eval(['groups_ttest_diff_p',save_field_names{k},'=p;']);
    eval(['groups_ttest_diff_p_c',save_field_names{k},'=p_c;']);
    eval(['groups_ttest_diff_stat',save_field_names{k},'=stat;']);
    eval(['groups_ttest_diff_stat_c',save_field_names{k},'=stat_c;']);
    
    catch
        
    end
    
    k
end
groups_mean.mean1=groups_mean1;
groups_mean.mean2=groups_mean2;
groups_mean.std1=groups_std1;
groups_mean.std2=groups_std2;
save([output_directory,'mean_groups_data2',group_type,'.mat'],'groups_mean','-v7.3');


groups_ttest.r_h=groups_ttest_r_h;
groups_ttest.r_p=groups_ttest_r_p;
groups_ttest.r_stat=groups_ttest_r_stat;
groups_ttest.r_stat_c=groups_ttest_r_stat_c;
groups_ttest.l_h=groups_ttest_l_h;
groups_ttest.l_p=groups_ttest_l_p;
groups_ttest.l_stat=groups_ttest_l_stat;
groups_ttest.l_stat_c=groups_ttest_l_stat_c;
groups_ttest.diff_h=groups_ttest_diff_h;
groups_ttest.diff_p=groups_ttest_diff_p;
groups_ttest.diff_p_c=groups_ttest_diff_p_c;
groups_ttest.diff_stat=groups_ttest_diff_stat;
groups_ttest.diff_stat_c=groups_ttest_diff_stat_c;
save([output_directory,'ttest_groups_data2',group_type,'.mat'],'groups_ttest','-v7.3');

    function [save_field_names]=get_data_fields (temp_data,field_names,save_field_names)
        if isstruct(temp_data)
            temp_fields=fieldnames(temp_data);
            for j=1:length(temp_fields)
                if ~strcmp(temp_fields{j}(1:2),'h_')
                    field_names2=[field_names,'.(''',temp_fields{j},''')'];
                    temp_data2=temp_data.(temp_fields{j});
                    [save_field_names]=get_data_fields (temp_data2,field_names2,save_field_names);
                end
            end
        else
            if isempty(save_field_names)
                save_field_names{1}=field_names;
            else
                save_field_names{end+1}=field_names;
            end
        end
    end



end


