function  create_contrast_MIBCA_orig(all_data,output_directory,ctx_labels)

database_txt = importdata('/disk2/afs13/ADNI_dataset/database.txt', ' ');
for i=1:length(database_txt)
    contrast_txt{i,:}=strsplit(database_txt{i}, ' ');
end

subj_names=fieldnames(all_data);
for i=1:length(subj_names)
    pos=cellfun(@(C) ~isempty(strfind(subj_names{i},C{1})), contrast_txt, 'UniformOutput', 0);
    
    if any([pos{:}])
        contrast_data=contrast_txt{find([pos{:}])};
        
        if strcmp(contrast_data{6},'Normal')
            group1.(subj_names{i})=all_data.(subj_names{i});
        elseif strcmp(contrast_data{6},'EMCI')
            group2.(subj_names{i})=all_data.(subj_names{i});
        elseif strcmp(contrast_data{6},'LMCI')
            group3.(subj_names{i})=all_data.(subj_names{i});
        elseif strcmp(contrast_data{6},'AD')
            group4.(subj_names{i})=all_data.(subj_names{i});
        end
    end
end
clear all_data

ttest_groups_MIBCA(group1,group2,output_directory,'H-EMCI')
ttest_groups_MIBCA(group1,group3,output_directory,'H-LMCI')
ttest_groups_MIBCA(group1,group4,output_directory,'H-AD')

ttest_groups_MIBCA(group2,group3,output_directory,'EMCI-LMCI')
ttest_groups_MIBCA(group2,group4,output_directory,'EMCI-AD')

ttest_groups_MIBCA(group3,group4,output_directory,'LMCI-AD')
end



function ttest_groups_MIBCA(group1,group2,output_directory,group_type)
% output_directory='/home/afs13/Documents/data/ibeb_data/ADNI/';
% group1=load([output_directory,'results_23N_ISMRM2014/all_group_data.mat']);
% group2=load([output_directory,'results_15AD_ISMRM2014/all_group_data.mat']);

subj_names1=fieldnames(group1);
subj_names2=fieldnames(group2);
[save_field_names]=get_data_fields(group1.(subj_names1{1}),[],[]);

groups_ttest=[];
groups_ttest_r_p=[];
groups_ttest_l_p=[];
groups_ttest_diff_p=[];
groups_ttest_r_h=[];
groups_ttest_l_h=[];
groups_ttest_diff_h=[];
groups_ttest_r_stat=[];
groups_ttest_l_stat=[];
groups_ttest_diff_stat=[];
groups_ttest_r_stat_c=[];
groups_ttest_l_stat_c=[];
groups_ttest_diff_stat_c=[];

for k=1:length(save_field_names)
    save_new_group1=[];
    save_new_group2=[];
    fails=0;
    for kk1=1:length(subj_names1)
        try
        new_group=eval(['group1.(''',subj_names1{kk1},''')',save_field_names{k}]);
        catch
            ['group1.(''',subj_names1{kk1},''')',save_field_names{k}]
            fails=fails+1;
        end
        save_new_group1(kk1-fails,:)=new_group(:);
        
    end
    fails=0;
    for kk1=1:length(subj_names2)
        try
            new_group=eval(['group2.(''',subj_names2{kk1},''')',save_field_names{k}]);
        catch
            ['group2.(''',subj_names2{kk1},''')',save_field_names{k}]
            fails=fails+1;
        end
        save_new_group2(kk1-fails,:)=new_group(:);
        
    end
    
    %         raw_test=zeros(1,size(save_new_group1,2));
    %         for i=1:size(save_new_group1,2)
    %             if ~(any(isnan(save_new_group1(:,i))) || any(isnan(save_new_group2(:,i))))
    %                 [~,raw_test(i)] = ranksum(save_new_group1(:,i),save_new_group2(:,i),'Tail','right');
    %             end
    %         end
    [h,p,~,stat]=ttest2(save_new_group1,save_new_group2,'Tail','right','Alpha',0.1);
    stat=stat.tstat;
    stat_c=stat;
    stat_c(h==0)=NaN;
    stat_c(isnan(h))=NaN;
    h=reshape(h,size(new_group));
    p=reshape(p,size(new_group));
    stat=reshape(stat,size(new_group));
    stat_c=reshape(stat_c,size(new_group));
    eval(['groups_ttest_r_h',save_field_names{k},'=h;']);
    eval(['groups_ttest_r_p',save_field_names{k},'=p;']);
    eval(['groups_ttest_r_stat',save_field_names{k},'=stat;']);
    eval(['groups_ttest_r_stat_c',save_field_names{k},'=stat_c;']);
    
    %       figure,imagesc(save_new_group2(:,~all(save_new_group2==0)))
    %     figure,imagesc(save_new_group1(:,~all(save_new_group1==0)))
    
    %         raw_test=zeros(1,size(save_new_group1,2));
    %         for i=1:size(save_new_group1,2)
    %             if ~(any(isnan(save_new_group1(:,i))) || any(isnan(save_new_group2(:,i))))
    %                 [~,raw_test(i)] = ranksum(save_new_group1(:,i),save_new_group2(:,i),'Tail','left');
    %             end
    %         end
    [h,p,~,stat]=ttest2(save_new_group1,save_new_group2,'Tail','left','Alpha',0.1);
    stat=stat.tstat;
    stat_c=stat;
    stat_c(h==0)=NaN;
    stat_c(isnan(h))=NaN;
    h=reshape(h,size(new_group));
    p=reshape(p,size(new_group));
    stat=reshape(stat,size(new_group));
    stat_c=reshape(stat_c,size(new_group));
    eval(['groups_ttest_l_h',save_field_names{k},'=h;']);
    eval(['groups_ttest_l_p',save_field_names{k},'=p;']);
    eval(['groups_ttest_l_stat',save_field_names{k},'=stat;']);
    eval(['groups_ttest_l_stat_c',save_field_names{k},'=stat_c;']);
    
    [h,p,~,stat]=ttest2(save_new_group1,save_new_group2,'Alpha',0.1);
    stat=stat.tstat;
    stat_c=stat;
    stat_c(h==0)=NaN;
    stat_c(isnan(h))=NaN;
    h=reshape(h,size(new_group));
    p=reshape(p,size(new_group));
    stat=reshape(stat,size(new_group));
    stat_c=reshape(stat_c,size(new_group));
    eval(['groups_ttest_diff_h',save_field_names{k},'=h;']);
    eval(['groups_ttest_diff_p',save_field_names{k},'=p;']);
    eval(['groups_ttest_diff_stat',save_field_names{k},'=stat;']);
    eval(['groups_ttest_diff_stat_c',save_field_names{k},'=stat_c;']);
    
    k
end

groups_ttest.r_h=groups_ttest_r_h;
groups_ttest.r_p=groups_ttest_r_p;
groups_ttest.r_stat=groups_ttest_r_stat;
groups_ttest.r_stat_c=groups_ttest_r_stat_c;
groups_ttest.l_h=groups_ttest_l_h;
groups_ttest.l_p=groups_ttest_l_p;
groups_ttest.l_stat=groups_ttest_l_stat;
groups_ttest.l_stat_c=groups_ttest_l_stat_c;
groups_ttest.diff_h=groups_ttest_diff_h;
groups_ttest.diff_p=groups_ttest_diff_p;
groups_ttest.diff_stat=groups_ttest_diff_stat;
groups_ttest.diff_stat_c=groups_ttest_diff_stat_c;
save([output_directory,'ttest_groups_data2',group_type,'.mat'],'groups_ttest','-v7.3');

    function [save_field_names]=get_data_fields (temp_data,field_names,save_field_names)
        if isstruct(temp_data)
            temp_fields=fieldnames(temp_data);
            for j=1:length(temp_fields)
                if ~strcmp(temp_fields{j}(1:2),'h_')
                    field_names2=[field_names,'.(''',temp_fields{j},''')'];
                    temp_data2=temp_data.(temp_fields{j});
                    [save_field_names]=get_data_fields (temp_data2,field_names2,save_field_names);
                end
            end
        else
            if isempty(save_field_names)
                save_field_names{1}=field_names;
            else
                save_field_names{end+1}=field_names;
            end
        end
    end



end


