function dicom2nii_PET_MIBCA(type_subdirectory,out_type,system_initialization,dcm2nii_dir)
%Developed by A. Santos Ribeiro
%%%%

check_directories=genpath(type_subdirectory);
recursive_directories=strsplit(check_directories,':');
indx_t=cellfun(@(C) ~isempty(C), recursive_directories,'UniformOutput',false);
recursive_directories=recursive_directories(cell2mat(indx_t));

for i=1:length(recursive_directories)
    indx_t=cellfun(@(C) strfind(recursive_directories{i},C),...
        recursive_directories,'UniformOutput',false);
    indx_t=cell2mat(cellfun(@(C) ~isempty(C),indx_t,'UniformOutput',false));
    indx_t2=cell2mat(cellfun(@(C) ~strcmp(recursive_directories{i},C),...
        recursive_directories,'UniformOutput',false));
    if i==1
        indx_tt=(indx_t&indx_t2);
    else
        indx_tt=indx_tt|(indx_t&indx_t2);
    end
end
recursive_directories(indx_tt)=[];

[~,indx_t]=sort(cell2mat(cellfun(@(C) length(C), recursive_directories,'UniformOutput',false)));
recursive_directories=recursive_directories(indx_t(end:-1:1));



for i=1:length(recursive_directories)
    
    file_dcm=dir([recursive_directories{i},'/*.dcm']);
    file_nii=dir([recursive_directories{i},'/*.nii']);
    file_niigz=dir([recursive_directories{i},'/*.nii.gz']);
    file_ecat=dir([recursive_directories{i},'/*.v']);
    file_analyse=dir([recursive_directories{i},'/*.img']);
    file_i=dir([recursive_directories{i},'/*.i']);
    
    if size(file_dcm,1)~=0
        if strcmp(recursive_directories{i}(end),'/'), recursive_directories{i}=recursive_directories{i}(1:end-1);end
        system([dcm2nii_dir,'/dcm2nii -d n -e y -f n -p n -r n -o ',...
            out_type,' ', recursive_directories{i}]);
        
        header_dcm = dicominfo([recursive_directories{i},'/',file_dcm(1).name]);
        toCalcSUV = [];
        toCalcSUV.patient_weight = header_dcm.PatientWeight;
        toCalcSUV.dose_start_time = header_dcm.RadiopharmaceuticalInformationSequence.Item_1.RadionuclideTotalDose;
%         toCalcSUV.decay_corr_fctr=header_dcm.DecayFactor;
%         toCalcSUV.corr_factor=(toCalcSUV.patient_weight/(toCalcSUV.decay_corr_fctr.*toCalcSUV.dose_start_time))*1000;
%         save([out_type, 'SUV_parameters.mat'],'toCalcSUV');
        
    elseif size(file_nii,1)~=0
        for j=1:length(file_nii)
            cut_file_nii=file_nii(j).name;
            cut_file_nii=cut_file_nii(1:end-4);
            mkdir(out_type,cut_file_nii)
            
            copyfile ([recursive_directories{i},'/',cut_file_nii,'.nii'], [out_type,cut_file_nii,'/', cut_file_nii,'.nii'])
            gzip([out_type,cut_file_nii,'/', cut_file_nii,'.nii'])
            delete([out_type,cut_file_nii,'/', cut_file_nii,'.nii'])
        end
        
    elseif size(file_niigz,1)~=0
         for j=1:length(file_nii)
            cut_file_nii=file_nii(j).name;
            cut_file_nii=cut_file_nii(1:end-7);
            mkdir(out_type,cut_file_nii)
            
            copyfile ([recursive_directories{i},'/',cut_file_nii,'.nii.gz'], [out_type,cut_file_nii,'/', cut_file_nii,'.nii.gz'])
        end
    
    elseif  size(file_ecat,1)~=0
        for j=1:length(file_ecat)
            cut_file_ecat=file_ecat(j).name;
            cut_file_ecat=cut_file_ecat(1:end-2);
            cur_dir=pwd;
            mkdir(out_type,cut_file_ecat)
            %%%%
%             cd ([out_type,cut_file_ecat])
%                         opts.ext='nii';
%                         spm_ecat2nifti([recursive_directories{i},'/',file_ecat(j).name],opts)
%             cd (cur_dir)
%             %%%
            [petdata, petscaninfo, hd]=loadecat([recursive_directories{i},'/',file_ecat(j).name]);
            save_nii(make_nii(petdata, petscaninfo.pixsize,...
                [petscaninfo.pixsize(2)*size(petdata,2)/2 ...
                petscaninfo.pixsize(1)*size(petdata,1)/2 ...
                petscaninfo.pixsize(3)*size(petdata,3)/2]),...
                [out_type,cut_file_ecat,'/',cut_file_ecat,'.nii.gz']);
            %%%
            
            toCalcSUV = [];
            toCalcSUV.patient_weight = hd.mh.patient_weight;
            toCalcSUV.dose_start_time = hd.mh.dosage;
            toCalcSUV.decay_corr_fctr = hd.sh.decay_corr_fctr;
            toCalcSUV.corr_factor=(toCalcSUV.patient_weight/(toCalcSUV.decay_corr_fctr.*toCalcSUV.dose_start_time))*1000;
            save([out_type, 'SUV_parameters.mat'],'toCalcSUV');
        
        end
        
    elseif size(file_analyse,1)~=0
        for j=1:length(file_analyse)
            cut_file_analyse=file_analyse(j).name;
            cut_file_analyse=cut_file_analyse(1:end-4);
            mkdir(out_type,cut_file_analyse)
            
            mri_convert_images=['mri_convert ',recursive_directories{i},'/',file_analyse(j).name, ' ', out_type,cut_file_analyse,'/', cut_file_analyse,'.nii.gz'];
            system([system_initialization, mri_convert_images])
        end
    
    elseif size(file_i,1)~=0
    
        for j=1:length(file_i)
        cut_file_i=file_i(j).name;
        cut_file_i=cut_file_i(1:end-2);
        
        fileID = fopen([recursive_directories{i},'/',file_i(j).name], 'r');
        A = fread(fileID,inf,'float');
        new_A=reshape(A,[256,256,207]);
        new_A_4d(:,:,:,j)=new_A;
        end
        mkdir(out_type,cut_file_i)
        nii = make_nii(new_A_4d,[1.218750,1.218750,1.218750]);
        save_nii(nii, [out_type,'/',cut_file_i,'.nii.gz'])
        movefile([out_type,'/',cut_file_i,'.nii.gz'], [out_type,'/',cut_file_i,'/',cut_file_i,'.nii.gz'])

    end
    file_mat=dir([recursive_directories{i},'/*SUV_parameters.mat']);
    if ~isempty(file_mat)
        copyfile([recursive_directories{i},'/',file_mat.name],out_type)
    end
    
end

scans_type=dir([out_type,'*.nii.gz*']);
for i=1:length(scans_type)
    temp_image=scans_type(i).name;
    s_directory=[out_type,temp_image];
    if ~((strcmp(temp_image,'.')) || (strcmp(temp_image,'..')) || (strcmp(temp_image,'.DS_Store')))
        
        mkdir(s_directory(1:end-7))
        movefile([s_directory(1:end-6),'*'],[s_directory(1:end-7),'/'])
        
    end
end

end





















