function diffest_MIBCA(out_DTI,system_initialization)
%Developed by A. Santos Ribeiro
%%%%

scans_DTI=dir(out_DTI);
scans_DTI=struct2cell(scans_DTI);
scans_DTI=scans_DTI(1,:)';
scans_DTI_temp=cell2mat(cellfun(@(C) strcmp(C,'..'), scans_DTI, 'UniformOutput', false));
scans_DTI_temp=scans_DTI_temp | cell2mat(cellfun(@(C) strcmp(C,'.'), scans_DTI, 'UniformOutput', false));
scans_DTI_temp=scans_DTI_temp | cell2mat(cellfun(@(C) strcmp(C,'.DS_Store'), scans_DTI, 'UniformOutput', false));
scans_DTI=scans_DTI(~scans_DTI_temp);
for i=1:length(scans_DTI)
    
    temp_image=scans_DTI{i};
    s_directory=[out_DTI,temp_image,'/'];
    
    if isdir(s_directory)
        %%% Variables initiation for diffusion images
        dti_name_nii=[s_directory,'eddy_',temp_image];
        dti_out_directory=[s_directory,'dti'];
        try
            dti_gradient_table=ls([s_directory,'*.bvec']);
        catch
            error('A *.bvec file must be provided.')
        end
        dti_gradient_table=dti_gradient_table(1:end-1);
        
        %dti_recon_string=['dti_recon "',dti_name_nii,'" "', dti_out_directory,...
        %    '" -gm "',dti_gradient_table,'" -b 1000 -b0 5 -oc -p 3 -sn 1 -ot nii'];
        
        dti_bval=dlmread([s_directory,temp_image,'.bval']);
        
        dti_recon_string=['dti_recon "',dti_name_nii,'" "', dti_out_directory,...
            '" -gm "',dti_gradient_table,'" -b ',num2str(max(dti_bval(:))),' -b0 auto -p 3 -sn 1 -ot nii'];
        
        %%% Diffussion images estimation
        s=system(['bash -c ',system_initialization,dti_recon_string]);
    end
end

end
