function difftract_MIBCA(out_DTI,system_initialization,use_detect,str_inv,str_swap)
%Developed by A. Santos Ribeiro
%%%%

scans_DTI=dir(out_DTI);
scans_DTI=struct2cell(scans_DTI);
scans_DTI=scans_DTI(1,:)';
scans_DTI_temp=cell2mat(cellfun(@(C) strcmp(C,'..'), scans_DTI, 'UniformOutput', false));
scans_DTI_temp=scans_DTI_temp | cell2mat(cellfun(@(C) strcmp(C,'.'), scans_DTI, 'UniformOutput', false));
scans_DTI_temp=scans_DTI_temp | cell2mat(cellfun(@(C) strcmp(C,'.DS_Store'), scans_DTI, 'UniformOutput', false));
scans_DTI=scans_DTI(~scans_DTI_temp);
for i=1:length(scans_DTI)
    
    temp_image=scans_DTI{i};
    s_directory=[out_DTI,temp_image,'/'];
    
    if isdir(s_directory)
        %%% Variables initiation for tractography estimation
        dti_out_directory=[s_directory,'dti'];
        dti_track_temp=[s_directory,'track_tmp.trk'];
        
        if use_detect==1
            inver_dti={'','-ix','-iy','-iz'};
            swap_dti={'','-sxy','-szx','-syz'};
            for kkk=1:length(inver_dti)
                for kkk2=1:length(swap_dti)
                    dti_tracker_string=['dti_tracker "',dti_out_directory,'" "',dti_track_temp,...
                        '" -at 35 ',inver_dti{kkk},' ', swap_dti{kkk2},' -m "',s_directory,'dti_dwi.nii" -m2 "',s_directory,'aparc+aseg2DTI.nii" 0.01 10000 -it nii']; %%% FACT algorithm
                    
                    %Tractography estimation
                    if ~exist([s_directory,inver_dti{kkk},'_',swap_dti{kkk2},'_dti.trk'])
                        s=system(['bash -c ',system_initialization,dti_tracker_string]);
                        movefile([s_directory,'track_tmp.trk'], [s_directory,inver_dti{kkk},'_',swap_dti{kkk2},'_dti.trk'])
                    end
                    
                    [INFO, TRACTS]=Readtrk([s_directory,inver_dti{kkk},'_',swap_dti{kkk2},'_dti.trk']);
                    [TRACTS]=NBL_tractsFOV2MTX(INFO,TRACTS);
                    n_count    = INFO.n_count;
                    TRACTSOUT=cell(n_count,1);
                    f_length_t=cellfun(@diff,TRACTS,'UniformOutput',0);
                    f_length=cellfun(@times,f_length_t,f_length_t,'UniformOutput',0);
                    f_length=cellfun(@transpose,f_length,'UniformOutput',0);
                    f_length=cellfun(@sum,f_length,'UniformOutput',0);
                    f_length=cellfun(@sqrt,f_length,'UniformOutput',0);
                    f_length=cellfun(@sum,f_length,'UniformOutput',0);
                    
                    total_fibre(kkk,kkk2)=sum(cell2mat(f_length)>25);
                end
            end
            [~,indx]=max(total_fibre(:));
            [indx_x,indx_y]=ind2sub([4,4],indx);
            %dlmwrite([s_directory,'inversions_table.txt'],[indx_x,indx_y],'-append')
            dti_spline_filter_string=['spline_filter "',s_directory,inver_dti{indx_x},'_',swap_dti{indx_y},'_dti.trk" 1 "',s_directory,'dti.trk"'];
        else
            inver_dti='';
            swap_dti='';
            if str_inv==2,inver_dti='ix';end
            if str_inv==3,inver_dti='iy';end
            if str_inv==4,inver_dti='iz';end
            if str_swap==2,swap_dti='-sxy';end
            if str_swap==3,swap_dti='-syz';end
            if str_swap==4,swap_dti='-szx';end
            
            dti_tracker_string=['dti_tracker "',dti_out_directory,'" "',dti_track_temp,...
                '" -at 35 ',inver_dti,' ', swap_dti,' -m "',s_directory,'dti_dwi.nii" -m2 "',s_directory,'aparc+aseg2DTI.nii" 0.01 10000 -it nii']; %%% FACT algorithm
            s=system(['bash -c ',system_initialization,dti_tracker_string]);
            movefile([s_directory,'track_tmp.trk'], [s_directory,inver_dti,'_',swap_dti,'_dti.trk'])
            dti_spline_filter_string=['spline_filter "',s_directory,inver_dti,'_',swap_dti,'_dti.trk" 1 "',s_directory,'dti.trk"'];
        end
        s=system(['bash -c ',system_initialization,dti_spline_filter_string]);
    end
    
end
end

