function dti_matrix_MIBCA(out_DTI,SUBJECT,ctx_labels)
%Developed by A. Santos Ribeiro
%%%%

scans_DTI=dir(out_DTI);
scans_DTI=struct2cell(scans_DTI);
isdir_DTI=scans_DTI(4,:)';
scans_DTI=scans_DTI(1,:)';

scans_DTI_temp=cell2mat(cellfun(@(C) strcmp(C,'..'), scans_DTI, 'UniformOutput', false));
scans_DTI_temp=scans_DTI_temp | cell2mat(cellfun(@(C) strcmp(C,'.'), scans_DTI, 'UniformOutput', false));
scans_DTI_temp=scans_DTI_temp | cell2mat(cellfun(@(C) strcmp(C,'.DS_Store'), scans_DTI, 'UniformOutput', false));

scans_DTI_temp=scans_DTI_temp | (~cell2mat(isdir_DTI));
scans_DTI=scans_DTI(~scans_DTI_temp);
aaa=1;
for i=1:length(scans_DTI)
    
    temp_image=scans_DTI{i};
    s_directory=[out_DTI,temp_image,'/'];
    
    if strcmp(temp_image(1:4),'ZZZ_') || strcmp(temp_image(1:4),'AAA_')
            temp_image=temp_image(5:end);
    end
    
    %Fibre matrix calculation
    if ~exist([s_directory,'/aparc+aseg2DTI.nii'])
            gunzip([s_directory,'/aparc+aseg2DTI.nii','.gz'])
    end
    region_DTI= load_untouch_nii([s_directory,'aparc+aseg2DTI.nii']);
    [INFO, TRACTS]=Readtrk([s_directory,'dti.trk']);
    [TRACTS]=NBL_tractsFOV2MTX(INFO,TRACTS);
    
    if ~exist([s_directory,'/dti_fa.nii'])
            gunzip([s_directory,'/dti_fa.nii','.gz'])
    end
    FA_DTI= load_untouch_nii([s_directory,'dti_fa.nii']);
    FA_DTI=FA_DTI.img;
    
    if ~exist([s_directory,'/dti_e1.nii'])
            gunzip([s_directory,'/dti_e1.nii','.gz'])
    end
    if ~exist([s_directory,'/dti_e2.nii'])
            gunzip([s_directory,'/dti_e2.nii','.gz'])
    end
    if ~exist([s_directory,'/dti_e3.nii'])
            gunzip([s_directory,'/dti_e3.nii','.gz'])
    end
    e1_DTI= load_untouch_nii([s_directory,'dti_e1.nii']);
    e2_DTI= load_untouch_nii([s_directory,'dti_e2.nii']);
    e3_DTI= load_untouch_nii([s_directory,'dti_e3.nii']);
    MD_DTI=(e1_DTI.img+e2_DTI.img+e3_DTI.img)/3;
    
    sel_label=ones(1,length(ctx_labels));
    type=1;
    [fiber_matrix,ROI_zeros_DTI,f_length,f_orient,MD_vector,FA_vector]=dti_measures_analisys_MIBCA(INFO,TRACTS,region_DTI,ctx_labels,sel_label,type,FA_DTI,MD_DTI);
    
    fiber_matrix=(fiber_matrix+fiber_matrix').*(~eye(size(fiber_matrix,1),size(fiber_matrix,2)));
% % %     fiber_matrix(fiber_ma trix==0)=NaN;
    m_dti_fiber.(['run',num2str(aaa)])=fiber_matrix;
    m_dti_fiber_thres.(['run',num2str(aaa)])=fiber_matrix>0;
    m_dti_fiber_Lnorm.(['run',num2str(aaa)])=fiber_matrix./repmat(sum(fiber_matrix,2),1,size(fiber_matrix,2));
    m_dti_fiber_Gnorm.(['run',num2str(aaa)])=fiber_matrix./sum(fiber_matrix(:));
    
    
    f_length=f_length+f_length'.*(~eye(size(fiber_matrix,1),size(fiber_matrix,2)));
    f_length(f_length==0)=NaN;
    m_dti_length.(['run',num2str(aaa)])=f_length;
    
    f_orient(:,:,1)=f_orient(:,:,1)+f_orient(:,:,1)'.*(~eye(size(fiber_matrix,1),size(fiber_matrix,2)));
    f_orient(:,:,2)=f_orient(:,:,2)+f_orient(:,:,2)'.*(~eye(size(fiber_matrix,1),size(fiber_matrix,2)));
    f_orient(:,:,3)=f_orient(:,:,3)+f_orient(:,:,3)'.*(~eye(size(fiber_matrix,1),size(fiber_matrix,2)));
    m_dti_orient.(['run',num2str(aaa)])=f_orient;
    
    v_dti_md.(['run',num2str(aaa)])=MD_vector;
    v_dti_fa.(['run',num2str(aaa)])=FA_vector;
    %%%%%%
    
    fiber_matrix(isnan(fiber_matrix(:)))=0;
    [dti_degree_fiber,dti_cluster_fiber,dti_Sworld_fiber,dti_Path_fiber,dti_Cluster_fiber]=BCT_MIBCA(fiber_matrix,ctx_labels,sel_label,1,0);
    v_dti_degree_fiber.(['run',num2str(aaa)])=dti_degree_fiber;
    v_dti_cluster_fiber.(['run',num2str(aaa)])=dti_cluster_fiber;
    h_dti_Sworld_fiber.(['run',num2str(aaa)])=dti_Sworld_fiber;
    h_dti_Path_fiber.(['run',num2str(aaa)])=dti_Path_fiber;
    h_dti_Cluster_fiber.(['run',num2str(aaa)])=dti_Cluster_fiber;
     
    if isfield(m_dti_fiber,'run_mean')
        m_dti_fiber.run_mean=m_dti_fiber.run_mean+m_dti_fiber.(['run',num2str(aaa)]);
    else
        m_dti_fiber.run_mean=m_dti_fiber.(['run',num2str(aaa)]);
    end
    if isfield(m_dti_fiber_thres,'run_mean')
        m_dti_fiber_thres.run_mean=m_dti_fiber_thres.run_mean+m_dti_fiber_thres.(['run',num2str(aaa)]);
    else
        m_dti_fiber_thres.run_mean=m_dti_fiber_thres.(['run',num2str(aaa)]);
    end
    if isfield(v_dti_md,'run_mean')
        v_dti_md.run_mean=v_dti_md.run_mean+v_dti_md.(['run',num2str(aaa)]);
    else
        v_dti_md.run_mean=v_dti_md.(['run',num2str(aaa)]);
    end
    if isfield(v_dti_fa,'run_mean')
        v_dti_fa.run_mean=v_dti_fa.run_mean+v_dti_fa.(['run',num2str(aaa)]);
    else
        v_dti_fa.run_mean=v_dti_fa.(['run',num2str(aaa)]);
    end
    if isfield(v_dti_degree_fiber,'run_mean')
        v_dti_degree_fiber.run_mean=v_dti_degree_fiber.run_mean+v_dti_degree_fiber.(['run',num2str(aaa)]);
    else
        v_dti_degree_fiber.run_mean=v_dti_degree_fiber.(['run',num2str(aaa)]);
    end
    if isfield(v_dti_cluster_fiber,'run_mean')
        v_dti_cluster_fiber.run_mean=v_dti_cluster_fiber.run_mean+v_dti_cluster_fiber.(['run',num2str(aaa)]);
    else
        v_dti_cluster_fiber.run_mean=v_dti_cluster_fiber.(['run',num2str(aaa)]);
    end
    
    
    
    aaa=aaa+1;
end

if aaa>1
m_dti_fiber.run_mean=m_dti_fiber.run_mean/(aaa-1);
m_dti_fiber_thres.run_mean=m_dti_fiber_thres.run_mean/(aaa-1);
v_dti_md.run_mean=v_dti_md.run_mean/(aaa-1);
v_dti_fa.run_mean=v_dti_fa.run_mean/(aaa-1);
v_dti_degree_fiber.run_mean=v_dti_degree_fiber.run_mean/(aaa-1);
v_dti_cluster_fiber.run_mean=v_dti_cluster_fiber.run_mean/(aaa-1);
    
save([out_DTI,SUBJECT,'_dti_data.mat'],'m_dti_fiber','m_dti_fiber_thres','m_dti_fiber_Gnorm','m_dti_fiber_Lnorm','m_dti_length','m_dti_orient',...
    'v_dti_fa','v_dti_md',...
    'v_dti_degree_fiber','v_dti_cluster_fiber','h_dti_Path_fiber','h_dti_Sworld_fiber','h_dti_Cluster_fiber')
end

% % mean_dti_fiber=squeeze(sum(dti_fiber,3))/(aaa-1);
% % mean_dti_length=squeeze(sum(dti_length,3))/(aaa-1);
% % mean_dti_orient=squeeze(sum(dti_orient,4));%/(aaa-1);
% % mean_dti_orient=mean_dti_orient./repmat(sqrt(sum(mean_dti_orient.^2,3)),[1,1,3]);
% % 
% % mean_dti_md=squeeze(sum(dti_md,2))/(aaa-1);
% % mean_dti_fa=squeeze(sum(dti_md,2))/(aaa-1);
% %    
% % check_col=any(mean_dti_fiber);
% % check_col_indx=find(check_col);
% % iter=20;
% % t_mean_dti_length=mean_dti_length;
% % for kk=1:iter
% %     t_mean_dti_length_temp=t_mean_dti_length;
% %     for i=1:length(check_col_indx)
% %         ii=check_col_indx(i);
% %         for j=1:length(check_col_indx)
% %             jj=check_col_indx(j);
% %             
% %             %     for i=1:size(fiber_matrix,1)
% %             %         for j=1:size(fiber_matrix,2)
% %             if isnan(t_mean_dti_length_temp(ii,jj)) || (t_mean_dti_length_temp(ii,jj)==0)
% %                 f_dist=t_mean_dti_length_temp(ii,:)+t_mean_dti_length_temp(:,jj)';
% %                 t_mean_dti_length(ii,jj)=min(f_dist);
% %                 t_mean_dti_length(jj,ii)=min(f_dist);
% %             else
% %                 t_mean_dti_length(ii,jj)=t_mean_dti_length_temp(ii,jj);
% %                 t_mean_dti_length(jj,ii)=t_mean_dti_length_temp(ii,jj);
% %             end
% %         end
% %     end
% % end
% % save([out_DTI,SUBJECT,'_dti_data.mat'],'mean_dti_fiber','dti_fiber','t_mean_dti_length',...
% %     'mean_dti_length','dti_length','mean_dti_orient','dti_orient','mean_dti_md','mean_dti_fa','dti_fa','dti_md')

return