function [fiber_matrix_orig,ROI_zeros,f_length,f_orient,MD_vector,FA_vector]=dti_measures_analisys_MIBCA (INFO,TRACTS,subject_nii,ctx_labels,sel_labels,type,FA_DTI,MD_DTI)
%Developed by A. Santos Ribeiro and L. Lacerda
%%%%

data=subject_nii.img;

region2analy=unique(data(:));
region2analy(region2analy(:)==0)=[];
all_regions=cell2mat(ctx_labels(:,1));

ROI_zeros=ones(1,length(sel_labels));
sel_labels=find(sel_labels);

INFOOUT2=cell(length(sel_labels),length(sel_labels));
TRACTSOUT2=cell(length(sel_labels),length(sel_labels));

f_length=zeros(length(sel_labels));
f_orient=zeros(length(sel_labels),length(sel_labels),3);
MD_vector=zeros(length(sel_labels),1);
FA_vector=zeros(length(sel_labels),1);

for i=1:length(region2analy)
    iter_region=find(region2analy(i)==all_regions,1);
    if ~isempty(iter_region)
        roi_label=ctx_labels{iter_region,1};
        ROI=data==roi_label;
        ROI_zeros(iter_region)=0;
        
            MD_vector(iter_region)=sum(MD_DTI(:).*ROI(:))/sum(ROI(:));
            FA_vector(iter_region)=sum(FA_DTI(:).*ROI(:))/sum(ROI(:));
            
            [INFOOUT, TRACTSOUT]=NBL_filterTract_full_2_MIBCA(INFO,TRACTS,ROI,type);
        for j=i+1:length(region2analy)
            iter_region2=find(region2analy(j)==all_regions,1);
            if ~isempty(iter_region2)
                roi_label2=ctx_labels{iter_region2,1};
                ROI2=data==roi_label2;
                [INFOOUT2{iter_region,iter_region2}, TRACTSOUT2{iter_region,iter_region2},...
                    f_length(iter_region,iter_region2),f_orient(iter_region,iter_region2,:)]=...
                    NBL_filterTract_full_2_MIBCA(INFOOUT,TRACTSOUT,ROI2,type);
                
            end
        end
    end
    
end

% for i=1:length(sel_labels)
%     roi_label=ctx_labels{sel_labels(i),1};
%     ROI=data==roi_label;
%     ROI_zeros(i)=~any(ROI(:));
%
%     if ~ROI_zeros(i)
%         [INFOOUT, TRACTSOUT]=NBL_filterTract_full_2_MIBCA(INFO,TRACTS,ROI,type);
%         for j=i:length(sel_labels)
%             roi_label2=ctx_labels{sel_labels(j),1};
%             ROI2=data==roi_label2;
%             [INFOOUT2{i,j}, TRACTSOUT2{i,j},f_length(i,j),f_orient(i,j,:)]=NBL_filterTract_full_2_MIBCA(INFOOUT,TRACTSOUT,ROI2,type);
%
%         end
%     end
% end

fiber_matrix_orig=zeros(size(TRACTSOUT2,1),size(TRACTSOUT2,2));
for i=1:size(TRACTSOUT2,1)
    for j=i:size(TRACTSOUT2,2)
        fiber_matrix_orig(i,j)=length(TRACTSOUT2{i,j});
    end
end


