function [pathss]=check_files(directory, filter)
%  Scrip to check if exists dicom files recursivly
%
%
%  # Short discription: Scrip to check if exists dicom files
%
%
%
%  #Input:
%      $ Define the correct paths and files:
% 		- directory -> directory to search for ficom data.
%
%  #Output:
%       - pathss -> paths with the files
%
%
% Date  : February 2014
% Author: Luis Lacerda and Nuno Andre da Silva
% E-mail: luislacerda1989@gmail.com
%         nuno.andre.da.silva@gmail.com

% --  check inputs
pathss={};
p=1;

if nargin == 0
    folder = pwd;
    filter = '*.dcm';
else
    
    disp(['checking files on ' directory]);
    files=dir(directory);
    
    % -- files on the directory
    if isempty (files)
        
        disp(['no directories or files under directory ' directory])
        
    else
        % -- checking all files
        
        for i=1:length(files)
            
            if (files(i).isdir ==1) && (length(files(i).name) > 3)
                
                alli=genpath([directory files(i).name]);
                
                a_len_fin=[':',alli];
                pontos=find(a_len_fin==':');
                
                for j=1:length(pontos)-1
                    
                    c{j}=a_len_fin(pontos(j)+1:pontos(j+1)-1);
                    
                    dcm=dir([c{j},'/' filter]);
                    
                    if ~isempty(dcm)
                        pathss{p}=c{j};
                        p=p+1;
                    end
                    
                end
                
            end
            
        end
        
    end
end