function fMRI_matrix_MIBCA(out_fMRI,SUBJECT, jade,ctx_labels,effective_fmri,complexity_fmri)

%Developed by A. Santos Ribeiro
%%%%

scans_fMRI=dir(out_fMRI);
scans_fMRI=struct2cell(scans_fMRI);
isdir_fMRI=scans_fMRI(4,:)';
scans_fMRI=scans_fMRI(1,:)';

scans_fMRI_temp=cell2mat(cellfun(@(C) strcmp(C,'..'), scans_fMRI, 'UniformOutput', false));
scans_fMRI_temp=scans_fMRI_temp | cell2mat(cellfun(@(C) strcmp(C,'.'), scans_fMRI, 'UniformOutput', false));
scans_fMRI_temp=scans_fMRI_temp | cell2mat(cellfun(@(C) strcmp(C,'.DS_Store'), scans_fMRI, 'UniformOutput', false));

scans_fMRI_temp=scans_fMRI_temp | (~cell2mat(isdir_fMRI));
scans_fMRI=scans_fMRI(~scans_fMRI_temp);
aaa=1;
for i=1:length(scans_fMRI)
    temp_image=scans_fMRI{i};
    
    %%% mean fMRI calculation
    gunzip([out_fMRI,temp_image,'/','filtered_func_data.nii.gz'])
    output_merge_volume=[out_fMRI,temp_image,'/','filtered_func_data.nii'];
    nii_fMRI_dinamic=load_untouch_nii(output_merge_volume);
    region_fMRI = load_untouch_nii([out_fMRI,temp_image,'/','aparc+aseg2fMRI.nii']);
    
    gunzip([out_fMRI,temp_image,'/',temp_image,'.feat/mean_func.nii.gz'])
    mean_fMRI = load_untouch_nii([out_fMRI,temp_image,'/',temp_image,'.feat/mean_func.nii']);
    mean_fMRI=mean_fMRI.img;
    
    %         sel_label=ones(1,72);
    sel_label=ones(1,length(ctx_labels));
    [mean_X1_fMRI,ROI_zeros_fMRI,mean_activation]=measures_mean_jade_fmri_MIBCA (nii_fMRI_dinamic,region_fMRI,ctx_labels,sel_label,jade,mean_fMRI);
    h_mean_X1_fMRI.(['run',num2str(aaa)])=mean_X1_fMRI;
    
    [mean_r_fMRI,mean_p_fMRI]=corrcoef(mean_X1_fMRI');
    m_fmri_corr.(['run',num2str(aaa)])=mean_r_fMRI;
    h_fmri_pval.(['run',num2str(aaa)])=mean_p_fMRI;
    h_fmri_pval_bonf.(['run',num2str(aaa)])=mean_p_fMRI<(0.05/(size(mean_r_fMRI,1)*(size(mean_r_fMRI,1)-1)));
    m_fmri_corr_bonf.(['run',num2str(aaa)])=(mean_r_fMRI.*h_fmri_pval_bonf.(['run',num2str(aaa)]))>0;
    %%%
    
    %%% complexity calculation
    if complexity_fmri > 0
        [h_fmri_mse_data.(['run',num2str(aaa)]),m_fmri_mse.(['run',num2str(aaa)])]=...
            mse_fMRI_MIBCA(mean_X1_fMRI);
    end
    %%%
    
    %%% effective conectivity calculation
    if effective_fmri > 0
        fmri_effective_r_temp=zeros(size(mean_r_fMRI,1),size(mean_r_fMRI,2));
        fmri_effective_p_temp=zeros(size(mean_r_fMRI,1),size(mean_r_fMRI,2));
        for zz=1:size(mean_X1_fMRI,1)
            for xx=zz+1:size(mean_X1_fMRI,1)
                if effective_fmri==1
                    [fmri_effective_temp2, prb_temp2] = CP_GCTime_MIBCA(mean_X1_fMRI([zz,xx],:),1,0.10);
                elseif effective_fmri==2
                    [fmri_effective_temp2, prb_temp2] = MVAR_GCTime_MIBCA(mean_X1_fMRI([zz,xx],:),1,0.10);
                end
                fmri_effective_r_temp(zz,xx)=fmri_effective_temp2(1,2);
                fmri_effective_r_temp(xx,zz)=fmri_effective_temp2(2,1);
                fmri_effective_p_temp(zz,xx)=prb_temp2(1,2);
                fmri_effective_p_temp(xx,zz)=prb_temp2(2,1);
            end
        end
        
        for zz=1:size(mean_X1_fMRI,1)
            for xx=1:size(mean_X1_fMRI,1)
                if fmri_effective_r_temp(zz,xx)>=fmri_effective_r_temp(xx,zz)
                    fmri_effective_r_temp(xx,zz)=0;
                else
                    fmri_effective_r_temp(zz,xx)=0;
                end
            end
        end
        
        m_fmri_corr_effective.(['run',num2str(aaa)])=fmri_effective_r_temp;
        h_fmri_pval_effective.(['run',num2str(aaa)])=fmri_effective_p_temp;
        h_fmri_pval_effective_bonf.(['run',num2str(aaa)])=h_fmri_pval_effective.(['run',num2str(aaa)])<(0.05/(size(mean_r_fMRI,1)*(size(mean_r_fMRI,1)-1)));
        m_fmri_corr_effective_bonf.(['run',num2str(aaa)])=(m_fmri_corr_effective.(['run',num2str(aaa)]).*h_fmri_pval_effective_bonf.(['run',num2str(aaa)]))>0;
        %%%
        
        %%% mutual connectivity calculation
        m_fmri_mutual.(['run',num2str(aaa)])=(mean_r_fMRI-(fmri_effective_r_temp+fmri_effective_r_temp'));
        m_fmri_mutual_bonf.(['run',num2str(aaa)])=((m_fmri_corr_bonf.(['run',num2str(aaa)])-(m_fmri_corr_effective_bonf.(['run',num2str(aaa)])+m_fmri_corr_effective_bonf.(['run',num2str(aaa)])')))>0;
        %%%
        
        %%% mean activation
        v_fmri_act.(['run',num2str(aaa)])=mean_activation;
        %%%
    else
    end
    aaa=aaa+1;
    
end
if (effective_fmri > 0) && (complexity_fmri > 0)
    save([out_fMRI,SUBJECT,'_fmri_data.mat'],'m_fmri_corr','h_fmri_pval','m_fmri_corr_bonf','h_fmri_pval_bonf',...
        'm_fmri_corr_effective','h_fmri_pval_effective','m_fmri_corr_effective_bonf','h_fmri_pval_effective_bonf',...
        'm_fmri_mutual','m_fmri_mutual_bonf',...
        'h_fmri_mse_data','m_fmri_mse',...
        'h_mean_X1_fMRI','v_fmri_act')
elseif (effective_fmri > 0)
    save([out_fMRI,SUBJECT,'_fmri_data.mat'],'m_fmri_corr','h_fmri_pval','m_fmri_corr_bonf','h_fmri_pval_bonf',...
        'm_fmri_corr_effective','h_fmri_pval_effective','m_fmri_corr_effective_bonf','h_fmri_pval_effective_bonf',...
        'm_fmri_mutual','m_fmri_mutual_bonf',...
        'h_mean_X1_fMRI','v_fmri_act')
    
elseif (complexity_fmri > 0)
    save([out_fMRI,SUBJECT,'_fmri_data.mat'],'m_fmri_corr','h_fmri_pval','m_fmri_corr_bonf','h_fmri_pval_bonf',...
        'h_fmri_mse_data','m_fmri_mse',...
        'h_mean_X1_fMRI','v_fmri_act')
    
else
    save([out_fMRI,SUBJECT,'_fmri_data.mat'],'m_fmri_corr','h_fmri_pval','m_fmri_corr_bonf','h_fmri_pval_bonf',...
        'h_mean_X1_fMRI','v_fmri_act')

% % mean_fmri_r=squeeze(sum(fmri_r,3))/(aaa-1);
% % sum_fmri_r_bonf=squeeze(sum(fmri_r_bonf,3));
% % mean_fmri_act=squeeze(sum(fmri_act,2))/(aaa-1);
% % if effective_fmri > 0
% %     mean_fmri_r_effective=squeeze(sum(fmri_r_effective,3))/(aaa-1);
% %     sum_fmri_r_effective_bonf=squeeze(sum(fmri_r_effective_bonf,3));
% %     
% %     mean_fmri_mutual=squeeze(sum(fmri_mutual,3))/(aaa-1);
% %     sum_fmri_mutual_bonf=squeeze(sum(fmri_mutual_bonf,3));
% % end
% % 
% % if complexity_fmri > 0
% %     mean_mse_matrix_fmri=squeeze(sum(mse_matrix_fmri,3))/(aaa-1);
% %     mean_mse_fmri=squeeze(sum(mse_fmri,3))/(aaa-1);
% % end
% % if (effective_fmri > 0) && (complexity_fmri > 0)
% %     save([out_fMRI,SUBJECT,'_fmri_data.mat'],'mean_fmri_r','fmri_r','fmri_p','sum_fmri_r_bonf','fmri_r_bonf','fmri_p_bonf',...
% %         'mean_fmri_r_effective','fmri_r_effective','fmri_p_effective','sum_fmri_r_effective_bonf','fmri_r_effective_bonf','fmri_p_effective_bonf',...
% %         'mean_fmri_mutual','fmri_mutual','sum_fmri_mutual_bonf','fmri_mutual_bonf',...
% %         'mean_mse_matrix_fmri','mse_matrix_fmri','mean_mse_fmri','mse_fmri',...
% %         'save_mean_X1_fMRI','mean_fmri_act','fmri_act')
% % elseif (effective_fmri > 0)
% %     save([out_fMRI,SUBJECT,'_fmri_data.mat'],'mean_fmri_r','fmri_r','fmri_p','sum_fmri_r_bonf','fmri_r_bonf','fmri_p_bonf',...
% %         'mean_fmri_r_effective','fmri_r_effective','fmri_p_effective','sum_fmri_r_effective_bonf','fmri_r_effective_bonf','fmri_p_effective_bonf',...
% %         'mean_fmri_mutual','fmri_mutual','sum_fmri_mutual_bonf','fmri_mutual_bonf',...
% %         'save_mean_X1_fMRI','mean_fmri_act','fmri_act')
% %     
% % elseif (complexity_fmri > 0)
% %     save([out_fMRI,SUBJECT,'_fmri_data.mat'],'mean_fmri_r','fmri_r','fmri_p','sum_fmri_r_bonf','fmri_r_bonf','fmri_p_bonf',...
% %         'mean_mse_matrix_fmri','mse_matrix_fmri','mean_mse_fmri','mse_fmri',...
% %         'save_mean_X1_fMRI','mean_fmri_act','fmri_act')
% %     
% % else
% %     save([out_fMRI,SUBJECT,'_fmri_data.mat'],'mean_fmri_r','fmri_r','fmri_p','sum_fmri_r_bonf','fmri_r_bonf','fmri_p_bonf',...
% %         'save_mean_X1_fMRI','mean_fmri_act','fmri_act')
    
end







