function fMRI_matrix_MIBCA_new(out_fMRI,SUBJECT, jade,ctx_labels,effective_fmri,complexity_fmri)

%Developed by A. Santos Ribeiro
%%%%

scans_fMRI=dir(out_fMRI);
scans_fMRI=struct2cell(scans_fMRI);
isdir_fMRI=scans_fMRI(4,:)';
scans_fMRI=scans_fMRI(1,:)';

scans_fMRI_temp=cell2mat(cellfun(@(C) strcmp(C,'..'), scans_fMRI, 'UniformOutput', false));
scans_fMRI_temp=scans_fMRI_temp | cell2mat(cellfun(@(C) strcmp(C,'.'), scans_fMRI, 'UniformOutput', false));
scans_fMRI_temp=scans_fMRI_temp | cell2mat(cellfun(@(C) strcmp(C,'.DS_Store'), scans_fMRI, 'UniformOutput', false));

scans_fMRI_temp=scans_fMRI_temp | (~cell2mat(isdir_fMRI));
scans_fMRI=scans_fMRI(~scans_fMRI_temp);
aaa=1;
for i=1:length(scans_fMRI)
    temp_image=scans_fMRI{i};
    
    %%% mean fMRI calculation
    gunzip([out_fMRI,temp_image,'/','filtered_func_data.nii.gz'])
    output_merge_volume=[out_fMRI,temp_image,'/','filtered_func_data.nii'];
    nii_fMRI_dinamic=load_untouch_nii(output_merge_volume);
    region_fMRI = load_untouch_nii([out_fMRI,temp_image,'/','aparc+aseg2fMRI.nii']);
    
    gunzip([out_fMRI,temp_image,'/',temp_image,'.feat/mean_func.nii.gz'])
    mean_fMRI = load_untouch_nii([out_fMRI,temp_image,'/',temp_image,'.feat/mean_func.nii']);
    mean_fMRI=mean_fMRI.img;
    
    %         sel_label=ones(1,72);
    sel_label=ones(1,length(ctx_labels));
    [mean_X1_fMRI,ROI_zeros_fMRI,mean_activation]=measures_mean_jade_fmri_MIBCA (nii_fMRI_dinamic,region_fMRI,ctx_labels,sel_label,jade,mean_fMRI);
    h_mean_X1_fMRI.(['run',num2str(aaa)])=mean_X1_fMRI;
    
    [mean_r_fMRI,mean_p_fMRI]=corrcoef(mean_X1_fMRI');
    mean_r_fMRI=mean_r_fMRI.*(mean_p_fMRI<0.05);
    h_fmri_pval.(['run',num2str(aaa)])=mean_p_fMRI;
    m_fmri_corr.(['run',num2str(aaa)])=mean_r_fMRI;
    m_fmri_corr_thres.(['run',num2str(aaa)])=abs(mean_r_fMRI)>0;
    %     h_fmri_pval_bonf.(['run',num2str(aaa)])=mean_p_fMRI<(0.05/(size(mean_r_fMRI,1)*(size(mean_r_fMRI,1)-1)));
    %     m_fmri_corr_bonf.(['run',num2str(aaa)])=(mean_r_fMRI.*h_fmri_pval_bonf.(['run',num2str(aaa)]))>0;
    %%%
    
    %%% complexity calculation
    if complexity_fmri > 0
        [h_fmri_mse_data.(['run',num2str(aaa)]),m_fmri_mse.(['run',num2str(aaa)])]=...
            mse_fMRI_MIBCA(mean_X1_fMRI);
    end
    %%%
    
    %%% effective conectivity calculation
    if effective_fmri > 0
        fmri_effective_r_temp=zeros(size(mean_r_fMRI,1),size(mean_r_fMRI,2));
        for zz=1:size(mean_X1_fMRI,1)
            for xx=1:size(mean_X1_fMRI,1)
                if any(mean_X1_fMRI(zz,:))&&any(mean_X1_fMRI(xx,:))&&(zz~=xx)
                    %if true zz grange-cause xx
                    fmri_effective_r_temp(zz,xx) = granger_simplified_MIBCA(mean_X1_fMRI(zz,:)',mean_X1_fMRI(xx,:)',0);
                else
                    fmri_effective_r_temp(zz,xx)=NaN;
                end
            end
        end
        
        m_fmri_corr_effective_thres.(['run',num2str(aaa)])=fmri_effective_r_temp;
        
        label_effective=double(fmri_effective_r_temp).*...
            (double(fmri_effective_r_temp)+double(fmri_effective_r_temp)');
        m_fmri_e0.(['run',num2str(aaa)])=mean_r_fMRI.*(label_effective==0);
        m_fmri_e1.(['run',num2str(aaa)])=mean_r_fMRI.*(label_effective==1);
        m_fmri_e2.(['run',num2str(aaa)])=mean_r_fMRI.*(label_effective==2);
        
        m_fmri_e0_thres.(['run',num2str(aaa)])=(label_effective==0).*(mean_p_fMRI<0.05);
        m_fmri_e1_thres.(['run',num2str(aaa)])=(label_effective==1).*(mean_p_fMRI<0.05);
        m_fmri_e2_thres.(['run',num2str(aaa)])=(label_effective==2).*(mean_p_fMRI<0.05);
        %%%
        
        %%% mean activation
        v_fmri_act.(['run',num2str(aaa)])=mean_activation;
        %%%
    else
    end
    
    [fmri_degree_corr,fmri_cluster_corr,fmri_Sworld_corr,fmri_Path_corr,fmri_Cluster_corr]=BCT_MIBCA(mean_r_fMRI.^2,ctx_labels,sel_label,1,0);
    v_fmri_degree_corr.(['run',num2str(aaa)])=fmri_degree_corr;
    v_fmri_cluster_corr.(['run',num2str(aaa)])=fmri_cluster_corr;
    h_fmri_Path_corr.(['run',num2str(aaa)])=fmri_Path_corr;
    h_fmri_Sworld_corr.(['run',num2str(aaa)])=fmri_Sworld_corr;
    h_fmri_Cluster_corr.(['run',num2str(aaa)])=fmri_Cluster_corr;
    
    
    if isfield(m_fmri_corr,'run_mean')
        m_fmri_corr.run_mean=m_fmri_corr.run_mean+m_fmri_corr.(['run',num2str(aaa)]);
    else
        m_fmri_corr.run_mean=m_fmri_corr.(['run',num2str(aaa)]);
    end
    if isfield(m_fmri_corr_thres,'run_mean')
        m_fmri_corr_thres.run_mean=m_fmri_corr_thres.run_mean+m_fmri_corr_thres.(['run',num2str(aaa)]);
    else
        m_fmri_corr_thres.run_mean=m_fmri_corr_thres.(['run',num2str(aaa)]);
    end
    if isfield(v_fmri_degree_corr,'run_mean')
        v_fmri_degree_corr.run_mean=v_fmri_degree_corr.run_mean+v_fmri_degree_corr.(['run',num2str(aaa)]);
    else
        v_fmri_degree_corr.run_mean=v_fmri_degree_corr.(['run',num2str(aaa)]);
    end
    if isfield(v_fmri_cluster_corr,'run_mean')
        v_fmri_cluster_corr.run_mean=v_fmri_cluster_corr.run_mean+v_fmri_cluster_corr.(['run',num2str(aaa)]);
    else
        v_fmri_cluster_corr.run_mean=v_fmri_cluster_corr.(['run',num2str(aaa)]);
    end
    if isfield(m_fmri_corr_effective_thres,'run_mean')
        m_fmri_corr_effective_thres.run_mean=m_fmri_corr_effective_thres.run_mean+m_fmri_corr_effective_thres.(['run',num2str(aaa)]);
    else
        m_fmri_corr_effective_thres.run_mean=m_fmri_corr_effective_thres.(['run',num2str(aaa)]);
    end
    
    
    
    aaa=aaa+1;
end

if aaa>1
    
    m_fmri_corr.run_mean=m_fmri_corr.run_mean/(aaa-1);
    m_fmri_corr_thres.run_mean=m_fmri_corr_thres.run_mean/(aaa-1);
    v_fmri_degree_corr.run_mean=v_fmri_degree_corr.run_mean/(aaa-1);
    v_fmri_cluster_corr.run_mean=v_fmri_cluster_corr.run_mean/(aaa-1);
    m_fmri_corr_effective_thres.run_mean=m_fmri_corr_effective_thres.run_mean/(aaa-1);
    
    
    if (effective_fmri > 0) && (complexity_fmri > 0)
        save([out_fMRI,SUBJECT,'_fmri_data.mat'],...
            'm_fmri_corr','m_fmri_corr_thres','h_fmri_pval',...
            'm_fmri_e0','m_fmri_e1','m_fmri_e2',...
            'm_fmri_corr_effective_thres','m_fmri_e0_thres','m_fmri_e1_thres','m_fmri_e2_thres',...
            'h_fmri_mse_data','m_fmri_mse',...
            'h_mean_X1_fMRI','v_fmri_act',...
            'v_fmri_degree_corr','v_fmri_cluster_corr','h_fmri_Path_corr','h_fmri_Sworld_corr','h_fmri_Cluster_corr')
    elseif (effective_fmri > 0)
        save([out_fMRI,SUBJECT,'_fmri_data.mat'],...
            'm_fmri_corr','m_fmri_corr_thres','h_fmri_pval',...
            'm_fmri_e0','m_fmri_e1','m_fmri_e2',...
            'm_fmri_corr_effective_thres','m_fmri_e0_thres','m_fmri_e1_thres','m_fmri_e2_thres',...
            'h_mean_X1_fMRI','v_fmri_act',...
            'v_fmri_degree_corr','v_fmri_cluster_corr','h_fmri_Path_corr','h_fmri_Sworld_corr','h_fmri_Cluster_corr')
        
    elseif (complexity_fmri > 0)
        save([out_fMRI,SUBJECT,'_fmri_data.mat'],...
            'm_fmri_corr','h_fmri_pval',...
            'h_fmri_mse_data','m_fmri_mse',...
            'h_mean_X1_fMRI','v_fmri_act',...
            'v_fmri_degree_corr','v_fmri_cluster_corr','h_fmri_Path_corr','h_fmri_Sworld_corr','h_fmri_Cluster_corr')
        
    else
        save([out_fMRI,SUBJECT,'_fmri_data.mat'],...
            'm_fmri_corr','h_fmri_pval',...
            'h_mean_X1_fMRI','v_fmri_act',...
            'v_fmri_degree_corr','v_fmri_cluster_corr','h_fmri_Path_corr','h_fmri_Sworld_corr','h_fmri_Cluster_corr')
        
    end
    
end





