function []=fh_intermediate_checklists_processing2(varargin)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        label_dir=[];
        sub_dir=[];
        data_location=[];
        subjects_names=[];
        sMRI_identifier=[];
        fMRI_identifier=[];
        DTI_identifier=[];
        PET_identifier=[];
        output_directory=[];
        ctx_labels=[];
        system_initialization=[];
        dcm2nii_dir=[];
        
        load('general_variables.mat');
        load('regions_freesurfer_last.mat');
        
        sub_pipeline=[];
        if exist([output_directory,'processing_pipeline.mat'])
            load([output_directory,'processing_pipeline.mat']);
        end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


S.fh_fh_genpaths = figure('units','normalized',...
    'position',[0.25 0.175 0.50 0.75],...
    'menubar','none',...
    'name','GUI_MIBCA_Processing',...
    'numbertitle','off',...
    'resize','on');

x_stxt_pos_1=0.1;
dx_cbh_stxt=0.2;
x_cbh_pos_1=x_stxt_pos_1 + dx_cbh_stxt;

y_cbh_pos_1=0.9;
y_stxt_pos_1=0.9;

x_cbh_siz1=0.03;
y_cbh_siz1=0.03;
x_stxt_siz1=0.2;
y_stxt_siz1=0.03;

dy_cbh_stxt=0.03;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Structural %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 
%         
%         Template_pipeline{1,1}='sMRI';
%         Template_pipeline{1,2}='Run';
%         Template_pipeline{2,1}='dicom2nii';
%         Template_pipeline{2,2}=0;
%         Template_pipeline{3,1}='smrireco';
%         Template_pipeline{3,2}=0;
%         Template_pipeline{4,1}='smrireco2';
%         Template_pipeline{4,2}=0;
%         Template_pipeline{5,1}='smrimvt1';
%         Template_pipeline{5,2}=0;
%         Template_pipeline{6,1}='smrimvregion';
%         Template_pipeline{6,2}=0;
%         Template_pipeline{7,1}='sMRI_matrix';
%         Template_pipeline{7,2}=0;


S.cbh_str_dicom2nii = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 y_cbh_pos_1 x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_str_dicom2nii = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','Structural data conversion.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 y_stxt_pos_1 x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_str_dicom2nii,'Value') == 0
    set (S.stxt_str_dicom2nii,'Enable','off')
else
    set (S.stxt_str_dicom2nii,'Enable','on')
end

S.cbh_smrireco = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_smrireco = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','Smrireco.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_smrireco,'Value') == 0
    set (S.stxt_smrireco,'Enable','off')
else
    set (S.stxt_smrireco,'Enable','on')
end

S.cbh_smrireco2 = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 2*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_smrireco2 = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','Smrireco2.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 2*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_smrireco2,'Value') == 0
    set (S.stxt_smrireco2,'Enable','off')
else
    set (S.stxt_smrireco2,'Enable','on')
end

S.cbh_smrimvt1 = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 3*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_smrimvt1 = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','smrimvt1.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 3*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_smrimvt1,'Value') == 0
    set (S.stxt_smrimvt1,'Enable','off')
else
    set (S.stxt_smrimvt1,'Enable','on')
end

S.cbh_smrimvregion = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 4*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_smrimvregion = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','smrimvregion.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 4*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_smrimvregion,'Value') == 0
    set (S.stxt_smrimvregion,'Enable','off')
else
    set (S.stxt_smrimvregion,'Enable','on')
end

S.cbh_sMRI_matrix = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 5*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_sMRI_matrix = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','sMRI_matrix.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 5*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_sMRI_matrix,'Value') == 0
    set (S.stxt_sMRI_matrix,'Enable','off')
else
    set (S.stxt_sMRI_matrix,'Enable','on')
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Diffusion %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%         
%         Template_pipeline{10,1}='dMRI';
%         Template_pipeline{10,2}='Run';
%         Template_pipeline{11,1}='dicom2nii';
%         Template_pipeline{11,2}=0;
%         Template_pipeline{12,1}='corr_bvec';
%         Template_pipeline{12,2}=0;
%         Template_pipeline{13,1}='diffest';
%         Template_pipeline{13,2}=1;
%         Template_pipeline{15,1}='diffregspm';
%         Template_pipeline{15,2}=0;
%         Template_pipeline{14,1}='difftract';
%         Template_pipeline{14,2}=0;
%         Template_pipeline{16,1}='dti_matrix';
%         Template_pipeline{16,2}=0;



S.cbh_dwi_dicom2nii = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 7*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_dwi_dicom2nii = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','Diffusion data conversion.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 7*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_dwi_dicom2nii,'Value') == 0
    set (S.stxt_dwi_dicom2nii,'Enable','off')
else
    set (S.stxt_dwi_dicom2nii,'Enable','on')
end

S.cbh_corr_bvec = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 8*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_corr_bvec = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','corr_bvec.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 8*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_corr_bvec,'Value') == 0
    set (S.stxt_corr_bvec,'Enable','off')
else
    set (S.stxt_corr_bvec,'Enable','on')
end

S.cbh_diffest = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 9*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_diffest = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','diffest.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 9*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

S.stxt_dwi_inv_swap_value = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','Inversion and Swap of Gradients',...
    'unit','normalized',...
    'position',[(x_stxt_pos_1 + x_stxt_siz1 + 2*x_cbh_siz1)...
    (y_cbh_pos_1 - 9*dy_cbh_stxt) 1.5*x_stxt_siz1 y_stxt_siz1]);

S.pmh_inv = uicontrol(S.fh_fh_genpaths,'Style','popupmenu',...
    'String',{'no inversion','-x','-y','-z'},...
    'unit','normalized',...
    'position',[(x_stxt_pos_1 + x_stxt_siz1 + 2*x_cbh_siz1)...
    (y_cbh_pos_1 - 10.5*dy_cbh_stxt) x_stxt_siz1*0.7 y_stxt_siz1],...
    'Enable','off');

S.pmh_swp = uicontrol(S.fh_fh_genpaths,'Style','popupmenu',...
    'String',{'no swap','swap x','swap y','swap z'},...
    'unit','normalized',...
    'position',[(x_stxt_pos_1 + 1.5*x_stxt_siz1 + 5*x_cbh_siz1)...
    (y_cbh_pos_1 - 10.5*dy_cbh_stxt) x_stxt_siz1*0.5 y_stxt_siz1],...
    'Enable','off');

S.cbh_dwi_inv_swp_detect = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[(x_stxt_pos_1 + 2.4*x_stxt_siz1 + 2*x_cbh_siz1)...
    (y_cbh_pos_1 - 12.5*dy_cbh_stxt) x_cbh_siz1*0.9 y_cbh_siz1],...
    'Value',1);

S.stxt_dwi_inv_swp_detect = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','Automatically Detect.',...
    'unit','normalized',...
    'position',[(x_stxt_pos_1 + x_stxt_siz1 + 2*x_cbh_siz1)...
    (y_cbh_pos_1 - 12.5*dy_cbh_stxt) 1.4*x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_dwi_inv_swp_detect,'Value') == 0
    set (S.pmh_inv,'Enable','on')
    set (S.pmh_swp,'Enable','on')
    set (S.stxt_dwi_inv_swp_detect,'Enable','off')
else
    set (S.pmh_inv,'Enable','off')
    set (S.pmh_swp,'Enable','off')
    set (S.stxt_dwi_inv_swp_detect,'Enable','on')
end

if get(S.cbh_diffest,'Value') == 0
    set (S.stxt_diffest,'Enable','off')
else
    set (S.stxt_diffest,'Enable','on')
end

S.cbh_diffregspm = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 10*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_diffregspm = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','diffregspm.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 10*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_diffregspm,'Value') == 0
    set (S.stxt_diffregspm,'Enable','off')
else
    set (S.stxt_diffregspm,'Enable','on')
end

S.cbh_difftract = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 11*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_difftract = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','difftract.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 11*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_difftract,'Value') == 0
    set (S.stxt_difftract,'Enable','off')
else
    set (S.stxt_difftract,'Enable','on')
end

S.cbh_dti_matrix = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 12*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_dti_matrix = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','dti_matrix.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 12*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_dti_matrix,'Value') == 0
    set (S.stxt_dti_matrix,'Enable','off')
else
    set (S.stxt_dti_matrix,'Enable','on')
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Functional %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%         
%         Template_pipeline{20,1}='fMRI';
%         Template_pipeline{20,2}='Run';
%         Template_pipeline{21,1}='dicom2nii';
%         Template_pipeline{21,2}=0;
%         Template_pipeline{22,1}='fmrimvraw';
%         Template_pipeline{22,2}=0;
%         Template_pipeline{23,1}='fmripreproc';
%         Template_pipeline{23,2}=0;
%         Template_pipeline{24,1}='fmriregspm';
%         Template_pipeline{24,2}=0;
%         Template_pipeline{25,1}='fMRI_matrix';
%         Template_pipeline{25,2}=0;


S.cbh_fmri_dicom2nii = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 14*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_fmri_dicom2nii = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','Functional data conversion.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 14*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

%%%%%% Additional Information for FMRI processing (TR value)
S.stxt_TR_value = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','Repetition Time (TR)',...
    'unit','normalized',...
    'position',[(x_stxt_pos_1 + x_stxt_siz1 + 2*x_cbh_siz1)...
    (y_cbh_pos_1 - 15*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

S.eth_TR = uicontrol(S.fh_fh_genpaths,'Style','edit',...
    'String','2000 ms',...
    'unit','normalized',...
    'position',[(x_stxt_pos_1 + x_stxt_siz1 + 2*x_cbh_siz1)...
    (y_cbh_pos_1 - 16.5*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_fmri_dicom2nii,'Value') == 0
    set (S.stxt_fmri_dicom2nii,'Enable','off')
else
    set (S.stxt_fmri_dicom2nii,'Enable','on')
end

S.cbh_fmrimvraw = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 15*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_fmrimvraw = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','fmrimvraw.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 15*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_fmrimvraw,'Value') == 0
    set (S.stxt_fmrimvraw,'Enable','off')
else
    set (S.stxt_fmrimvraw,'Enable','on')
end

S.cbh_fmripreproc = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 16*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_fmripreproc = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','fmripreproc.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 16*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_fmripreproc,'Value') == 0
    set (S.stxt_fmripreproc,'Enable','off')
else
    set (S.stxt_fmripreproc,'Enable','on')
end

S.cbh_fmriregspm = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 17*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_fmriregspm = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','fmriregspm.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 17*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_fmriregspm,'Value') == 0
    set (S.stxt_fmriregspm,'Enable','off')
else
    set (S.stxt_fmriregspm,'Enable','on')
end

S.cbh_fMRI_matrix = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 18*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_fMRI_matrix = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','fMRI_matrix.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 18*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_fMRI_matrix,'Value') == 0
    set (S.stxt_fMRI_matrix,'Enable','off')
else
    set (S.stxt_fMRI_matrix,'Enable','on')
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% PET %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%         
%         Template_pipeline{30,1}='PET';
%         Template_pipeline{30,2}='Run';
%         Template_pipeline{31,1}='dicom2nii';
%         Template_pipeline{31,2}=0;
%         Template_pipeline{32,1}='pet_preproc';
%         Template_pipeline{32,2}=0;
%         Template_pipeline{33,1}='petregspm';
%         Template_pipeline{33,2}=0;
%         Template_pipeline{34,1}='PET_matrix';
%         Template_pipeline{34,2}=0;
%         


S.cbh_pet_dicom2nii = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 20*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_pet_dicom2nii = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','PET data conversion.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 20*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_pet_dicom2nii,'Value') == 0
    set (S.stxt_pet_dicom2nii,'Enable','off')
else
    set (S.stxt_pet_dicom2nii,'Enable','on')
end

S.cbh_pet_preproc = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 21*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_pet_preproc = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','pet_preproc.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 21*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_pet_preproc,'Value') == 0
    set (S.stxt_pet_preproc,'Enable','off')
else
    set (S.stxt_pet_preproc,'Enable','on')
end

S.cbh_petregspm = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 22*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_petregspm = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','petregspm.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 22*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_petregspm,'Value') == 0
    set (S.stxt_petregspm,'Enable','off')
else
    set (S.stxt_petregspm,'Enable','on')
end

S.cbh_PET_matrix = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 23*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.stxt_PET_matrix = uicontrol(S.fh_fh_genpaths,'Style','text',...
    'String','PET_matrix.',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 23*dy_cbh_stxt) x_stxt_siz1 y_stxt_siz1]);

if get(S.cbh_PET_matrix,'Value') == 0
    set (S.stxt_PET_matrix,'Enable','off')
else
    set (S.stxt_PET_matrix,'Enable','on')
end


%%%%%%%%% STATISTICAL TESTS

S.cbh_stat_tests = uicontrol(S.fh_fh_genpaths,'Style','checkbox',...
    'unit','normalized',...
    'position',[x_cbh_pos_1 (y_cbh_pos_1 - 25*dy_cbh_stxt) x_cbh_siz1 y_cbh_siz1],...
    'Value',1);

S.bgh = uibuttongroup('Parent',S.fh_fh_genpaths,'Title','Statistical Tests',...
    'unit','normalized',...
    'position',[x_stxt_pos_1 (y_cbh_pos_1 - 29*dy_cbh_stxt) 0.2 0.15]);

S.rbh1 = uicontrol(S.bgh,'Style','radiobutton','String','Linear',...
    'unit','normalized',...
    'position',[0.1 0.6 0.6 0.4]);
S.rbh2 = uicontrol(S.bgh,'Style','radiobutton','String','Non-linear',...
    'unit','normalized',...
    'position',[0.1 0.2 0.6 0.4]);

if get(S.cbh_stat_tests,'Value') == 0
    set (S.rbh1,'Enable','off')
    set (S.rbh2,'Enable','off')
else
    set (S.rbh1,'Enable','on')
    set (S.rbh2,'Enable','on')
end

%%%% Start Processing

S.fh_run = uicontrol('style','push',...
    'unit','normalized',...
    'position',[0.7 0.05 0.2 0.85],...
    'fontsize',14,'fontweight','bold', 'String','Process Data',...
    'callback',{@fh_processing});

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
mkdir(output_directory);



for kk=1:length(subjects_names)
    [SUBJECT,sMRI_subdirectory,fMRI_subdirectory,DTI_subdirectory,PET_subdirectory,...
        out_sMRI,out_fMRI,out_DTI,out_PET]=variables_folders_script_MIBCA...
        (output_directory,data_location,subjects_names,sMRI_identifier,fMRI_identifier,DTI_identifier,PET_identifier,kk);
    
    SUBJECT
    if ~isfield(sub_pipeline,SUBJECT)
        sub_pipeline.([SUBJECT])=S;
    end
    
    % Run sMRI pre-processing and analisys
    if ~isempty(sMRI_identifier)
        try
            display('Running sMRI workflow')
            if get(sub_pipeline.([SUBJECT]).S.cbh_str_dicom2nii,'Value')
                dicom2nii_MIBCA(sMRI_subdirectory,out_sMRI,system_initialization,dcm2nii_dir)
                set(sub_pipeline.([SUBJECT]).S.cbh_str_dicom2nii,'Value',0);
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_smrireco,'Value')
                smrireco_MIBCA(out_sMRI,[SUBJECT],system_initialization,sub_dir)
                set(sub_pipeline.([SUBJECT]).S.cbh_smrireco,'Value',0);
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_smrireco2,'Value')
                smrireco2_MIBCA([SUBJECT],system_initialization,sub_dir)
                set(sub_pipeline.([SUBJECT]).S.cbh_smrireco2,'Value',0);
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_smrimvt1,'Value')
                smrimvt1_MIBCA(sub_dir,[SUBJECT],system_initialization,out_sMRI)
                set(sub_pipeline.([SUBJECT]).S.cbh_smrimvt1,'Value',0);
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_smrimvregion,'Value')
                smrimvregion_MIBCA(sub_dir,[SUBJECT],system_initialization,out_sMRI)
                set(sub_pipeline.([SUBJECT]).S.cbh_smrimvregion,'Value',0);
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_sMRI_matrix,'Value')
                sMRI_matrix_MIBCA_v2(sub_dir,[SUBJECT],ctx_labels,out_sMRI);
                set(sub_pipeline.([SUBJECT]).S.cbh_sMRI_matrix,'Value',0);
            end
            display('sMRI done')
            
        catch
            display(['Subject: ', SUBJECT,', Pipeline:sMRI, had an error and was stopped'])
        end
    end
    
    % Run DTI pre-processing and analisys
    if ~isempty(DTI_identifier)
        try
            display('Running DTI workflow')
            if get(sub_pipeline.([SUBJECT]).S.cbh_dwi_dicom2nii,'Value')
                dicom2nii_MIBCA(DTI_subdirectory,out_DTI,system_initialization,dcm2nii_dir)
                set(sub_pipeline.([SUBJECT]).S.cbh_dwi_dicom2nii,'Value',0);
                
                corr_eddy_MIBCA(out_DTI,system_initialization)
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_corr_bvec,'Value')
                type=0;
                corr_bvec_MIBCA(out_DTI,type)
                set(sub_pipeline.([SUBJECT]).S.cbh_corr_bvec,'Value');
            end
                        
            if get(sub_pipeline.([SUBJECT]).S.cbh_diffest,'Value')
                diffest_MIBCA(out_DTI,system_initialization)
                set(sub_pipeline.([SUBJECT]).S.cbh_diffest,'Value',0);
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_diffregspm,'Value')
                diffregspm_MIBCA(out_DTI,sub_dir,[SUBJECT],system_initialization,out_sMRI)
                set(sub_pipeline.([SUBJECT]).S.cbh_diffregspm,'Value',0);
            end
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             INFO ABOUT INVERSION AND SWAPPING NEEDS TO GO IN
%               if S.cbh_dwi_inv_swp_detect = 1 we use our detection
%               if S.cbh_dwi_inv_swp_detect = 0
%               
%               use info from
%                       S.pmh_inv
%                       S.pmh_swp
% 
%                    NEED TO CHANGE DIFFTRACT_MIBCA
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
            if get(sub_pipeline.([SUBJECT]).S.cbh_difftract,'Value')
                difftract_MIBCA(out_DTI,system_initialization)
                set(sub_pipeline.([SUBJECT]).S.cbh_difftract,'Value',0);
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_dti_matrix,'Value')
                dti_matrix_MIBCA(out_DTI,[SUBJECT],ctx_labels)
                set(sub_pipeline.([SUBJECT]).S.cbh_dti_matrix,'Value',0);
            end
            display('DTI done')
        catch
            display(['Subject: ', SUBJECT,', Pipeline:DTI, had an error and was stopped'])
        end
    end
    
    
    % Run fMRI pre-processing and analisys
    if ~isempty(fMRI_identifier)
        display('Running fMRI workflow')
        try
            if get(sub_pipeline.([SUBJECT]).S.cbh_fmri_dicom2nii,'Value')
                dicom2nii_MIBCA(fMRI_subdirectory,out_fMRI,system_initialization,dcm2nii_dir)
                set(sub_pipeline.([SUBJECT]).S.cbh_fmri_dicom2nii,'Value',0);
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_fmrimvraw,'Value')
                fmrimvraw_MIBCA(out_fMRI)
                set(sub_pipeline.([SUBJECT]).S.cbh_fmrimvraw,'Value',0);
            end
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             INFO ABOUT REPETITION TIME (S.eth_TR)
%                    NEED TO CHANGE fmripreproc_MIBCA
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                        
            if get(sub_pipeline.([SUBJECT]).S.cbh_fmripreproc,'Value')
                %%%module FSL
                fmripreproc_MIBCA(out_fMRI,system_initialization)
                %%%module SPM
                % % %                     sliceorder='DK';
                % % %                     TR=2;
                % % %                     fmripreproc_SPM_MIBCA(out_fMRI,TR,sliceorder)
                % % %                     sub_pipeline.([SUBJECT]){23,2}=0;
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_fmriregspm,'Value')
                %%%module FSL
                fmriregspm_MIBCA(out_fMRI,out_sMRI)
                %%%module SPM
                %                     fmriregspm_SPM_MIBCA(out_fMRI,out_sMRI)
                set(sub_pipeline.([SUBJECT]).S.cbh_fmriregspm,'Value',0);
            end
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             CLOSE EFFECTIVE AND COMPLEXITY!!!!!!!!!!!
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            jade=0;
            effective_fmri=1;
            complexity_fmri=1;
            if get(sub_pipeline.([SUBJECT]).S.cbh_fMRI_matrix,'Value')
                fMRI_matrix_MIBCA_new(out_fMRI,[SUBJECT], jade,ctx_labels,effective_fmri,complexity_fmri)
                set(sub_pipeline.([SUBJECT]).S.cbh_fMRI_matrix,'Value',0);
            end
            display('fMRI done')
        catch
            display(['Subject: ', SUBJECT,', Pipeline:fMRI, had an error and was stopped'])
        end
    end
    
    %Run PET pre-processing and analisys
    if ~isempty(PET_identifier)
        try
            display('Running PET workflow')
            if get(sub_pipeline.([SUBJECT]).S.cbh_pet_dicom2nii,'Value')
                dicom2nii_PET_MIBCA(PET_subdirectory,out_PET,system_initialization,dcm2nii_dir)
                set(sub_pipeline.([SUBJECT]).S.cbh_pet_dicom2nii,'Value',0);
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_pet_preproc,'Value');
                %%%module FSL
                %                     pet_preproc_MIBCA(out_PET,system_initialization)
                %%%module SPM
                pet_preproc_SPM_MIBCA(out_PET)
                set(sub_pipeline.([SUBJECT]).S.cbh_pet_preproc,'Value',0);
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_petregspm,'Value',0)
                %%%module FSL
                %                   petregspm_MIBCA(out_PET,sub_dir,[SUBJECT],system_initialization,out_sMRI)
                %%%module SPM
                petregspm_SPM_MIBCA(out_PET,out_sMRI)
                set(sub_pipeline.([SUBJECT]).S.cbh_petregspm,'Value',0);
            end
            if get(sub_pipeline.([SUBJECT]).S.cbh_PET_matrix,'Value')
                jade=0;
                %%%module FSL
                %                   PET_matrix_MIBCA_new(out_PET,[SUBJECT], jade,ctx_labels)
                %%%module SPM
                PET_matrix_SPM_MIBCA_new(out_PET,[SUBJECT], jade,ctx_labels)
                set(sub_pipeline.([SUBJECT]).S.cbh_PET_matrix,'Value',0);
            end
            display('PET done')
            
        catch
            display(['Subject: ', SUBJECT,', Pipeline:PET, had an error and was stopped'])
        end
    end
    
    %%%group SUBJECT data
    smri_data=[];
    fmri_data=[];
    dti_data=[];
    pet_data=[];
    out_var_save=[];
    
    on_smri=exist([out_sMRI,SUBJECT,'_smri_data.mat'],'file')==2;
    if on_smri
        smri_data=load([out_sMRI,SUBJECT,'_smri_data.mat']);
        out_var_save=[out_var_save,'''smri_data'','];
    end
    on_dti=exist([out_DTI,SUBJECT,'_dti_data.mat'],'file')==2;
    if on_dti
        dti_data=load([out_DTI,SUBJECT,'_dti_data.mat']);
        out_var_save=[out_var_save,'''dti_data'','];
    end
    on_fmri=exist([out_fMRI,SUBJECT,'_fmri_data.mat'],'file')==2;
    if on_fmri
        fmri_data=load([out_fMRI,SUBJECT,'_fmri_data.mat']);
        out_var_save=[out_var_save,'''fmri_data'','];
    end
    on_pet=exist([out_PET,SUBJECT,'_pet_data.mat'],'file')==2;
    if on_pet
        pet_data=load([out_PET,SUBJECT,'_pet_data.mat']);
        out_var_save=[out_var_save,'''pet_data'''];
    end
    
    if strcmp(out_var_save(end),',')
        out_var_save=out_var_save(1:end-1);
    end
    eval(['save([output_directory,SUBJECT,''/'',SUBJECT,''_grouped_data.mat''],',out_var_save,')'])
    %%%
    %%%group all SUBJECT data
    try
        all_data.(['s_',SUBJECT])=load([output_directory,SUBJECT,'/',SUBJECT,'_grouped_data.mat']);
    catch
        'something failed'
    end
    %%%
end

save([output_directory,'all_group_data.mat'],'all_data','-v7.3');
% % % %         save([output_directory,'processing_pipeline.mat'],'sub_pipeline');

all_data=[];
load([output_directory,'all_group_data.mat']);
%         mean_group_MIBCA_new3(all_data,output_directory,ctx_labels);
% create_contrast_MIBCA_ICBM(all_data,output_directory,ctx_labels);
create_contrast_MIBCA(all_data,output_directory,ctx_labels);  

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


end