function fmripreproc_MIBCA(out_fMRI,system_initialization,str_TR)
%Developed by A. Santos Ribeiro
%%%%

scans_fMRI=dir(out_fMRI);
for i=1:length(scans_fMRI)
    temp_image=scans_fMRI(i).name;
    s_directory=[out_fMRI,temp_image,'/'];
    if isdir(s_directory)
        
        if ~((strcmp(temp_image,'.')) || (strcmp(temp_image,'..')) || (strcmp(temp_image,'.DS_Store'))|| (exist(s_directory)~=7))
            mod_design_text = fopen([s_directory,'design.fsf'],'w+');
            
            temp_design_text = textread('template_design.fsf', '%s', 'delimiter', '\n');
            temp_design_text{36}= ['set fmri(outputdir) "',out_fMRI,temp_image,'"'];
            temp_design_text{39}= ['set fmri(tr) "',str_TR,'"'];
            temp_design_text{281}=['set feat_files(1) "',s_directory,temp_image,'"'];
            
            gunzip([s_directory,temp_image,'.nii.gz'])
            img_h=spm_vol([s_directory,temp_image,'.nii']);
            timepoints=length(img_h);
            temp_design_text{42}=['set fmri(npts) ', num2str(timepoints)];
            delete([s_directory,temp_image,'.nii'])
            
            for j=1:length(temp_design_text)
                fprintf(mod_design_text,'%s\n',temp_design_text{j});
            end
            
            fclose(mod_design_text)
            
            call_fsl([system_initialization,'feat ',s_directory,'design.fsf'])
            copyfile([out_fMRI,temp_image,'.feat/','filtered_func_data.nii.gz'],[s_directory,'filtered_func_data.nii.gz']);
            movefile([out_fMRI,temp_image,'.feat/'],[s_directory]);
            delete([s_directory,'design.fsf'])
            
            
            %             system([system_initialization,'melodic -i ', s_directory, 'filtered_func_data.nii -n 25 -d 25']);
            call_fsl(['bash -c ',system_initialization,'melodic -i ', s_directory, 'filtered_func_data.nii -n 25 -d 25']);
            
        end
    end
end
end
