function fmripreproc_SPM_MIBCA(out_fMRI,TR,sliceorder)
%Developed by A. Santos Ribeiro
%%%%

scans_fMRI=dir(out_fMRI);
for i=1:length(scans_fMRI)
    temp_image=scans_fMRI(i).name;
    s_directory=[out_fMRI,temp_image,'/'];
    if isdir(s_directory)
        
        if ~((strcmp(temp_image,'.')) || (strcmp(temp_image,'..')) || (strcmp(temp_image,'.DS_Store'))|| (exist(s_directory)~=7))
            
            gunzip([s_directory,temp_image,'.nii.gz'])
            img_h=spm_vol([s_directory,temp_image,'.nii']);
            timepoints=length(img_h);
            
            P=[s_directory,temp_image,'.nii'];
            nslice=img_h(1).dim(3);
            timing(1) = (TR-TR/nslice) / (nslice -1);
            timing(2) = TR/nslice;
            if strcmp(sliceorder,'ascending')
                spm_slice_timing(P, 1:timepoints, 1, timing, 's');
            elseif strcmp(sliceorder,'descending')
                spm_slice_timing(P, timepoints:-1:1, 1, timing, 's');
            elseif (strcmp(sliceorder,'Interleave') || strcmp(sliceorder,'DK'))
                if mod(timepoints,2)==1
                    spm_slice_timing(P, [1:2:timepoints,2:2:timepoints], 1, timing, 's');
                else
                    spm_slice_timing(P, [2:2:timepoints,1:2:timepoints], 1, timing, 's');
                end
            end
            gzip([s_directory,'s',temp_image,'.nii'])
            delete([s_directory,temp_image,'.nii'])
            
            fmri_param.eoptions.quality=0.9;
            fmri_param.eoptions.sep=4;
            fmri_param.eoptions.fwhm=5;
            fmri_param.eoptions.rtm=1;
            fmri_param.eoptions.interp=2;
            fmri_param.eoptions.wrap=[0,0,0];
            fmri_param.eoptions.weight='';
            fmri_param.roptions.which=[2,1];
            fmri_param.roptions.interp=4;
            fmri_param.roptions.wrap=[0,0,0];
            fmri_param.roptions.mask=1;
            fmri_param.roptions.prefix='r';
            for j=1:timepoints
                fmri_param.data{j,1}=[s_directory,'s',temp_image,'.nii,',num2str(j)];
            end
            fmri_param.data={fmri_param.data};
            spm_run_realign_estwrite(fmri_param);
            gzip([s_directory,'rs',temp_image,'.nii'])
            delete([s_directory,'s',temp_image,'.nii'])
        
% % %             %%%temporal filtering
% % %             gunzip([s_directory,'rs',temp_image,'.nii.gz'])
% % %             img_h=spm_vol([s_directory,'rs',temp_image,'.nii']);
% % %             img_vol=spm_read_vols(img_h);
% % %             
% % %             p2=[5,5,5];
% % %             p3=1;
% % %             siz = (p2-1)/2;
% % %             std2 = p3^2;
% % %             [x,y,z] = meshgrid(-siz(2):siz(2),-siz(1):siz(1),-siz(3):siz(3));
% % %             h_s = exp(-(x.*x + y.*y+ z.*z)/(2*std2));
% % %             h_s=repmat(h_s,[1,1,1,15]);
% % %             p2=15;
% % %             p3=1;
% % %             siz = (p2-1)/2;
% % %             std2 = p3^2;
% % %             x=-siz(1):siz(1);
% % % %             h_t = -exp(-(x.*x)/(2*std2))+exp(-(x.*x)/(2*(std2*160)));
% % %             h = exp(-(x.*x)/(2*std2));
% % %             h_t = h.*(x.*x - 2*std2)/(std2^2);
% % %             h_t=permute(repmat(h_t',[1,5,5,5]),[2,3,4,1]);
% % %             h_t = h_t-sum(h_t(:))/numel(h_t);
% % %             
% % %             h=h_t.*h_s;
% % %             h=h./sum(abs(h(:)));
% % % %             img_vol=convn(img_vol,h,'same');
% % %             img_regr=convnfft(img_vol,h,'same');
% % %             new_img_vol=img_regr;
% % %             
% % %             tf_img_h=img_h(floor(size(h,4)/2)+1:end-floor(size(h,4)/2));
% % %             for j=1:size(new_img_vol,4)-size(h,4)+1
% % %             tf_img_h(j).dt=[16 0];
% % %             tf_img_h(j).n=tf_img_h(j).n-[floor(size(h,4)/2),0];
% % %             tf_img_h(j).fname=[s_directory,'tf_rs',temp_image,'.nii'];
% % %             spm_write_vol(tf_img_h(j),new_img_vol(:,:,:,j+floor(size(h,4)/2)));
% % %             end
% % %             delete([s_directory,'rs',temp_image,'.nii'])
% % %             %%%
            
            clear fmri_param
            smooth_value=8;
            fmri_param.fwhm=[smooth_value,smooth_value,smooth_value];
            fmri_param.dtype=0;
            fmri_param.im=0;
            fmri_param.prefix='s';
            for j=1:timepoints-size(h,4)+1
                fmri_param.data{j,1}=[s_directory,'rs',temp_image,'.nii,',num2str(j)];
            end
            spm_run_smooth(fmri_param);
            gzip([s_directory,'srs',temp_image,'.nii'])
            delete([s_directory,'srs',temp_image,'.nii'])
            
            delete([s_directory,'means',temp_image,'.nii']);
            img_h=spm_vol([s_directory,'srs',temp_image,'.nii']);
            mean_img_h=img_h(1);
            mean_img_h.fname=[s_directory,'mean_srs',temp_image,'.nii'];
            img_vol=spm_read_vols(img_h);
            mean_img_vol=mean(img_vol,4);
            spm_write_vol(mean_img_h,mean_img_vol);
            gzip([s_directory,'mean_srs',temp_image,'.nii']);
            delete([s_directory,'mean_srs',temp_image,'.nii']);
            delete([s_directory,'srs',temp_image,'.nii']);
            
        end
    end
end
end
