function fmriregspm_SPM_MIBCA(out_fMRI,out_sMRI)
%Developed by A. Santos Ribeiro
%%%%

global Ptransform

scans_fMRI=dir(out_fMRI);
scans_fMRI=struct2cell(scans_fMRI);
isdir_fMRI=scans_fMRI(4,:)';
scans_fMRI=scans_fMRI(1,:)';

scans_fMRI_temp=cell2mat(cellfun(@(C) strcmp(C,'..'), scans_fMRI, 'UniformOutput', false));
scans_fMRI_temp=scans_fMRI_temp | cell2mat(cellfun(@(C) strcmp(C,'.'), scans_fMRI, 'UniformOutput', false));
scans_fMRI_temp=scans_fMRI_temp | cell2mat(cellfun(@(C) strcmp(C,'.DS_Store'), scans_fMRI, 'UniformOutput', false));

scans_fMRI_temp=scans_fMRI_temp | (~cell2mat(isdir_fMRI));
scans_fMRI=scans_fMRI(~scans_fMRI_temp);
for i=1:length(scans_fMRI)
    temp_image=scans_fMRI{i};
    s_directory=[out_fMRI,temp_image,'/'];
    
    if isdir(s_directory)
        
        corr_par.ref={[s_directory,'mean_srs',temp_image,'.nii,1']};
        corr_par.source={[out_sMRI,'/brain.nii',',1']};
        corr_par.other={[out_sMRI,'/aparc+aseg.nii',',1']};
        corr_par.eoptions.cost_fun='nmi';
        corr_par.eoptions.sep=[4,2];
        corr_par.eoptions.fwhm=[7 7];
        corr_par.roptions.interp=0; %%%% 1 para trilinear, 0 para nearest
        corr_par.roptions.wrap=[0 0 0];
        corr_par.roptions.mask=1;
        corr_par.roptions.prefix='r';
        
        Ptransform=[];
        
        if ~((strcmp(temp_image,'.')) || (strcmp(temp_image,'..')) || (strcmp(temp_image,'.DS_Store'))|| (exist(s_directory)~=7))
            
            
            temp_image222=[out_sMRI,'/brain.nii'];
            if ~exist(temp_image222)
                gunzip([temp_image222,'.gz'])
            end
            temp_image222=[s_directory,'mean_srs',temp_image,'.nii'];
            if ~exist(temp_image222)
                gunzip([temp_image222,'.gz'])
            end
            temp_image222=[s_directory,'aparc+aseg2fMRI.nii'];
            if ~exist(temp_image222)
                try
                    gunzip([temp_image222,'.gz'])
                end
            end
            temp_image222=[out_sMRI,'/aparc+aseg.nii'];
            if ~exist(temp_image222)
                gunzip([temp_image222,'.gz'])
            end
            
            
            if ~exist([s_directory,'aparc+aseg2fMRI.nii'])
                out = spm_run_coreg_estwrite(corr_par);
                if ~isstruct(out)
                    s_T1=load_untouch_nii([out_sMRI,'/brain.nii']);
                    s_fmri=load_untouch_nii([s_directory,'mean_srs',temp_image,'.nii']);
                    GUI_MIBCA_3(s_fmri,s_T1)
                    pause
                    out = spm_run_coreg_estwrite(corr_par);
                end
                movefile([out_sMRI,'/raparc+aseg.nii'],[s_directory, 'aparc+aseg2fMRI.nii'])
                
            else
                s_T1=load_untouch_nii([s_directory, 'aparc+aseg2fMRI.nii']);
                s_fmri=load_untouch_nii([s_directory,'mean_srs',temp_image,'.nii']);
                GUI_MIBCA_3(s_fmri,s_T1)
                str = input('wish to redo coregistration(y/n)?','s');
                if strcmp(str,'y')
                    s_T1=load_untouch_nii([out_sMRI,'/brain.nii']);
                    s_fmri=load_untouch_nii([s_directory,'mean_srs',temp_image,'.nii']);
                    GUI_MIBCA_3(s_fmri,s_T1)
                    pause
                    out = spm_run_coreg_estwrite(corr_par);
                    movefile([out_sMRI,'raparc+aseg.nii'],[s_directory,'/aparc+aseg2fMRI.nii'])
                end
            end
            
            
            
        end
    end
end
end
