function XcY = granger_MIBCA(x,y,alpha,max_lag)
x=x-mean(x);
x=x/std(x);
y=y-mean(y);
y=y/std(y);

if size(x,1)==1,x=x';end
if size(y,1)==1,y=y';end

%First find the proper model specification using the Bayesian Information
%Criterion for the number of lags of x
T = length(x);
BIC = zeros(max_lag,1);

%Specify a matrix for the restricted RSS
RSS_R = zeros(max_lag,1);
i = 1;
while i <= max_lag
    ystar = x(i+1:T,:);
    %Populate the xstar matrix with the corresponding vectors of lags
    j = 1;
    clear xstar
    while j <= i
        xstar(:,j) = x(i+1-j:T-j);
        j = j+1;
    end
    %Apply the regress function. b = betahat, bint corresponds to the 95%
    %confidence intervals for the regression coefficients and r = residuals
%     [b,bint,r] = regress(ystar,xstar);
    [~,~,mse] = lscov(xstar,ystar);
    mse=mse.^2;

    %Find the bayesian information criterion
    BIC(i,:) = T*log(mse/T) + (i+1)*log(T);
    
    %Put the restricted residual sum of squares in the RSS_R vector
    RSS_R(i,:) = mse;
    
    i = i+1;
    
end
[dummy,x_lag] = min(BIC);

%First find the proper model specification using the Bayesian Information
%Criterion for the number of lags of y

BIC = zeros(max_lag,1);

%Specify a matrix for the unrestricted RSS
RSS_U = zeros(max_lag,1);

i = 1;
while i <= max_lag
    
    ystar = x(i+x_lag+1:T,:);
%     xstar = [zeros(T-(i+x_lag),x_lag+i)];
    %Populate the xstar matrix with the corresponding vectors of lags of x
    j = 1;
    clear xstar
    while j <= x_lag
        xstar(:,j) = x(i+x_lag+1-j:T-j,:);
        j = j+1;
    end
    %Populate the xstar matrix with the corresponding vectors of lags of y
    j = 1;
    while j <= i
        xstar(:,x_lag+j) = y(i+x_lag+1-j:T-j,:);
        j = j+1;
    end
    %Apply the regress function. b = betahat, bint corresponds to the 95%
    %confidence intervals for the regression coefficients and r = residuals
%     [b,bint,r] = regress(ystar,xstar);
    [~,~,mse] = lscov(xstar,ystar);
    mse=mse.^2;

    %Find the bayesian information criterion
    BIC(i,:) = T*log(mse/T) + (i+1)*log(T);
    
    RSS_U(i,:) = mse;
    
    i = i+1;
    
end
[dummy,y_lag] =min(BIC);

%The numerator of the F-statistic
F_num = ((RSS_R(x_lag,:) - RSS_U(y_lag,:))/y_lag);

%The denominator of the F-statistic
F_den = RSS_U(y_lag,:)/(T-(x_lag+y_lag+1));

%The F-Statistic
F = F_num/F_den;
c_v = finv(1-alpha,y_lag,(T-(x_lag+y_lag+1)));

XcY=F>c_v;



    
    
    
    


