function mean_group_MIBCA(all_data,regions2analy,output_directory,sMRI_identifier,DTI_identifier,fMRI_identifier,PET_identifier)

regions2analy=1:length(regions2analy);

subjects=fieldnames(all_data);
thickness=zeros(length(regions2analy),length(regions2analy),length(subjects));
area=zeros(length(regions2analy),length(regions2analy),length(subjects));
volume=zeros(length(regions2analy),length(regions2analy),length(subjects));
thickness_val=zeros(length(regions2analy),length(subjects));
area_val=zeros(length(regions2analy),length(subjects));
volume_val=zeros(length(regions2analy),length(subjects));

dti_fiber=zeros(length(regions2analy),length(regions2analy),length(subjects));
dti_length=zeros(length(regions2analy),length(regions2analy),length(subjects));
fmri_r=zeros(length(regions2analy),length(regions2analy),length(subjects));

for i=1:length(subjects)
    if ~isempty(sMRI_identifier)
    temp_thickness=all_data.(subjects{i}).smri_data...
        .thickness_ratio_matrix(regions2analy,regions2analy);
    thickness(:,:,i)=temp_thickness;%double((temp_thickness>0.95) & (temp_thickness<1.05));
    
    temp_area=all_data.(subjects{i}).smri_data...
        .area_ratio_matrix(regions2analy,regions2analy);
    area(:,:,i)=temp_area;%double((temp_area>0.95) & (temp_area<1.05));
    
    temp_volume=all_data.(subjects{i}).smri_data...
        .volume_ratio_matrix(regions2analy,regions2analy);
    volume(:,:,i)=temp_volume;%double((temp_volume>0.95) & (temp_volume<1.05));
    
    temp_thickness_val=all_data.(subjects{i}).smri_data...
        .thickness(regions2analy);
    thickness_val(:,i)=temp_thickness_val;
    
    temp_area_val=all_data.(subjects{i}).smri_data...
        .area(regions2analy);
    area_val(:,i)=temp_area_val;
    
    temp_volume_val=all_data.(subjects{i}).smri_data...
        .volume(regions2analy);
    volume_val(:,i)=temp_volume_val;
    
    end
    
    if ~isempty(DTI_identifier)
    dti_fiber(:,:,i)=all_data.(subjects{i}).dti_data.mean_dti_fiber(regions2analy,regions2analy);
    dti_length(:,:,i)=all_data.(subjects{i}).dti_data.mean_dti_length(regions2analy,regions2analy);
    end
    
    if ~isempty(fMRI_identifier)
    fmri_r(:,:,i)=all_data.(subjects{i}).fmri_data.mean_fmri_r(regions2analy,regions2analy);
    end
end
s_thickness=sum((thickness>0.95) & (thickness<1.05),3);
s_area=sum((area>0.95) & (area<1.05),3);
s_volume=sum((volume>0.95) & (volume<1.05),3);

m_thickness_val=mean(thickness_val,2);
m_area_val=mean(area_val,2);
m_volume_val=mean(volume_val,2);

m_dti_fiber=mean(dti_fiber,3);
m_dti_length=mean(dti_length,3);

mean_fmri_r=mean(fmri_r,3);

all_data.mean_data.s_thickness=s_thickness;
all_data.mean_data.s_area=s_area;
all_data.mean_data.s_volume=s_volume;
all_data.mean_data.m_thickness_val=m_thickness_val;
all_data.mean_data.m_area_val=m_area_val;
all_data.mean_data.m_volume_val=m_volume_val;
all_data.mean_data.m_dti_fiber=m_dti_fiber;
all_data.mean_data.m_dti_length=m_dti_length;
all_data.mean_data.mean_fmri_r=mean_fmri_r;

m_dti_fiber(isnan(m_dti_fiber(:)))=0;
[deg_M_wei_u_dti_fiber,c_wei_u_dti_fiber,C_wei_u_dti_fiber,...
    D_wei_u_dti_fiber,S_wei_dti_fiber]=BCT_MIBCA(m_dti_fiber,1);

all_data.mean_data.deg_M_wei_u_dti_fiber=deg_M_wei_u_dti_fiber;
all_data.mean_data.c_wei_u_dti_fiber=c_wei_u_dti_fiber;
all_data.mean_data.C_wei_u_dti_fiber=C_wei_u_dti_fiber;
all_data.mean_data.D_wei_u_dti_fiber=D_wei_u_dti_fiber;
all_data.mean_data.S_wei_dti_fiber=S_wei_dti_fiber;


%%% group study
save([output_directory,'all_group_data.mat'],'all_data','-v7.3');
%%%
















