function [mean_X1_f,ROI_zeros,mean_activation,brain_X1_fdata]=measures_mean_jade_fmri_MIBCA (dinamic_nii,region_nii,ctx_labels,sel_labels,jade,mean_fMRI)
%Developed by A. Santos Ribeiro
%%%%

regions=region_nii.img;
regions=double(regions);
data=dinamic_nii.img;
data=double(data);

region2analy=unique(regions(:));
region2analy(region2analy(:)==0)=[];
all_regions=cell2mat(ctx_labels(:,1));

ROI_zeros=ones(1,length(sel_labels));
sel_labels=find(sel_labels);
mean_X1_f=zeros(length(sel_labels),size(data,4));
mean_activation=zeros(length(sel_labels),1);

for i=1:length(region2analy)
    iter_region=find(region2analy(i)==all_regions,1);
    if ~isempty(iter_region)
        roi_label=ctx_labels{iter_region,1};
        ROI=regions==roi_label;
        ROI_zeros(iter_region)=0;
        
        mean_activation(iter_region)=nansum(mean_fMRI(:).*ROI(:))/sum(ROI(:));
        if mean_activation(iter_region)==0
            mean_activation(iter_region)=NaN;
        end
        
        X1_f=[];
        for t=1:size(data,4)
            tmp_data=data(:,:,:,t);
            X1_f(:,t)=tmp_data(ROI(:));
        end;
        if jade==1
            X1_f=X1_f-repmat(mean(X1_f,2),1,size(X1_f,2));
            mean_X1_f(iter_region,:)=jadeR_modified_MIBCA(X1_f,1);
        else
%             X1_f=X1_f-repmat(mean(X1_f,2),1,size(X1_f,2));
            mean_X1_f(iter_region,:)=nanmean(X1_f,1);        
        end
    end
end

for t=1:size(data,4)
        temp_data=data(:,:,:,t).*(regions>0);
        brain_X1_fdata(1,t)=nanmean(temp_data(:),1);
end

% for i=1:length(sel_labels)
%     roi_label=ctx_labels{sel_labels(i),1};
%     ROI=regions==roi_label;
%     ROI_zeros(sel_labels(i))=~any(ROI(:));
%
%     X1_f=[];
%     for t=1:size(data,4)
%         tmp_data=data(:,:,:,t);
%         X1_f(:,t)=tmp_data(ROI(:));
%     end;
%     if jade==1
%         X1_f=X1_f-repmat(mean(X1_f,2),1,138);
%         mean_X1_f(i,:)=jadeR_modified_MIBCA(X1_f,1);
%     else
%         X1_f=X1_f-repmat(mean(X1_f,2),1,138);
%         mean_X1_f(i,:)=mean(X1_f,1);
%     end
% end
return



