function pet_preproc_MIBCA(out_PET,system_initialization)
%Developed by A. Santos Ribeiro
%%%%

scans_DTI=dir(out_PET);
for i=1:length(scans_DTI)
    fslmerge=[];
    fslmaths=[];
    
    temp_image=scans_DTI(i).name;
    s_directory=[out_PET,temp_image,'/'];
    
    if isdir(s_directory)
        if ~((strcmp(temp_image,'.')) || (strcmp(temp_image,'..')) || (strcmp(temp_image,'.DS_Store')))
            
            if ~isempty(dir([s_directory,'merge_rs_*'])), return, end
            
            smooth_value=8;
            smooth_array=[smooth_value,smooth_value,smooth_value];
            try
                fslsplit=['fslsplit ',s_directory,temp_image,'.nii.gz ',s_directory,temp_image,' -t'];
                system([system_initialization,fslsplit])
                try
                    movefile([s_directory,temp_image,'.nii.gz'],[s_directory,'orig_',temp_image,'.nii.gz'])
                catch
                    movefile([s_directory,temp_image,'.nii'],[s_directory,'orig_',temp_image,'.nii'])
                end
                gunzip([s_directory,temp_image,'*.nii.gz'])
                movefile([s_directory,'orig_',temp_image,'.nii.gz'],[s_directory,temp_image,'.nii.gz'])
            end
            
            dir_names=strsplit(ls([s_directory,temp_image,'*.nii']),' ');
            %         dir_names(end)=[];
            in_names=cellfun(@(C) C(length(s_directory)+1:end),dir_names,'UniformOutput',false');
            out_names=cellfun(@(C) [s_directory,'s_',C],in_names,'UniformOutput',false');
            out_names_r=cellfun(@(C) [s_directory,'rs_',C],in_names,'UniformOutput',false');
            
            pet_param.eoptions.quality=0.9;
            pet_param.eoptions.sep=4;
            pet_param.eoptions.fwhm=5;
            pet_param.eoptions.rtm=1;
            pet_param.eoptions.interp=2;
            pet_param.eoptions.wrap=[0,0,0];
            pet_param.eoptions.weight='';
            
            pet_param.roptions.which=[2,1];
            pet_param.roptions.interp=4;
            pet_param.roptions.wrap=[0,0,0];
            pet_param.roptions.mask=1;
            pet_param.roptions.prefix='r';
            
            for j=1:length(in_names)
                spm_smooth(dir_names{j},out_names{j},smooth_array,0)
                pet_param.data{j,1}={[out_names{j},',1']};
                
                if isempty(fslmaths)
                    fslmaths=['fslmaths ', out_names_r{j}];
                else
                    fslmaths=[fslmaths,' -add ',out_names_r{j}];
                end
                fslmerge=[fslmerge, ' ', out_names_r{j}];
            end
            out = spm_run_realign_estwrite(pet_param);
            
            fslmaths=[fslmaths, ' ', s_directory,'sum_rs_',temp_image];
            system([system_initialization,fslmaths])
            gunzip([s_directory,'sum_rs_',temp_image,'.nii.gz'])
            
            fslmerge=['fslmerge -t ',s_directory,'merge_rs_',temp_image, ' ',fslmerge];
            system([system_initialization,fslmerge])
            gunzip([s_directory,'merge_rs_',temp_image,'.nii.gz'])
            
            %             for j=1:length(in_names)
            %                 delete([out_names{j},'*'])
            %                 delete([out_names_r{j},'*'])
            %                 delete([in_names,'*'])
            %             end
            %
            
        end
    end
    
end


