function pet_preproc_SPM_MIBCA(out_PET)
%Developed by A. Santos Ribeiro
%%%%

scans_DTI=dir(out_PET);
for i=1:length(scans_DTI)    
    temp_image=scans_DTI(i).name;
    s_directory=[out_PET,temp_image,'/'];
    
    if isdir(s_directory)
        if ~((strcmp(temp_image,'.')) || (strcmp(temp_image,'..')) || (strcmp(temp_image,'.DS_Store')))
            
            gunzip([s_directory,temp_image,'.nii.gz'])
            img_h=spm_vol([s_directory,temp_image,'.nii']);
            timepoints=length(img_h);
            
            clear PET_param
            smooth_value=8;
            PET_param.fwhm=[smooth_value,smooth_value,smooth_value];
            PET_param.dtype=0;
            PET_param.im=0;
            PET_param.prefix='s';
            for j=1:timepoints
                PET_param.data{j,1}=[s_directory,temp_image,'.nii,',num2str(j)];
            end                
            spm_run_smooth(PET_param);
            gzip([s_directory,'s',temp_image,'.nii'])
            delete([s_directory,temp_image,'.nii'])
            
            clear PET_param
            PET_param.eoptions.quality=0.9;
            PET_param.eoptions.sep=4;
            PET_param.eoptions.fwhm=5;
            PET_param.eoptions.rtm=1;
            PET_param.eoptions.interp=2;
            PET_param.eoptions.wrap=[0,0,0];
            PET_param.eoptions.weight='';
            PET_param.roptions.which=[2,1];
            PET_param.roptions.interp=4;
            PET_param.roptions.wrap=[0,0,0];
            PET_param.roptions.mask=1;
            PET_param.roptions.prefix='r';
            for j=1:timepoints
            PET_param.data{j,1}=[s_directory,'s',temp_image,'.nii,',num2str(j)];
            end
            PET_param.data={PET_param.data};
            spm_run_realign_estwrite(PET_param);
            gzip([s_directory,'rs',temp_image,'.nii'])
            delete([s_directory,'s',temp_image,'.nii'])
            

            delete([s_directory,'means',temp_image,'.nii'])
            img_h=spm_vol([s_directory,'rs',temp_image,'.nii']);
            sum_img_h=img_h(1);
            sum_img_h.fname=[s_directory,'sum_rs',temp_image,'.nii'];
            img_vol=spm_read_vols(img_h);
            sum_img_vol=sum(img_vol,4);
            spm_write_vol(sum_img_h,sum_img_vol)
            gzip([s_directory,'sum_rs',temp_image,'.nii'])
            delete([s_directory,'sum_rs',temp_image,'.nii'])
            delete([s_directory,'rs',temp_image,'.nii'])

        end
    end
    
end


