function [R,t] = rigid_transform_3D_MIBCA(A, B)

%Developed by A. Santos Ribeiro
%%%%


    if nargin ~= 2
	    error('Missing parameters');
    end

    assert(all(size(A) == size(B)))

    centroid_A = mean(A);
    centroid_B = mean(B);

    N = size(A,1);

    H = (A - repmat(centroid_A, N, 1))' * (B - repmat(centroid_B, N, 1));

    [U,S,V] = svd(H);

    R = V*U';

    if det(R) < 0
        'Reflection detected\n'
        V(:,3) = V(:,3).*(-1);
        R = V*U';
    end

%     t_R=R;
%     R(1,:)=t_R(3,:);
%     R(3,:)=t_R(1,:);
    t = -R*centroid_A' + centroid_B';
end

