function sMRI_matrix_MIBCA(sub_dir,SUBJECT,ctx_labels,out_sMRI)

%Developed by A. Santos Ribeiro
%%%%

% % % T = fileread(['/usr/local/freesurfer/subjects/',SUBJECT,'/stats/aseg.stats']);
% % % T = regexp(T, '\n', 'split');
% % % if isempty(T{end}),T(end)=[];end
% % % header_lines=cellfun(@(A) strcmp(A(1),'#'),T);
% % % T(header_lines)=[];
% % % T=cellfun(@(A) strsplit(A),T,'UniformOutput',false);

all_regions=cell2mat(ctx_labels(:,1));
all_regions_names=ctx_labels(:,2);
ctx_volume=zeros(length(all_regions),1);
ctx_area=zeros(length(all_regions),1);
ctx_thickness=zeros(length(all_regions),1);

%%% volume
T = readtable([sub_dir,SUBJECT,'/stats/aseg.stats'],...
    'FileType','text','HeaderLines',68,'ReadVariableNames',false);
T=table2cell(T);
T = regexp(T, ' +', 'split');
% for alterado
for i=1:(length(T)-11)
    ctx_volume(find(all_regions==str2num(T{i+11}{2})))=str2num(T{i+11}{4});
end

% % % % % % % %versao antiga
% % % % % % % for i=1:length(T)
% % % % % % %     ctx_volume(find(all_regions==str2num(T{i}{2})))=str2num(T{i}{4});
% % % % % % % end

T = readtable([sub_dir,SUBJECT,'/stats/lh.aparc.stats'],...
    'FileType','text','HeaderLines',53,'ReadVariableNames',false);
T=table2cell(T);
T = regexp(T, ' +', 'split');
for i=1:length(T)
    find_name=strfind(all_regions_names(43:78),T{i}{1});
    find_name=cellfun(@(A) ~isempty(A),find_name);
    ctx_volume(42+find(find_name))=str2num(T{i}{4});
end
T = readtable([sub_dir,SUBJECT,'/stats/rh.aparc.stats'],...
    'FileType','text','HeaderLines',53,'ReadVariableNames',false);
T=table2cell(T);
T = regexp(T, ' +', 'split');
for i=1:length(T)
    find_name=strfind(all_regions_names(79:114),T{i}{1});
    find_name=cellfun(@(A) ~isempty(A),find_name);
    ctx_volume(78+find(find_name))=str2num(T{i}{4});
end

%%% thickness
T = readtable([sub_dir,SUBJECT,'/stats/lh.aparc.stats'],...
    'FileType','text','HeaderLines',53,'ReadVariableNames',false);
T=table2cell(T);
T = regexp(T, ' +', 'split');
for i=1:length(T)
    find_name=strfind(all_regions_names(43:78),T{i}{1});
    find_name=cellfun(@(A) ~isempty(A),find_name);
    ctx_thickness(42+find(find_name))=str2num(T{i}{5});
end
T = readtable([sub_dir,SUBJECT,'/stats/rh.aparc.stats'],...
    'FileType','text','HeaderLines',53,'ReadVariableNames',false);
T=table2cell(T);
T = regexp(T, ' +', 'split');
for i=1:length(T)
    find_name=strfind(all_regions_names(79:114),T{i}{1});
    find_name=cellfun(@(A) ~isempty(A),find_name);
    ctx_thickness(78+find(find_name))=str2num(T{i}{5});
end

%%% area
T = readtable([sub_dir,SUBJECT,'/stats/lh.aparc.stats'],...
    'FileType','text','HeaderLines',53,'ReadVariableNames',false);
T=table2cell(T);
T = regexp(T, ' +', 'split');
for i=1:length(T)
    find_name=strfind(all_regions_names(43:78),T{i}{1});
    find_name=cellfun(@(A) ~isempty(A),find_name);
    ctx_area(42+find(find_name))=str2num(T{i}{3});
end
T = readtable([sub_dir,SUBJECT,'/stats/rh.aparc.stats'],...
    'FileType','text','HeaderLines',53,'ReadVariableNames',false);
T=table2cell(T);
T = regexp(T, ' +', 'split');
for i=1:length(T)
    find_name=strfind(all_regions_names(79:114),T{i}{1});
    find_name=cellfun(@(A) ~isempty(A),find_name);
    ctx_area(78+find(find_name))=str2num(T{i}{3});
end


% % % [ctx_thickness]=...
% % %     cortical_measures_analisys_v2 (sub_dir,SUBJECT,ctx_labels,'thickness');
% % % 
for i=1:length(ctx_thickness)
    for j=1:length(ctx_thickness)
        mm_ctx_thickness(i,j)=(ctx_thickness(i))/...
            (ctx_thickness(j));
    
        mm_ctx_thickness_sim(i,j)=1./((ctx_thickness(i)./ctx_thickness(j)+ctx_thickness(j)./ctx_thickness(i))/2);
    end
end
% % % 
% % % 
% % % [ctx_volume]=...
% % %     cortical_measures_analisys_v2 (sub_dir,SUBJECT,ctx_labels,'volume');
% % % 
for i=1:length(ctx_volume)
    for j=1:length(ctx_volume)
        mm_ctx_volume(i,j)=(ctx_volume(i))/...
            (ctx_volume(j));
            
        mm_ctx_volume_sim(i,j)=1./((ctx_volume(i)./ctx_volume(j)+ctx_volume(j)./ctx_volume(i))/2);
    end
end
% % % 
% % % 
% % % [ctx_area]=...
% % %     cortical_measures_analisys_v2 (sub_dir,SUBJECT,ctx_labels,'area');
% % % 
for i=1:length(ctx_area)
    for j=1:length(ctx_area)
        mm_ctx_area(i,j)=(ctx_area(i))/...
            (ctx_area(j));
    
        mm_ctx_area_sim(i,j)=1./((ctx_area(i)./ctx_area(j)+ctx_area(j)./ctx_area(i))/2);
    end
end





% % % all_regions=cell2mat(ctx_labels(:,1));
% % % sel_labels=ones(1,length(ctx_labels));
% % % all_volume=zeros(length(sel_labels),1);
% % % 
% % % if ~exist([out_sMRI,'aparc+aseg.nii'])
% % %             gunzip([out_sMRI,'aparc+aseg.nii','.gz'])
% % % end
% % % label_img= load_untouch_nii([out_sMRI,'aparc+aseg.nii']);
% % % vox_dim=label_img.hdr.dime.pixdim(2:4);
% % % label_img=label_img.img;
% % % regions2analy=unique(label_img(~isnan(label_img)));    
% % % for i=1:length(regions2analy)
% % %     iter_region=find(regions2analy(i)==all_regions,1);
% % %     if ~isempty(iter_region)
% % %         roi_label=ctx_labels{iter_region,1};
% % %         ROI=label_img==roi_label;
% % %         all_volume(iter_region)=sum(ROI(:));
% % %     end
% % % end
% % % all_volume=all_volume.*prod(vox_dim);
% % % ctx_volume(2:42)=all_volume(2:42);

v_ctx_thickness.('run1')=ctx_thickness;
v_ctx_area.('run1')=ctx_area;
v_ctx_volume.('run1')=ctx_volume;
% % % m_ctx_thickness.('run1')=mm_ctx_thickness;
% % % m_ctx_area.('run1')=mm_ctx_area;
% % % m_ctx_volume.('run1')=mm_ctx_volume;

m_ctx_thickness_sim.('run1')=mm_ctx_thickness_sim;
m_ctx_area_sim.('run1')=mm_ctx_area_sim;
m_ctx_volume_sim.('run1')=mm_ctx_volume_sim;
m_ctx_tav_sim.('run1')=mm_ctx_thickness_sim.*mm_ctx_area_sim.*mm_ctx_volume_sim;

m_ctx_thickness_sim_thres.('run1')=mm_ctx_thickness_sim>0.995;
m_ctx_area_sim_thres.('run1')=mm_ctx_area_sim>0.9987;
m_ctx_volume_sim_thres.('run1')=mm_ctx_volume_sim>0.995;
m_ctx_tav_sim_thres.('run1')=m_ctx_thickness_sim_thres.('run1').*m_ctx_area_sim_thres.('run1').*m_ctx_volume_sim_thres.('run1');

% % % v_all_volume.('run1')=all_volume;
save([out_sMRI,SUBJECT,'_smri_data.mat'],'v_ctx_thickness','m_ctx_thickness_sim','v_ctx_volume','m_ctx_volume_sim','v_ctx_area','m_ctx_area_sim','m_ctx_tav_sim',...
    'm_ctx_thickness_sim_thres','m_ctx_area_sim_thres','m_ctx_volume_sim_thres','m_ctx_tav_sim_thres');
% save([out_sMRI,SUBJECT,'_smri_data.mat'],'v_ctx_thickness','m_ctx_thickness','v_ctx_volume','m_ctx_volume','v_ctx_area','m_ctx_area','v_all_volume');

return
